=== modified file 'drizzled/common.h'
--- drizzled/common.h	2010-03-01 01:31:21 +0000
+++ drizzled/common.h	2010-03-02 07:09:16 +0000
@@ -55,7 +55,6 @@
 #define SELECT_NO_JOIN_CACHE    (UINT64_C(1) << 7)     // intern
 #define OPTION_BIG_TABLES       (UINT64_C(1) << 8)     // THD, user
 #define OPTION_BIG_SELECTS      (UINT64_C(1) << 9)     // THD, user
-#define OPTION_LOG_OFF          (UINT64_C(1) << 10)    // THD, user
 #define TMP_TABLE_ALL_COLUMNS   (UINT64_C(1) << 12)    // SELECT, intern
 #define OPTION_WARNINGS         (UINT64_C(1) << 13)    // THD, user
 #define OPTION_AUTO_IS_NULL     (UINT64_C(1) << 14)    // THD, user, binlog
@@ -74,18 +73,10 @@
    key checks in some cases */
 #define OPTION_RELAXED_UNIQUE_CHECKS    (UINT64_C(1) << 27) // THD, user, binlog
 #define SELECT_NO_UNLOCK                (UINT64_C(1) << 28) // SELECT, intern
-#define OPTION_SCHEMA_TABLE             (UINT64_C(1) << 29) // SELECT, intern
 /** Flag set if setup_tables already done */
 #define OPTION_SETUP_TABLES_DONE        (UINT64_C(1) << 30) // intern
 /** If not set then the thread will ignore all warnings with level notes. */
 #define OPTION_SQL_NOTES                (UINT64_C(1) << 31) // THD, user
-#define OPTION_PROFILING                (UINT64_C(1) << 33)
-
-/*
-  Dont report errors for individual rows,
-  But just report error on commit (or read ofcourse)
-*/
-#define OPTION_ALLOW_BATCH              (UINT64_C(1) << 33) // THD, intern (slave)
 
 /**
   Maximum length of time zone name that we support
@@ -104,13 +95,6 @@
 #define SQLSTATE_LENGTH 5
 
 /*
-  Maximum length of comments
-*/
-#define TABLE_COMMENT_MAXLEN 2048
-#define COLUMN_COMMENT_MAXLEN 1024
-#define INDEX_COMMENT_MAXLEN 1024
-
-/*
   USER_HOST_BUFF_SIZE -- length of string buffer, that is enough to contain
   username and hostname parts of the user identifier with trailing zero in
   MySQL standard format:
@@ -118,8 +102,6 @@
 */
 #define USER_HOST_BUFF_SIZE HOSTNAME_LENGTH + USERNAME_LENGTH + 2
 
-#define LOCAL_HOST	"localhost"
-
 /*
   You should add new commands to the end of this list, otherwise old
   servers won't be able to handle them as 'unsupported'.
@@ -144,54 +126,21 @@
 #define ENUM_FLAG	256		/* field is an enum */
 #define AUTO_INCREMENT_FLAG 512		/* field is a autoincrement field */
 #define TIMESTAMP_FLAG	1024		/* Field is a timestamp */
-#define SET_FLAG	2048		/* field is a set */
 #define NO_DEFAULT_VALUE_FLAG 4096	/* Field doesn't have default value */
 #define ON_UPDATE_NOW_FLAG 8192         /* Field is set to NOW on UPDATE */
-#define NUM_FLAG	32768		/* Field is num (for clients) */
 #define PART_KEY_FLAG	16384		/* Intern; Part of some key */
 #define GROUP_FLAG	32768		/* Intern: Group field */
 #define UNIQUE_FLAG	65536		/* Intern: Used by sql_yacc */
 #define BINCMP_FLAG	131072		/* Intern: Used by sql_yacc */
-#define GET_FIXED_FIELDS_FLAG (1 << 18) /* Used to get fields in item tree */
-#define FIELD_IN_PART_FUNC_FLAG (1 << 19)/* Field part of partition func */
-#define FIELD_IN_ADD_INDEX (1<< 20)	/* Intern: Field used in ADD INDEX */
-#define FIELD_IS_RENAMED (1<< 21)       /* Intern: Field is being renamed */
-#define FIELD_STORAGE_FLAGS 22          /* Storage type: bit 22, 23 and 24 */
 #define COLUMN_FORMAT_FLAGS 25          /* Column format: bit 25, 26 and 27 */
 #define COLUMN_FORMAT_MASK 7
 
-#define REFRESH_LOG		2	/* Start on new log file */
-#define REFRESH_TABLES		4	/* close all tables */
-#define REFRESH_STATUS		16	/* Flush status variables */
-
-/* The following can't be set with mysql_refresh() */
-#define REFRESH_READ_LOCK	16384	/* Lock tables for read */
-#define REFRESH_FAST		32768	/* Intern flag */
-
 #define SERVER_STATUS_IN_TRANS     1	/* Transaction has started */
 #define SERVER_STATUS_AUTOCOMMIT   2	/* Server in auto_commit mode */
 #define SERVER_MORE_RESULTS_EXISTS 8    /* Multi query - next query exists */
 #define SERVER_QUERY_NO_GOOD_INDEX_USED 16
 #define SERVER_QUERY_NO_INDEX_USED      32
-/*
-  The server was able to fulfill the clients request and opened a
-  read-only non-scrollable cursor for a query. This flag comes
-  in reply to COM_STMT_EXECUTE and COM_STMT_FETCH commands.
-*/
-#define SERVER_STATUS_CURSOR_EXISTS 64
-/*
-  This flag is sent when a read-only cursor is exhausted, in reply to
-  COM_STMT_FETCH command.
-*/
-#define SERVER_STATUS_LAST_ROW_SENT 128
 #define SERVER_STATUS_DB_DROPPED        256 /* A database was dropped */
-#define SERVER_STATUS_NO_BACKSLASH_ESCAPES 512
-/*
-  Tell clients that this query was logged to the slow query log.
-  Not yet set in the server, but interface is defined for applications
-  to use.  See WorkLog 4098.
-*/
-#define SERVER_QUERY_WAS_SLOW           1024
 
 #define DRIZZLE_ERRMSG_SIZE	512
 
@@ -199,7 +148,6 @@
 
 #define MAX_INT_WIDTH           10      /* Max width for a LONG w.o. sign */
 #define MAX_BIGINT_WIDTH        20      /* Max width for a LONGLONG */
-#define MAX_CHAR_WIDTH		255	/* Max length for a CHAR colum */
 #define MAX_BLOB_WIDTH		(uint32_t)16777216	/* Default width for blob */
 
 #define DRIZZLE_PROTOCOL_NO_MORE_DATA 0xFE
@@ -209,15 +157,6 @@
 
 #define packet_error (~(uint32_t) 0)
 
-
-/* Shutdown/kill enums and constants */
-
-/* Bits for THD::killable. */
-#define DRIZZLE_SHUTDOWN_KILLABLE_CONNECT    (unsigned char)(1 << 0)
-#define DRIZZLE_SHUTDOWN_KILLABLE_TRANS      (unsigned char)(1 << 1)
-#define DRIZZLE_SHUTDOWN_KILLABLE_LOCK_TABLE (unsigned char)(1 << 2)
-#define DRIZZLE_SHUTDOWN_KILLABLE_UPDATE     (unsigned char)(1 << 3)
-
 #if defined(__cplusplus)
 
 namespace drizzled
@@ -252,12 +191,6 @@
                         DRIZZLE_TYPE_MAX=DRIZZLE_TYPE_BLOB
 };
 
-
-  /* The following is for user defined functions */
-
-enum Item_result {STRING_RESULT=0, REAL_RESULT, INT_RESULT, ROW_RESULT,
-                  DECIMAL_RESULT};
-
 } /* namespace drizzled */
 
 #endif /* defined(__cplusplus) */

=== modified file 'drizzled/create_field.cc'
--- drizzled/create_field.cc	2010-02-04 08:14:46 +0000
+++ drizzled/create_field.cc	2010-03-02 06:45:16 +0000
@@ -87,7 +87,7 @@
       break;
   }
 
-  if (flags & (ENUM_FLAG | SET_FLAG))
+  if (flags & ENUM_FLAG)
     interval= ((Field_enum*) old_field)->typelib;
   else
     interval= 0;

=== modified file 'drizzled/cursor.cc'
--- drizzled/cursor.cc	2010-02-23 18:09:22 +0000
+++ drizzled/cursor.cc	2010-02-27 23:47:33 +0000
@@ -1353,6 +1353,18 @@
 
   switch (session->lex->sql_command)
   {
+  case SQLCOM_CREATE_TABLE:
+    /*
+     * We are in a CREATE TABLE ... SELECT statement
+     * and the kernel has already created the table
+     * and put a CreateTableStatement in the active
+     * Transaction message.  Here, we add a new InsertRecord
+     * to a new Transaction message (because the above
+     * CREATE TABLE will commit the transaction containing
+     * it).
+     */
+    result= replication_services.insertRecord(session, table);
+    break;
   case SQLCOM_REPLACE:
   case SQLCOM_REPLACE_SELECT:
     /*

=== modified file 'drizzled/db.cc'
--- drizzled/db.cc	2010-03-01 23:42:31 +0000
+++ drizzled/db.cc	2010-03-03 04:58:12 +0000
@@ -129,7 +129,7 @@
   }
   else // Created !
   {
-    replication_services.rawStatement(session, session->query);
+    replication_services.createSchema(session, schema_message);
     session->my_ok(1);
   }
 
@@ -275,7 +275,7 @@
     assert(! session->query.empty());
 
     ReplicationServices &replication_services= ReplicationServices::singleton();
-    replication_services.rawStatement(session, session->getQueryString());
+    replication_services.dropSchema(session, schema_name);
     session->clear_error();
     session->server_status|= SERVER_STATUS_DB_DROPPED;
     session->my_ok((uint32_t) deleted);
@@ -410,7 +410,7 @@
       }
     }
 
-    TableIdentifier identifier(db, table->table_name, table->internal_tmp_table ? INTERNAL_TMP_TABLE : NO_TMP_TABLE);
+    TableIdentifier identifier(db, table->table_name);
 
     if (table_type == NULL && not plugin::StorageEngine::doesTableExist(*session, identifier))
     {
@@ -454,7 +454,7 @@
   error= 0;
   if (wrong_tables.length())
   {
-    if (!foreign_key_error)
+    if (not foreign_key_error)
       my_printf_error(ER_BAD_TABLE_ERROR, ER(ER_BAD_TABLE_ERROR), MYF(0),
                       wrong_tables.c_ptr());
     else

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2010-03-03 20:21:57 +0000
+++ drizzled/drizzled.cc	2010-03-04 14:42:39 +0000
@@ -1120,7 +1120,7 @@
     strncpy(system_time_zone, tzname[tm_tmp.tm_isdst != 0 ? 1 : 0],
             sizeof(system_time_zone)-1);
 
- }
+  }
   /*
     We set SYSTEM time zone as reasonable default and
     also for failure of my_tz_init() and bootstrap mode.
@@ -1132,8 +1132,8 @@
   if (gethostname(glob_hostname,sizeof(glob_hostname)) < 0)
   {
     strncpy(glob_hostname, STRING_WITH_LEN("localhost"));
-      errmsg_printf(ERRMSG_LVL_WARN, _("gethostname failed, using '%s' as hostname"),
-                      glob_hostname);
+    errmsg_printf(ERRMSG_LVL_WARN, _("gethostname failed, using '%s' as hostname"),
+                  glob_hostname);
     strncpy(pidfile_name, STRING_WITH_LEN("drizzle"));
   }
   else
@@ -1196,14 +1196,14 @@
   global_system_variables.collation_server=	 default_charset_info;
 
   if (not (character_set_filesystem=
-        get_charset_by_csname(character_set_filesystem_name, MY_CS_PRIMARY)))
+           get_charset_by_csname(character_set_filesystem_name, MY_CS_PRIMARY)))
     return 1;
   global_system_variables.character_set_filesystem= character_set_filesystem;
 
   if (!(my_default_lc_time_names=
         my_locale_by_name(lc_time_names_name)))
   {
-      errmsg_printf(ERRMSG_LVL_ERROR, _("Unknown locale: '%s'"), lc_time_names_name);
+    errmsg_printf(ERRMSG_LVL_ERROR, _("Unknown locale: '%s'"), lc_time_names_name);
     return 1;
   }
   global_system_variables.lc_time_names= my_default_lc_time_names;

=== modified file 'drizzled/enum.h'
--- drizzled/enum.h	2010-02-26 08:21:58 +0000
+++ drizzled/enum.h	2010-03-02 22:39:09 +0000
@@ -216,7 +216,7 @@
 
 enum tmp_table_type
 {
-  NO_TMP_TABLE,
+  STANDARD_TABLE,
   TEMP_TABLE,
   INTERNAL_TMP_TABLE,
   SYSTEM_TMP_TABLE

=== modified file 'drizzled/field.cc'
--- drizzled/field.cc	2010-02-26 08:21:58 +0000
+++ drizzled/field.cc	2010-03-02 06:45:16 +0000
@@ -821,7 +821,7 @@
   tmp->part_of_key.reset();
   tmp->part_of_sortkey.reset();
   tmp->unireg_check= Field::NONE;
-  tmp->flags&= (NOT_NULL_FLAG | BLOB_FLAG | UNSIGNED_FLAG | BINARY_FLAG | ENUM_FLAG | SET_FLAG);
+  tmp->flags&= (NOT_NULL_FLAG | BLOB_FLAG | UNSIGNED_FLAG | BINARY_FLAG | ENUM_FLAG);
   tmp->reset_fields();
   return tmp;
 }

=== modified file 'drizzled/field.h'
--- drizzled/field.h	2010-02-26 08:21:58 +0000
+++ drizzled/field.h	2010-03-02 06:41:59 +0000
@@ -32,6 +32,7 @@
 #include "drizzled/sql_list.h"
 #include "drizzled/structs.h"
 #include "drizzled/charset_info.h"
+#include "drizzled/item_result.h"
 
 #include <string>
 #include <vector>

=== modified file 'drizzled/hybrid_type_traits.h'
--- drizzled/hybrid_type_traits.h	2010-02-04 08:14:46 +0000
+++ drizzled/hybrid_type_traits.h	2010-03-02 06:41:59 +0000
@@ -21,6 +21,7 @@
 #define DRIZZLED_HYBRID_TYPE_TRAITS_H
 
 #include "drizzled/common.h"
+#include "drizzled/item_result.h"
 
 namespace drizzled
 {

=== modified file 'drizzled/include.am'
--- drizzled/include.am	2010-03-03 20:21:57 +0000
+++ drizzled/include.am	2010-03-04 14:42:39 +0000
@@ -203,6 +203,7 @@
 			      drizzled/index_hint.h \
 			      drizzled/internal_error_handler.h \
 			      drizzled/item.h \
+			      drizzled/item_result.h \
 			      drizzled/item/basic_constant.h \
 			      drizzled/item/bin_string.h \
 			      drizzled/item/blob.h \

=== modified file 'drizzled/item.h'
--- drizzled/item.h	2010-02-16 17:15:01 +0000
+++ drizzled/item.h	2010-03-02 06:41:59 +0000
@@ -27,6 +27,7 @@
 #include <drizzled/sql_list.h>
 #include "drizzled/memory/sql_alloc.h"
 #include <drizzled/table.h>
+#include "drizzled/item_result.h"
 
 namespace drizzled
 {
@@ -47,7 +48,6 @@
 class Client;
 }
 
-
 /**
   Dummy error processor used by default by Name_resolution_context.
 

=== added file 'drizzled/item_result.h'
--- drizzled/item_result.h	1970-01-01 00:00:00 +0000
+++ drizzled/item_result.h	2010-03-02 06:41:59 +0000
@@ -0,0 +1,34 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *  Copyright (C) 2010 Stewart Smith
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_ITEM_RESULT_H
+#define DRIZZLED_ITEM_RESULT_H
+
+enum Item_result
+{
+  STRING_RESULT=0,
+  REAL_RESULT,
+  INT_RESULT,
+  ROW_RESULT,
+  DECIMAL_RESULT
+};
+
+
+#endif /* DRIZZLED_ITEM_RESULT_H */

=== modified file 'drizzled/join.cc'
--- drizzled/join.cc	2010-02-11 20:01:37 +0000
+++ drizzled/join.cc	2010-02-27 23:47:33 +0000
@@ -337,6 +337,12 @@
   if (error)
     goto err;
 
+  /* 
+   * The below will create the new table for
+   * CREATE TABLE ... SELECT
+   *
+   * @see create_table_from_items() in drizzled/sql_insert.cc
+   */
   if (result && result->prepare(fields_list, unit_arg))
     goto err;
 

=== modified file 'drizzled/message/statement_transform.cc'
--- drizzled/message/statement_transform.cc	2010-02-08 01:10:03 +0000
+++ drizzled/message/statement_transform.cc	2010-03-02 20:56:33 +0000
@@ -2,10 +2,11 @@
  *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
  *
  *  Copyright (C) 2009 Sun Microsystems
+ *  Copyright (c) 2010 Jay Pipes
  *
  *  Authors:
  *
- *    Jay Pipes <joinfu@sun.com>
+ *    Jay Pipes <jaypipes@gmail.com>
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -36,23 +37,27 @@
 
 #include <string>
 #include <vector>
+#include <sstream>
 
 using namespace std;
 
 namespace drizzled
 {
 
-enum message::TransformSqlError
-message::transformStatementToSql(const message::Statement &source,
-                                 vector<string> &sql_strings,
-                                 enum message::TransformSqlVariant sql_variant,
-                                 bool already_in_transaction)
-{
-  message::TransformSqlError error= NONE;
+namespace message
+{
+
+enum TransformSqlError
+transformStatementToSql(const Statement &source,
+                        vector<string> &sql_strings,
+                        enum TransformSqlVariant sql_variant,
+                        bool already_in_transaction)
+{
+  TransformSqlError error= NONE;
 
   switch (source.type())
   {
-  case message::Statement::INSERT:
+  case Statement::INSERT:
     {
       if (! source.has_insert_header())
       {
@@ -65,8 +70,8 @@
         return error;
       }
 
-      const message::InsertHeader &insert_header= source.insert_header();
-      const message::InsertData &insert_data= source.insert_data();
+      const InsertHeader &insert_header= source.insert_header();
+      const InsertData &insert_data= source.insert_data();
       size_t num_keys= insert_data.record_size();
       size_t x;
 
@@ -79,7 +84,7 @@
 
         error= transformInsertRecordToSql(insert_header,
                                           insert_data.record(x),
-                                          &destination,
+                                          destination,
                                           sql_variant);
         if (error != NONE)
           break;
@@ -96,7 +101,7 @@
       }
     }
     break;
-  case message::Statement::UPDATE:
+  case Statement::UPDATE:
     {
       if (! source.has_update_header())
       {
@@ -109,8 +114,8 @@
         return error;
       }
 
-      const message::UpdateHeader &update_header= source.update_header();
-      const message::UpdateData &update_data= source.update_data();
+      const UpdateHeader &update_header= source.update_header();
+      const UpdateData &update_data= source.update_data();
       size_t num_keys= update_data.record_size();
       size_t x;
 
@@ -123,7 +128,7 @@
 
         error= transformUpdateRecordToSql(update_header,
                                           update_data.record(x),
-                                          &destination,
+                                          destination,
                                           sql_variant);
         if (error != NONE)
           break;
@@ -140,7 +145,7 @@
       }
     }
     break;
-  case message::Statement::DELETE:
+  case Statement::DELETE:
     {
       if (! source.has_delete_header())
       {
@@ -153,8 +158,8 @@
         return error;
       }
 
-      const message::DeleteHeader &delete_header= source.delete_header();
-      const message::DeleteData &delete_data= source.delete_data();
+      const DeleteHeader &delete_header= source.delete_header();
+      const DeleteData &delete_data= source.delete_data();
       size_t num_keys= delete_data.record_size();
       size_t x;
 
@@ -167,7 +172,7 @@
 
         error= transformDeleteRecordToSql(delete_header,
                                           delete_data.record(x),
-                                          &destination,
+                                          destination,
                                           sql_variant);
         if (error != NONE)
           break;
@@ -184,27 +189,67 @@
       }
     }
     break;
-  case message::Statement::TRUNCATE_TABLE:
+  case Statement::CREATE_TABLE:
+    {
+      assert(source.has_create_table_statement());
+      string destination;
+      error= transformCreateTableStatementToSql(source.create_table_statement(),
+                                                destination,
+                                                sql_variant);
+      sql_strings.push_back(destination);
+    }
+    break;
+  case Statement::TRUNCATE_TABLE:
     {
       assert(source.has_truncate_table_statement());
       string destination;
-      error= message::transformTruncateTableStatementToSql(source.truncate_table_statement(),
-                                                           &destination,
-                                                           sql_variant);
-      sql_strings.push_back(destination);
-    }
-    break;
-  case message::Statement::SET_VARIABLE:
+      error= transformTruncateTableStatementToSql(source.truncate_table_statement(),
+                                                  destination,
+                                                  sql_variant);
+      sql_strings.push_back(destination);
+    }
+    break;
+  case Statement::DROP_TABLE:
+    {
+      assert(source.has_drop_table_statement());
+      string destination;
+      error= transformDropTableStatementToSql(source.drop_table_statement(),
+                                              destination,
+                                              sql_variant);
+      sql_strings.push_back(destination);
+    }
+    break;
+  case Statement::CREATE_SCHEMA:
+    {
+      assert(source.has_create_schema_statement());
+      string destination;
+      error= transformCreateSchemaStatementToSql(source.create_schema_statement(),
+                                                 destination,
+                                                 sql_variant);
+      sql_strings.push_back(destination);
+    }
+    break;
+  case Statement::DROP_SCHEMA:
+    {
+      assert(source.has_drop_schema_statement());
+      string destination;
+      error= transformDropSchemaStatementToSql(source.drop_schema_statement(),
+                                               destination,
+                                               sql_variant);
+      sql_strings.push_back(destination);
+    }
+    break;
+  case Statement::SET_VARIABLE:
     {
       assert(source.has_set_variable_statement());
       string destination;
-      error= message::transformSetVariableStatementToSql(source.set_variable_statement(),
-                                                       &destination,
-                                                       sql_variant);
+      error= transformSetVariableStatementToSql(source.set_variable_statement(),
+                                                destination,
+                                                sql_variant);
       sql_strings.push_back(destination);
     }
     break;
-  case message::Statement::RAW_SQL:
+  case Statement::RAW_SQL:
   default:
     sql_strings.push_back(source.sql());
     break;
@@ -212,24 +257,24 @@
   return error;
 }
 
-enum message::TransformSqlError
-message::transformInsertHeaderToSql(const message::InsertHeader &header,
-                                    std::string *destination,
-                                    enum message::TransformSqlVariant sql_variant)
+enum TransformSqlError
+transformInsertHeaderToSql(const InsertHeader &header,
+                           string &destination,
+                           enum TransformSqlVariant sql_variant)
 {
   char quoted_identifier= '`';
   if (sql_variant == ANSI)
     quoted_identifier= '"';
 
-  destination->assign("INSERT INTO ", 12);
-  destination->push_back(quoted_identifier);
-  destination->append(header.table_metadata().schema_name());
-  destination->push_back(quoted_identifier);
-  destination->push_back('.');
-  destination->push_back(quoted_identifier);
-  destination->append(header.table_metadata().table_name());
-  destination->push_back(quoted_identifier);
-  destination->append(" (", 2);
+  destination.assign("INSERT INTO ", 12);
+  destination.push_back(quoted_identifier);
+  destination.append(header.table_metadata().schema_name());
+  destination.push_back(quoted_identifier);
+  destination.push_back('.');
+  destination.push_back(quoted_identifier);
+  destination.append(header.table_metadata().table_name());
+  destination.push_back(quoted_identifier);
+  destination.append(" (", 2);
 
   /* Add field list to SQL string... */
   size_t num_fields= header.field_metadata_size();
@@ -237,33 +282,33 @@
 
   for (x= 0; x < num_fields; ++x)
   {
-    const message::FieldMetadata &field_metadata= header.field_metadata(x);
+    const FieldMetadata &field_metadata= header.field_metadata(x);
     if (x != 0)
-      destination->push_back(',');
+      destination.push_back(',');
     
-    destination->push_back(quoted_identifier);
-    destination->append(field_metadata.name());
-    destination->push_back(quoted_identifier);
+    destination.push_back(quoted_identifier);
+    destination.append(field_metadata.name());
+    destination.push_back(quoted_identifier);
   }
 
   return NONE;
 }
 
-enum message::TransformSqlError
-message::transformInsertRecordToSql(const message::InsertHeader &header,
-                                    const message::InsertRecord &record,
-                                    std::string *destination,
-                                    enum message::TransformSqlVariant sql_variant)
+enum TransformSqlError
+transformInsertRecordToSql(const InsertHeader &header,
+                           const InsertRecord &record,
+                           string &destination,
+                           enum TransformSqlVariant sql_variant)
 {
-  enum message::TransformSqlError error= transformInsertHeaderToSql(header,
-                                                                    destination,
-                                                                    sql_variant);
+  enum TransformSqlError error= transformInsertHeaderToSql(header,
+                                                           destination,
+                                                           sql_variant);
 
   char quoted_identifier= '`';
   if (sql_variant == ANSI)
     quoted_identifier= '"';
 
-  destination->append(") VALUES (");
+  destination.append(") VALUES (");
 
   /* Add insert values */
   size_t num_fields= header.field_metadata_size();
@@ -273,16 +318,16 @@
   for (x= 0; x < num_fields; ++x)
   {
     if (x != 0)
-      destination->push_back(',');
-
-    const message::FieldMetadata &field_metadata= header.field_metadata(x);
-
-    should_quote_field_value= message::shouldQuoteFieldValue(field_metadata.type());
+      destination.push_back(',');
+
+    const FieldMetadata &field_metadata= header.field_metadata(x);
+
+    should_quote_field_value= shouldQuoteFieldValue(field_metadata.type());
 
     if (should_quote_field_value)
-      destination->push_back('\'');
+      destination.push_back('\'');
 
-    if (field_metadata.type() == message::Table::Field::BLOB)
+    if (field_metadata.type() == Table::Field::BLOB)
     {
       /* 
         * We do this here because BLOB data is returned
@@ -291,36 +336,36 @@
         * up to a \0 being output here.
         */
       string raw_data(record.insert_value(x));
-      destination->append(raw_data.c_str(), raw_data.size());
+      destination.append(raw_data.c_str(), raw_data.size());
     }
     else
     {
-      destination->append(record.insert_value(x));
+      destination.append(record.insert_value(x));
     }
 
     if (should_quote_field_value)
-      destination->push_back('\'');
+      destination.push_back('\'');
   }
-  destination->push_back(')');
+  destination.push_back(')');
 
   return error;
 }
 
-enum message::TransformSqlError
-message::transformInsertStatementToSql(const message::InsertHeader &header,
-                                       const message::InsertData &data,
-                                       std::string *destination,
-                                       enum message::TransformSqlVariant sql_variant)
+enum TransformSqlError
+transformInsertStatementToSql(const InsertHeader &header,
+                              const InsertData &data,
+                              string &destination,
+                              enum TransformSqlVariant sql_variant)
 {
-  enum message::TransformSqlError error= transformInsertHeaderToSql(header,
-                                                                    destination,
-                                                                    sql_variant);
+  enum TransformSqlError error= transformInsertHeaderToSql(header,
+                                                           destination,
+                                                           sql_variant);
 
   char quoted_identifier= '`';
   if (sql_variant == ANSI)
     quoted_identifier= '"';
 
-  destination->append(") VALUES (", 10);
+  destination.append(") VALUES (", 10);
 
   /* Add insert values */
   size_t num_records= data.record_size();
@@ -331,21 +376,21 @@
   for (x= 0; x < num_records; ++x)
   {
     if (x != 0)
-      destination->append("),(", 3);
+      destination.append("),(", 3);
 
     for (y= 0; y < num_fields; ++y)
     {
       if (y != 0)
-        destination->push_back(',');
+        destination.push_back(',');
 
-      const message::FieldMetadata &field_metadata= header.field_metadata(y);
+      const FieldMetadata &field_metadata= header.field_metadata(y);
       
-      should_quote_field_value= message::shouldQuoteFieldValue(field_metadata.type());
+      should_quote_field_value= shouldQuoteFieldValue(field_metadata.type());
 
       if (should_quote_field_value)
-        destination->push_back('\'');
+        destination.push_back('\'');
 
-      if (field_metadata.type() == message::Table::Field::BLOB)
+      if (field_metadata.type() == Table::Field::BLOB)
       {
         /* 
          * We do this here because BLOB data is returned
@@ -354,53 +399,53 @@
          * up to a \0 being output here.
          */
         string raw_data(data.record(x).insert_value(y));
-        destination->append(raw_data.c_str(), raw_data.size());
+        destination.append(raw_data.c_str(), raw_data.size());
       }
       else
       {
-        destination->append(data.record(x).insert_value(y));
+        destination.append(data.record(x).insert_value(y));
       }
 
       if (should_quote_field_value)
-        destination->push_back('\'');
+        destination.push_back('\'');
     }
   }
-  destination->push_back(')');
+  destination.push_back(')');
 
   return error;
 }
 
-enum message::TransformSqlError
-message::transformUpdateHeaderToSql(const message::UpdateHeader &header,
-                                    std::string *destination,
-                                    enum message::TransformSqlVariant sql_variant)
+enum TransformSqlError
+transformUpdateHeaderToSql(const UpdateHeader &header,
+                           string &destination,
+                           enum TransformSqlVariant sql_variant)
 {
   char quoted_identifier= '`';
   if (sql_variant == ANSI)
     quoted_identifier= '"';
 
-  destination->assign("UPDATE ", 7);
-  destination->push_back(quoted_identifier);
-  destination->append(header.table_metadata().schema_name());
-  destination->push_back(quoted_identifier);
-  destination->push_back('.');
-  destination->push_back(quoted_identifier);
-  destination->append(header.table_metadata().table_name());
-  destination->push_back(quoted_identifier);
-  destination->append(" SET ", 5);
+  destination.assign("UPDATE ", 7);
+  destination.push_back(quoted_identifier);
+  destination.append(header.table_metadata().schema_name());
+  destination.push_back(quoted_identifier);
+  destination.push_back('.');
+  destination.push_back(quoted_identifier);
+  destination.append(header.table_metadata().table_name());
+  destination.push_back(quoted_identifier);
+  destination.append(" SET ", 5);
 
   return NONE;
 }
 
-enum message::TransformSqlError
-message::transformUpdateRecordToSql(const message::UpdateHeader &header,
-                                    const message::UpdateRecord &record,
-                                    std::string *destination,
-                                    enum message::TransformSqlVariant sql_variant)
+enum TransformSqlError
+transformUpdateRecordToSql(const UpdateHeader &header,
+                           const UpdateRecord &record,
+                           string &destination,
+                           enum TransformSqlVariant sql_variant)
 {
-  enum message::TransformSqlError error= transformUpdateHeaderToSql(header,
-                                                                    destination,
-                                                                    sql_variant);
+  enum TransformSqlError error= transformUpdateHeaderToSql(header,
+                                                           destination,
+                                                           sql_variant);
 
   char quoted_identifier= '`';
   if (sql_variant == ANSI)
@@ -413,21 +458,21 @@
 
   for (x= 0; x < num_set_fields; ++x)
   {
-    const message::FieldMetadata &field_metadata= header.set_field_metadata(x);
+    const FieldMetadata &field_metadata= header.set_field_metadata(x);
     if (x != 0)
-      destination->push_back(',');
+      destination.push_back(',');
     
-    destination->push_back(quoted_identifier);
-    destination->append(field_metadata.name());
-    destination->push_back(quoted_identifier);
-    destination->push_back('=');
+    destination.push_back(quoted_identifier);
+    destination.append(field_metadata.name());
+    destination.push_back(quoted_identifier);
+    destination.push_back('=');
 
-    should_quote_field_value= message::shouldQuoteFieldValue(field_metadata.type());
+    should_quote_field_value= shouldQuoteFieldValue(field_metadata.type());
 
     if (should_quote_field_value)
-      destination->push_back('\'');
+      destination.push_back('\'');
 
-    if (field_metadata.type() == message::Table::Field::BLOB)
+    if (field_metadata.type() == Table::Field::BLOB)
     {
       /* 
        * We do this here because BLOB data is returned
@@ -436,39 +481,39 @@
        * up to a \0 being output here.
        */
       string raw_data(record.after_value(x));
-      destination->append(raw_data.c_str(), raw_data.size());
+      destination.append(raw_data.c_str(), raw_data.size());
     }
     else
     {
-      destination->append(record.after_value(x));
+      destination.append(record.after_value(x));
     }
 
     if (should_quote_field_value)
-      destination->push_back('\'');
+      destination.push_back('\'');
   }
 
   size_t num_key_fields= header.key_field_metadata_size();
 
-  destination->append(" WHERE ", 7);
+  destination.append(" WHERE ", 7);
   for (x= 0; x < num_key_fields; ++x) 
   {
-    const message::FieldMetadata &field_metadata= header.key_field_metadata(x);
+    const FieldMetadata &field_metadata= header.key_field_metadata(x);
     
     if (x != 0)
-      destination->append(" AND ", 5); /* Always AND condition with a multi-column PK */
-
-    destination->push_back(quoted_identifier);
-    destination->append(field_metadata.name());
-    destination->push_back(quoted_identifier);
-
-    destination->push_back('=');
-
-    should_quote_field_value= message::shouldQuoteFieldValue(field_metadata.type());
+      destination.append(" AND ", 5); /* Always AND condition with a multi-column PK */
+
+    destination.push_back(quoted_identifier);
+    destination.append(field_metadata.name());
+    destination.push_back(quoted_identifier);
+
+    destination.push_back('=');
+
+    should_quote_field_value= shouldQuoteFieldValue(field_metadata.type());
 
     if (should_quote_field_value)
-      destination->push_back('\'');
+      destination.push_back('\'');
 
-    if (field_metadata.type() == message::Table::Field::BLOB)
+    if (field_metadata.type() == Table::Field::BLOB)
     {
       /* 
        * We do this here because BLOB data is returned
@@ -477,52 +522,50 @@
        * up to a \0 being output here.
        */
       string raw_data(record.key_value(x));
-      destination->append(raw_data.c_str(), raw_data.size());
+      destination.append(raw_data.c_str(), raw_data.size());
     }
     else
     {
-      destination->append(record.key_value(x));
+      destination.append(record.key_value(x));
     }
 
     if (should_quote_field_value)
-      destination->push_back('\'');
+      destination.push_back('\'');
   }
-  if (num_key_fields > 1)
-    destination->push_back(')');
 
   return error;
 }
 
-enum message::TransformSqlError
-message::transformDeleteHeaderToSql(const message::DeleteHeader &header,
-                                    std::string *destination,
-                                    enum message::TransformSqlVariant sql_variant)
+enum TransformSqlError
+transformDeleteHeaderToSql(const DeleteHeader &header,
+                           string &destination,
+                           enum TransformSqlVariant sql_variant)
 {
   char quoted_identifier= '`';
   if (sql_variant == ANSI)
     quoted_identifier= '"';
 
-  destination->assign("DELETE FROM ", 12);
-  destination->push_back(quoted_identifier);
-  destination->append(header.table_metadata().schema_name());
-  destination->push_back(quoted_identifier);
-  destination->push_back('.');
-  destination->push_back(quoted_identifier);
-  destination->append(header.table_metadata().table_name());
-  destination->push_back(quoted_identifier);
+  destination.assign("DELETE FROM ", 12);
+  destination.push_back(quoted_identifier);
+  destination.append(header.table_metadata().schema_name());
+  destination.push_back(quoted_identifier);
+  destination.push_back('.');
+  destination.push_back(quoted_identifier);
+  destination.append(header.table_metadata().table_name());
+  destination.push_back(quoted_identifier);
 
   return NONE;
 }
 
-enum message::TransformSqlError
-message::transformDeleteRecordToSql(const message::DeleteHeader &header,
-                                    const message::DeleteRecord &record,
-                                    std::string *destination,
-                                    enum message::TransformSqlVariant sql_variant)
+enum TransformSqlError
+transformDeleteRecordToSql(const DeleteHeader &header,
+                           const DeleteRecord &record,
+                           string &destination,
+                           enum TransformSqlVariant sql_variant)
 {
-  enum message::TransformSqlError error= transformDeleteHeaderToSql(header,
-                                                                    destination,
-                                                                    sql_variant);
+  enum TransformSqlError error= transformDeleteHeaderToSql(header,
+                                                           destination,
+                                                           sql_variant);
   char quoted_identifier= '`';
   if (sql_variant == ANSI)
     quoted_identifier= '"';
@@ -532,26 +575,26 @@
   uint32_t x;
   bool should_quote_field_value= false;
 
-  destination->append(" WHERE ", 7);
+  destination.append(" WHERE ", 7);
   for (x= 0; x < num_key_fields; ++x) 
   {
-    const message::FieldMetadata &field_metadata= header.key_field_metadata(x);
+    const FieldMetadata &field_metadata= header.key_field_metadata(x);
     
     if (x != 0)
-      destination->append(" AND ", 5); /* Always AND condition with a multi-column PK */
-
-    destination->push_back(quoted_identifier);
-    destination->append(field_metadata.name());
-    destination->push_back(quoted_identifier);
-
-    destination->push_back('=');
-
-    should_quote_field_value= message::shouldQuoteFieldValue(field_metadata.type());
+      destination.append(" AND ", 5); /* Always AND condition with a multi-column PK */
+
+    destination.push_back(quoted_identifier);
+    destination.append(field_metadata.name());
+    destination.push_back(quoted_identifier);
+
+    destination.push_back('=');
+
+    should_quote_field_value= shouldQuoteFieldValue(field_metadata.type());
 
     if (should_quote_field_value)
-      destination->push_back('\'');
+      destination.push_back('\'');
 
-    if (field_metadata.type() == message::Table::Field::BLOB)
+    if (field_metadata.type() == Table::Field::BLOB)
     {
       /* 
        * We do this here because BLOB data is returned
@@ -560,29 +603,29 @@
        * up to a \0 being output here.
        */
       string raw_data(record.key_value(x));
-      destination->append(raw_data.c_str(), raw_data.size());
+      destination.append(raw_data.c_str(), raw_data.size());
     }
     else
     {
-      destination->append(record.key_value(x));
+      destination.append(record.key_value(x));
     }
 
     if (should_quote_field_value)
-      destination->push_back('\'');
+      destination.push_back('\'');
   }
 
   return error;
 }
 
-enum message::TransformSqlError
-message::transformDeleteStatementToSql(const message::DeleteHeader &header,
-                                       const message::DeleteData &data,
-                                       std::string *destination,
-                                       enum message::TransformSqlVariant sql_variant)
+enum TransformSqlError
+transformDeleteStatementToSql(const DeleteHeader &header,
+                              const DeleteData &data,
+                              string &destination,
+                              enum TransformSqlVariant sql_variant)
 {
-  enum message::TransformSqlError error= transformDeleteHeaderToSql(header,
-                                                                    destination,
-                                                                    sql_variant);
+  enum TransformSqlError error= transformDeleteHeaderToSql(header,
+                                                           destination,
+                                                           sql_variant);
   char quoted_identifier= '`';
   if (sql_variant == ANSI)
     quoted_identifier= '"';
@@ -593,34 +636,34 @@
   uint32_t x, y;
   bool should_quote_field_value= false;
 
-  destination->append(" WHERE ", 7);
+  destination.append(" WHERE ", 7);
   for (x= 0; x < num_key_records; ++x)
   {
     if (x != 0)
-      destination->append(" OR ", 4); /* Always OR condition for multiple key records */
+      destination.append(" OR ", 4); /* Always OR condition for multiple key records */
 
     if (num_key_fields > 1)
-      destination->push_back('(');
+      destination.push_back('(');
 
     for (y= 0; y < num_key_fields; ++y) 
     {
-      const message::FieldMetadata &field_metadata= header.key_field_metadata(y);
+      const FieldMetadata &field_metadata= header.key_field_metadata(y);
       
       if (y != 0)
-        destination->append(" AND ", 5); /* Always AND condition with a multi-column PK */
-
-      destination->push_back(quoted_identifier);
-      destination->append(field_metadata.name());
-      destination->push_back(quoted_identifier);
-
-      destination->push_back('=');
-
-      should_quote_field_value= message::shouldQuoteFieldValue(field_metadata.type());
+        destination.append(" AND ", 5); /* Always AND condition with a multi-column PK */
+
+      destination.push_back(quoted_identifier);
+      destination.append(field_metadata.name());
+      destination.push_back(quoted_identifier);
+
+      destination.push_back('=');
+
+      should_quote_field_value= shouldQuoteFieldValue(field_metadata.type());
 
       if (should_quote_field_value)
-        destination->push_back('\'');
+        destination.push_back('\'');
 
-      if (field_metadata.type() == message::Table::Field::BLOB)
+      if (field_metadata.type() == Table::Field::BLOB)
       {
         /* 
          * We do this here because BLOB data is returned
@@ -629,114 +672,607 @@
          * up to a \0 being output here.
          */
         string raw_data(data.record(x).key_value(y));
-        destination->append(raw_data.c_str(), raw_data.size());
+        destination.append(raw_data.c_str(), raw_data.size());
       }
       else
       {
-        destination->append(data.record(x).key_value(y));
+        destination.append(data.record(x).key_value(y));
       }
 
       if (should_quote_field_value)
-        destination->push_back('\'');
+        destination.push_back('\'');
     }
     if (num_key_fields > 1)
-      destination->push_back(')');
+      destination.push_back(')');
   }
   return error;
 }
 
-enum message::TransformSqlError
-message::transformTruncateTableStatementToSql(const message::TruncateTableStatement &statement,
-                                              std::string *destination,
-                                              enum message::TransformSqlVariant sql_variant)
-{
-  char quoted_identifier= '`';
-  if (sql_variant == ANSI)
-    quoted_identifier= '"';
-
-  const message::TableMetadata &table_metadata= statement.table_metadata();
-
-  destination->append("TRUNCATE TABLE ", 15);
-  destination->push_back(quoted_identifier);
-  destination->append(table_metadata.schema_name());
-  destination->push_back(quoted_identifier);
-  destination->push_back('.');
-  destination->push_back(quoted_identifier);
-  destination->append(table_metadata.table_name());
-  destination->push_back(quoted_identifier);
-
-  return NONE;
-}
-
-enum message::TransformSqlError
-message::transformSetVariableStatementToSql(const message::SetVariableStatement &statement,
-                                            std::string *destination,
-                                            enum message::TransformSqlVariant sql_variant)
+enum TransformSqlError
+transformDropSchemaStatementToSql(const DropSchemaStatement &statement,
+                                  string &destination,
+                                  enum TransformSqlVariant sql_variant)
+{
+  char quoted_identifier= '`';
+  if (sql_variant == ANSI)
+    quoted_identifier= '"';
+
+  destination.append("DROP SCHEMA ", 12);
+  destination.push_back(quoted_identifier);
+  destination.append(statement.schema_name());
+  destination.push_back(quoted_identifier);
+
+  return NONE;
+}
+
+enum TransformSqlError
+transformCreateSchemaStatementToSql(const CreateSchemaStatement &statement,
+                                    string &destination,
+                                    enum TransformSqlVariant sql_variant)
+{
+  char quoted_identifier= '`';
+  if (sql_variant == ANSI)
+    quoted_identifier= '"';
+
+  const Schema &schema= statement.schema();
+
+  destination.append("CREATE SCHEMA ", 14);
+  destination.push_back(quoted_identifier);
+  destination.append(schema.name());
+  destination.push_back(quoted_identifier);
+
+  if (schema.has_collation())
+  {
+    destination.append(" COLLATE ", 9);
+    destination.append(schema.collation());
+  }
+
+  return NONE;
+}
+
+enum TransformSqlError
+transformDropTableStatementToSql(const DropTableStatement &statement,
+                                 string &destination,
+                                 enum TransformSqlVariant sql_variant)
+{
+  char quoted_identifier= '`';
+  if (sql_variant == ANSI)
+    quoted_identifier= '"';
+
+  const TableMetadata &table_metadata= statement.table_metadata();
+
+  destination.append("DROP TABLE ", 11);
+
+  /* Add the IF EXISTS clause if necessary */
+  if (statement.has_if_exists_clause() &&
+      statement.if_exists_clause() == true)
+  {
+    destination.append("IF EXISTS ", 10);
+  }
+
+  destination.push_back(quoted_identifier);
+  destination.append(table_metadata.schema_name());
+  destination.push_back(quoted_identifier);
+  destination.push_back('.');
+  destination.push_back(quoted_identifier);
+  destination.append(table_metadata.table_name());
+  destination.push_back(quoted_identifier);
+
+  return NONE;
+}
+
+enum TransformSqlError
+transformTruncateTableStatementToSql(const TruncateTableStatement &statement,
+                                     string &destination,
+                                     enum TransformSqlVariant sql_variant)
+{
+  char quoted_identifier= '`';
+  if (sql_variant == ANSI)
+    quoted_identifier= '"';
+
+  const TableMetadata &table_metadata= statement.table_metadata();
+
+  destination.append("TRUNCATE TABLE ", 15);
+  destination.push_back(quoted_identifier);
+  destination.append(table_metadata.schema_name());
+  destination.push_back(quoted_identifier);
+  destination.push_back('.');
+  destination.push_back(quoted_identifier);
+  destination.append(table_metadata.table_name());
+  destination.push_back(quoted_identifier);
+
+  return NONE;
+}
+
+enum TransformSqlError
+transformSetVariableStatementToSql(const SetVariableStatement &statement,
+                                   string &destination,
+                                   enum TransformSqlVariant sql_variant)
 {
   (void) sql_variant;
-  const message::FieldMetadata &variable_metadata= statement.variable_metadata();
-  bool should_quote_field_value= message::shouldQuoteFieldValue(variable_metadata.type());
-
-  destination->append("SET GLOBAL ", 11); /* Only global variables are replicated */
-  destination->append(variable_metadata.name());
-  destination->push_back('=');
-
-  if (should_quote_field_value)
-    destination->push_back('\'');
-  
-  destination->append(statement.variable_value());
-
-  if (should_quote_field_value)
-    destination->push_back('\'');
-
-  return NONE;
-}
-
-bool message::shouldQuoteFieldValue(message::Table::Field::FieldType in_type)
+  const FieldMetadata &variable_metadata= statement.variable_metadata();
+  bool should_quote_field_value= shouldQuoteFieldValue(variable_metadata.type());
+
+  destination.append("SET GLOBAL ", 11); /* Only global variables are replicated */
+  destination.append(variable_metadata.name());
+  destination.push_back('=');
+
+  if (should_quote_field_value)
+    destination.push_back('\'');
+  
+  destination.append(statement.variable_value());
+
+  if (should_quote_field_value)
+    destination.push_back('\'');
+
+  return NONE;
+}
+
+enum TransformSqlError
+transformCreateTableStatementToSql(const CreateTableStatement &statement,
+                                   string &destination,
+                                   enum TransformSqlVariant sql_variant)
+{
+  return transformTableDefinitionToSql(statement.table(), destination, sql_variant);
+}
+
+enum TransformSqlError
+transformTableDefinitionToSql(const Table &table,
+                              string &destination,
+                              enum TransformSqlVariant sql_variant)
+{
+  char quoted_identifier= '`';
+  if (sql_variant == ANSI)
+    quoted_identifier= '"';
+
+  destination.append("CREATE ", 7);
+
+  if (table.type() == Table::TEMPORARY)
+    destination.append("TEMPORARY ", 10);
+  
+  destination.append("TABLE ", 6);
+  destination.push_back(quoted_identifier);
+  destination.append(table.name());
+  destination.push_back(quoted_identifier);
+  destination.append(" (\n", 3);
+
+  enum TransformSqlError result= NONE;
+  size_t num_fields= table.field_size();
+  for (size_t x= 0; x < num_fields; ++x)
+  {
+    const Table::Field &field= table.field(x);
+
+    if (x != 0)
+      destination.append(",\n", 2);
+
+    result= transformFieldDefinitionToSql(field, destination, sql_variant);
+    
+    if (result != NONE)
+      return result;
+  }
+
+  size_t num_indexes= table.indexes_size();
+  
+  if (num_indexes > 0)
+    destination.append(",\n", 2);
+
+  for (size_t x= 0; x < num_indexes; ++x)
+  {
+    const message::Table::Index &index= table.indexes(x);
+
+    if (x != 0)
+      destination.append(",\n", 2);
+
+    result= transformIndexDefinitionToSql(index, table, destination, sql_variant);
+    
+    if (result != NONE)
+      return result;
+  }
+  destination.append("\n)", 2);
+
+  /* Add ENGINE = " clause */
+  if (table.has_engine())
+  {
+    const Table::StorageEngine &engine= table.engine();
+    destination.append("\nENGINE = ", 10);
+    destination.append(engine.name());
+
+    size_t num_engine_options= engine.option_size();
+    for (size_t x= 0; x < num_engine_options; ++x)
+    {
+      const Table::StorageEngine::EngineOption &option= engine.option(x);
+      destination.push_back('\n');
+      destination.append(option.option_name());
+      destination.append(" = ", 3);
+      destination.append(option.option_value());
+      destination.push_back('\n');
+    }
+  }
+
+  if (table.has_options())
+    (void) transformTableOptionsToSql(table.options(), destination, sql_variant);
+
+  return NONE;
+}
+
+enum TransformSqlError
+transformTableOptionsToSql(const Table::TableOptions &options,
+                           string &destination,
+                           enum TransformSqlVariant sql_variant)
+{
+  if (sql_variant == ANSI)
+    return NONE; /* ANSI does not support table options... */
+
+  stringstream ss;
+
+  if (options.has_comment())
+  {
+    destination.append("\nCOMMENT = '", 12);
+    destination.append(options.comment());
+    destination.push_back('\'');
+  }
+
+  if (options.has_collation())
+  {
+    destination.append("\nCOLLATE = ", 11);
+    destination.append(options.collation());
+  }
+
+  if (options.has_auto_increment())
+  {
+    ss << options.auto_increment();
+    destination.append("\nAUTOINCREMENT_OFFSET = ", 24);
+    destination.append(ss.str());
+    ss.clear();
+  }
+  
+  if (options.has_row_type())
+  {
+    ss << options.row_type();
+    destination.append("\nROW_TYPE = ", 12);
+    destination.append(ss.str());
+    ss.clear();
+  }
+
+  if (options.has_data_file_name())
+  {
+    destination.append("\nDATA_FILE_NAME = '", 19);
+    destination.append(options.data_file_name());
+    destination.push_back('\'');
+  }
+
+  if (options.has_index_file_name())
+  {
+    destination.append("\nINDEX_FILE_NAME = '", 20);
+    destination.append(options.index_file_name());
+    destination.push_back('\'');
+  }
+
+  if (options.has_max_rows())
+  {
+    ss << options.max_rows();
+    destination.append("\nMAX_ROWS = ", 12);
+    destination.append(ss.str());
+    ss.clear();
+  }
+
+  if (options.has_min_rows())
+  {
+    ss << options.min_rows();
+    destination.append("\nMIN_ROWS = ", 12);
+    destination.append(ss.str());
+    ss.clear();
+  }
+
+  if (options.has_auto_increment_value())
+  {
+    ss << options.auto_increment_value();
+    destination.append("\nAUTO_INCREMENT = ", 18);
+    destination.append(ss.str());
+    ss.clear();
+  }
+
+  if (options.has_avg_row_length())
+  {
+    ss << options.avg_row_length();
+    destination.append("\nAVG_ROW_LENGTH = ", 18);
+    destination.append(ss.str());
+    ss.clear();
+  }
+
+  if (options.has_key_block_size())
+  {
+    ss << options.key_block_size();
+    destination.append("\nKEY_BLOCK_SIZE = ", 18);
+    destination.append(ss.str());
+    ss.clear();
+  }
+
+  if (options.has_block_size())
+  {
+    ss << options.block_size();
+    destination.append("\nBLOCK_SIZE = ", 14);
+    destination.append(ss.str());
+    ss.clear();
+  }
+
+  if (options.has_pack_keys() &&
+      options.pack_keys())
+    destination.append("\nPACK_KEYS = TRUE", 17);
+  if (options.has_pack_record() &&
+      options.pack_record())
+    destination.append("\nPACK_RECORD = TRUE", 19);
+  if (options.has_checksum() &&
+      options.checksum())
+    destination.append("\nCHECKSUM = TRUE", 16);
+  if (options.has_page_checksum() &&
+      options.page_checksum())
+    destination.append("\nPAGE_CHECKSUM = TRUE", 21);
+
+  return NONE;
+}
+
+enum TransformSqlError
+transformIndexDefinitionToSql(const Table::Index &index,
+                              const Table &table,
+                              string &destination,
+                              enum TransformSqlVariant sql_variant)
+{
+  char quoted_identifier= '`';
+  if (sql_variant == ANSI)
+    quoted_identifier= '"';
+
+  if (index.is_primary())
+    destination.append("PRIMARY ", 8);
+  else if (index.is_unique())
+    destination.append("UNIQUE ", 7);
+
+  destination.append("KEY ", 4);
+  destination.push_back(quoted_identifier);
+  destination.append(index.name());
+  destination.push_back(quoted_identifier);
+  destination.append(" (", 2);
+  
+  size_t num_parts= index.index_part_size();
+  for (size_t x= 0; x < num_parts; ++x)
+  {
+    const Table::Index::IndexPart &part= index.index_part(x);
+    const Table::Field &field= table.field(part.fieldnr());
+
+    if (x != 0)
+      destination.push_back(',');
+    
+    destination.push_back(quoted_identifier);
+    destination.append(field.name());
+    destination.push_back(quoted_identifier);
+
+    /* 
+     * If the index part's field type is VARCHAR or TEXT
+     * then check for a prefix length then is different
+     * from the field's full length...
+     */
+    if (field.type() == Table::Field::VARCHAR ||
+        field.type() == Table::Field::BLOB)
+    {
+      if (part.has_compare_length())
+      {
+        size_t compare_length_in_chars= part.compare_length();
+        
+        /* hack: compare_length() is bytes, not chars, but
+         * only for VARCHAR. Ass. */
+        if (field.type() == Table::Field::VARCHAR)
+          compare_length_in_chars/= 4;
+
+        if (compare_length_in_chars != field.string_options().length())
+        {
+          stringstream ss;
+          destination.push_back('(');
+          ss << compare_length_in_chars;
+          destination.append(ss.str());
+          destination.push_back(')');
+        }
+      }
+    }
+  }
+  destination.push_back(')');
+
+  return NONE;
+}
+
+enum TransformSqlError
+transformFieldDefinitionToSql(const Table::Field &field,
+                              string &destination,
+                              enum TransformSqlVariant sql_variant)
+{
+  char quoted_identifier= '`';
+  if (sql_variant == ANSI)
+    quoted_identifier= '"';
+
+  destination.push_back(quoted_identifier);
+  destination.append(field.name());
+  destination.push_back(quoted_identifier);
+
+  Table::Field::FieldType field_type= field.type();
+
+  switch (field_type)
+  {
+    case Table::Field::DOUBLE:
+    destination.append(" DOUBLE", 7);
+    break;
+  case Table::Field::VARCHAR:
+    {
+      destination.append(" VARCHAR(", 9);
+      stringstream ss;
+      ss << field.string_options().length() << ")";
+      destination.append(ss.str());
+    }
+    break;
+  case Table::Field::BLOB:
+    destination.append(" BLOB", 5);
+    break;
+  case Table::Field::ENUM:
+    {
+      size_t num_field_values= field.set_options().field_value_size();
+      destination.append(" ENUM(", 6);
+      for (size_t x= 0; x < num_field_values; ++x)
+      {
+        const string &type= field.set_options().field_value(x);
+
+        if (x != 0)
+          destination.push_back(',');
+
+        destination.push_back('\'');
+        destination.append(type);
+        destination.push_back('\'');
+      }
+      destination.push_back(')');
+      break;
+    }
+  case Table::Field::INTEGER:
+    destination.append(" INT", 4);
+    break;
+  case Table::Field::BIGINT:
+    destination.append(" BIGINT", 7);
+    break;
+  case Table::Field::DECIMAL:
+    {
+      destination.append(" DECIMAL(", 9);
+      stringstream ss;
+      ss << field.numeric_options().precision() << ",";
+      ss << field.numeric_options().scale() << ")";
+      destination.append(ss.str());
+    }
+    break;
+  case Table::Field::DATE:
+    destination.append(" DATE", 5);
+    break;
+  case Table::Field::TIMESTAMP:
+    destination.append(" TIMESTAMP",  10);
+    break;
+  case Table::Field::DATETIME:
+    destination.append(" DATETIME",  9);
+    break;
+  }
+
+  if (field.type() == Table::Field::INTEGER || 
+      field.type() == Table::Field::BIGINT)
+  {
+    if (field.has_constraints() &&
+        field.constraints().has_is_unsigned() &&
+        field.constraints().is_unsigned())
+    {
+      destination.append(" UNSIGNED", 9);
+    }
+  }
+
+
+  if (! (field.has_constraints() &&
+         field.constraints().is_nullable()))
+  {
+    destination.append(" NOT", 4);
+  }
+  destination.append(" NULL", 5);
+
+  if (field.type() == Table::Field::INTEGER || 
+      field.type() == Table::Field::BIGINT)
+  {
+    /* AUTO_INCREMENT must be after NOT NULL */
+    if (field.has_numeric_options() &&
+        field.numeric_options().is_autoincrement())
+    {
+      destination.append(" AUTO_INCREMENT", 15);
+    }
+  }
+
+  if (field.type() == Table::Field::BLOB ||
+      field.type() == Table::Field::VARCHAR)
+  {
+    if (field.string_options().has_collation())
+    {
+      destination.append(" COLLATE ", 9);
+      destination.append(field.string_options().collation());
+    }
+  }
+
+  if (field.options().has_default_value())
+  {
+    destination.append(" DEFAULT ", 9);
+    destination.push_back(quoted_identifier);
+    destination.append(field.options().default_value());
+    destination.push_back(quoted_identifier);
+  }
+
+  if (field.options().has_default_bin_value())
+  {
+    const string &v= field.options().default_bin_value();
+    destination.append(" DEFAULT 0x", 11);
+    for (size_t x= 0; x < v.length(); x++)
+    {
+      printf("%.2x", *(v.c_str() + x));
+    }
+  }
+
+  if (field.type() == Table::Field::TIMESTAMP)
+    if (field.timestamp_options().has_auto_updates() &&
+        field.timestamp_options().auto_updates())
+      destination.append(" ON UPDATE CURRENT_TIMESTAMP", 28);
+
+  if (field.has_comment())
+  {
+    destination.append(" COMMENT ", 9);
+    destination.push_back(quoted_identifier);
+    destination.append(field.comment());
+    destination.push_back(quoted_identifier);
+  }
+  return NONE;
+}
+
+bool shouldQuoteFieldValue(Table::Field::FieldType in_type)
 {
   switch (in_type)
   {
-  case message::Table::Field::DOUBLE:
-  case message::Table::Field::DECIMAL:
-  case message::Table::Field::INTEGER:
-  case message::Table::Field::BIGINT:
-  case message::Table::Field::ENUM:
+  case Table::Field::DOUBLE:
+  case Table::Field::DECIMAL:
+  case Table::Field::INTEGER:
+  case Table::Field::BIGINT:
+  case Table::Field::ENUM:
     return false;
   default:
     return true;
   } 
 }
 
-drizzled::message::Table::Field::FieldType message::internalFieldTypeToFieldProtoType(enum enum_field_types type)
+Table::Field::FieldType internalFieldTypeToFieldProtoType(enum enum_field_types type)
 {
   switch (type) {
   case DRIZZLE_TYPE_LONG:
-    return message::Table::Field::INTEGER;
+    return Table::Field::INTEGER;
   case DRIZZLE_TYPE_DOUBLE:
-    return message::Table::Field::DOUBLE;
+    return Table::Field::DOUBLE;
   case DRIZZLE_TYPE_NULL:
     assert(false); /* Not a user definable type */
-    return message::Table::Field::INTEGER; /* unreachable */
+    return Table::Field::INTEGER; /* unreachable */
   case DRIZZLE_TYPE_TIMESTAMP:
-    return message::Table::Field::TIMESTAMP;
+    return Table::Field::TIMESTAMP;
   case DRIZZLE_TYPE_LONGLONG:
-    return message::Table::Field::BIGINT;
+    return Table::Field::BIGINT;
   case DRIZZLE_TYPE_DATETIME:
-    return message::Table::Field::DATETIME;
+    return Table::Field::DATETIME;
   case DRIZZLE_TYPE_DATE:
-    return message::Table::Field::DATE;
+    return Table::Field::DATE;
   case DRIZZLE_TYPE_VARCHAR:
-    return message::Table::Field::VARCHAR;
+    return Table::Field::VARCHAR;
   case DRIZZLE_TYPE_DECIMAL:
-    return message::Table::Field::DECIMAL;
+    return Table::Field::DECIMAL;
   case DRIZZLE_TYPE_ENUM:
-    return message::Table::Field::ENUM;
+    return Table::Field::ENUM;
   case DRIZZLE_TYPE_BLOB:
-    return message::Table::Field::BLOB;
+    return Table::Field::BLOB;
   }
 
   assert(false);
-  return message::Table::Field::INTEGER; /* unreachable */
+  return Table::Field::INTEGER; /* unreachable */
 }
 
+} /* namespace message */
 } /* namespace drizzled */

=== modified file 'drizzled/message/statement_transform.h'
--- drizzled/message/statement_transform.h	2010-02-08 01:10:03 +0000
+++ drizzled/message/statement_transform.h	2010-02-26 20:48:50 +0000
@@ -2,10 +2,11 @@
  *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
  *
  *  Copyright (C) 2009 Sun Microsystems
+ *  Copyright (c) 2010 Jay Pipes <jayjpipes@gmail.com>
  *
  *  Authors:
  *
- *    Jay Pipes <joinfu@sun.com>
+ *    Jay Pipes <jaypipes@gmail.com>
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -52,7 +53,11 @@
 class DeleteHeader;
 class DeleteData;
 class DeleteRecord;
+class DropTableStatement;
+class CreateTableStatement;
 class TruncateTableStatement;
+class CreateSchemaStatement;
+class DropSchemaStatement;
 class SetVariableStatement;
 
 /** A Variation of SQL to be output during transformation */
@@ -117,7 +122,7 @@
 enum TransformSqlError
 transformInsertStatementToSql(const InsertHeader &header,
                               const InsertData &data,
-                              std::string *destination,
+                              std::string &destination,
                               enum TransformSqlVariant sql_variant= DRIZZLE);
 
 /**
@@ -138,7 +143,7 @@
 enum TransformSqlError
 transformInsertRecordToSql(const InsertHeader &header,
                            const InsertRecord &record,
-                           std::string *destination,
+                           std::string &destination,
                            enum TransformSqlVariant sql_variant= DRIZZLE);
 
 /**
@@ -156,7 +161,7 @@
  */
 enum TransformSqlError
 transformInsertHeaderToSql(const InsertHeader &header,
-                           std::string *destination,
+                           std::string &destination,
                            enum TransformSqlVariant sql_variant= DRIZZLE);
 
 /**
@@ -174,7 +179,7 @@
  */
 enum TransformSqlError
 transformUpdateHeaderToSql(const UpdateHeader &header,
-                           std::string *destination,
+                           std::string &destination,
                            enum TransformSqlVariant sql_variant= DRIZZLE);
 
 /**
@@ -195,7 +200,7 @@
 enum TransformSqlError
 transformUpdateRecordToSql(const UpdateHeader &header,
                            const UpdateRecord &record,
-                           std::string *destination,
+                           std::string &destination,
                            enum TransformSqlVariant sql_variant= DRIZZLE);
 
 /**
@@ -221,7 +226,7 @@
 enum TransformSqlError
 transformDeleteStatementToSql(const DeleteHeader &header,
                               const DeleteData &data,
-                              std::string *destination,
+                              std::string &destination,
                               enum TransformSqlVariant sql_variant= DRIZZLE);
 
 /**
@@ -242,7 +247,7 @@
 enum TransformSqlError
 transformDeleteRecordToSql(const DeleteHeader &header,
                            const DeleteRecord &record,
-                           std::string *destination,
+                           std::string &destination,
                            enum TransformSqlVariant sql_variant= DRIZZLE);
 
 /**
@@ -260,10 +265,29 @@
  */
 enum TransformSqlError
 transformDeleteHeaderToSql(const DeleteHeader &header,
-                           std::string *destination,
+                           std::string &destination,
                            enum TransformSqlVariant sql_variant= DRIZZLE);
 
 /**
+ * This function looks at a supplied DropTableStatement
+ * and constructs a correctly-formatted SQL
+ * statement to the supplied destination string.
+ *
+ * @param DropTableStatement message to transform
+ * @param Destination string to append SQL to
+ * @param Variation of SQL to generate
+ *
+ * @retval
+ *  NONE if successful transformation
+ * @retval
+ *  Error code (see enum TransformSqlError definition) if failure
+ */
+enum TransformSqlError
+transformDropTableStatementToSql(const DropTableStatement &statement,
+                                  std::string &destination,
+                                  enum TransformSqlVariant sql_variant= DRIZZLE);
+
+/**
  * This function looks at a supplied TruncateTableStatement
  * and constructs a correctly-formatted SQL
  * statement to the supplied destination string.
@@ -279,10 +303,48 @@
  */
 enum TransformSqlError
 transformTruncateTableStatementToSql(const TruncateTableStatement &statement,
-                                     std::string *destination,
+                                     std::string &destination,
                                      enum TransformSqlVariant sql_variant= DRIZZLE);
 
 /**
+ * This function looks at a supplied CreateSchemaStatement
+ * and constructs a correctly-formatted SQL
+ * statement to the supplied destination string.
+ *
+ * @param CreateSchemaStatement message to transform
+ * @param Destination string to append SQL to
+ * @param Variation of SQL to generate
+ *
+ * @retval
+ *  NONE if successful transformation
+ * @retval
+ *  Error code (see enum TransformSqlError definition) if failure
+ */
+enum TransformSqlError
+transformCreateSchemaStatementToSql(const CreateSchemaStatement &statement,
+                                    std::string &destination,
+                                    enum TransformSqlVariant sql_variant= DRIZZLE);
+
+/**
+ * This function looks at a supplied DropSchemaStatement
+ * and constructs a correctly-formatted SQL
+ * statement to the supplied destination string.
+ *
+ * @param DropSchemaStatement message to transform
+ * @param Destination string to append SQL to
+ * @param Variation of SQL to generate
+ *
+ * @retval
+ *  NONE if successful transformation
+ * @retval
+ *  Error code (see enum TransformSqlError definition) if failure
+ */
+enum TransformSqlError
+transformDropSchemaStatementToSql(const DropSchemaStatement &statement,
+                                  std::string &destination,
+                                  enum TransformSqlVariant sql_variant= DRIZZLE);
+
+/**
  * This function looks at a supplied SetVariableStatement
  * and constructs a correctly-formatted SQL
  * statement to the supplied destination string.
@@ -298,9 +360,95 @@
  */
 enum TransformSqlError
 transformSetVariableStatementToSql(const SetVariableStatement &statement,
-                                   std::string *destination,
-                                   enum TransformSqlVariant sql_variant= DRIZZLE);
-
+                                   std::string &destination,
+                                   enum TransformSqlVariant sql_variant= DRIZZLE);
+
+/**
+ * Appends to supplied string an SQL expression
+ * containing the supplied CreateTableStatement's
+ * appropriate CREATE TABLE SQL statement.
+ */
+enum TransformSqlError
+transformCreateTableStatementToSql(const CreateTableStatement &statement,
+                                   std::string &destination,
+                                   enum TransformSqlVariant sql_variant= DRIZZLE);
+
+/**
+ * Appends to the supplied string an SQL expression
+ * representing the table for a CREATE TABLE expression.
+ *
+ * @param[in]   Table message
+ * @param[out]  String to append to
+ *
+ * @retval
+ *  NONE if successful transformation
+ * @retval
+ *  Error code (see enum TransformSqlError definition) if failure
+ */
+enum TransformSqlError
+transformTableDefinitionToSql(const Table &table,
+                              std::string &destination,
+                              enum TransformSqlVariant sql_variant= DRIZZLE);
+
+/**
+ * Appends to the supplied string an SQL expression
+ * representing the table's optional attributes.
+ *
+ * @note
+ *
+ * This function will eventually be a much simpler
+ * listing of key/value pairs.
+ *
+ * @param[in]   TableOptions message
+ * @param[out]  String to append to
+ *
+ * @retval
+ *  NONE if successful transformation
+ * @retval
+ *  Error code (see enum TransformSqlError definition) if failure
+ */
+enum TransformSqlError
+transformTableOptionsToSql(const Table::TableOptions &table_options,
+                           std::string &destination,
+                           enum TransformSqlVariant sql_variant= DRIZZLE);
+
+/**
+ * Appends to the supplied string an SQL expression
+ * representing the index's attributes.  The built string
+ * corresponds to the SQL in a CREATE INDEX statement.
+ *
+ * @param[in]   Index message
+ * @param[in]   Table containing this index (used to get field names...)
+ * @param[out]  String to append to
+ *
+ * @retval
+ *  NONE if successful transformation
+ * @retval
+ *  Error code (see enum TransformSqlError definition) if failure
+ */
+enum TransformSqlError
+transformIndexDefinitionToSql(const Table::Index &index,
+                              const Table &table,
+                              std::string &destination,
+                              enum TransformSqlVariant sql_variant= DRIZZLE);
+
+/**
+ * Appends to the supplied string an SQL expression
+ * representing the field's attributes.  The built string
+ * corresponds to the SQL in a CREATE TABLE statement.
+ *
+ * @param[in]   Field message
+ * @param[out]  String to append to
+ *
+ * @retval
+ *  NONE if successful transformation
+ * @retval
+ *  Error code (see enum TransformSqlError definition) if failure
+ */
+enum TransformSqlError
+transformFieldDefinitionToSql(const Table::Field &field,
+                              std::string &destination,
+                              enum TransformSqlVariant sql_variant= DRIZZLE);
 
 /**
  * Returns true if the supplied message::Table::Field::FieldType

=== modified file 'drizzled/message/table.proto'
--- drizzled/message/table.proto	2010-02-16 01:28:56 +0000
+++ drizzled/message/table.proto	2010-02-27 23:47:33 +0000
@@ -157,7 +157,7 @@
 
     message IndexPart {
       required uint32 fieldnr = 1;
-      optional int32 compare_length = 2;
+      optional uint32 compare_length = 2;
       optional bool in_reverse_order = 3 [default = false];
 
       optional uint32 key_type = 101; /* THIS MUST DIE. Along with pack_flag*/

=== modified file 'drizzled/message/table_reader.cc'
--- drizzled/message/table_reader.cc	2010-02-16 01:28:56 +0000
+++ drizzled/message/table_reader.cc	2010-02-26 20:48:50 +0000
@@ -30,7 +30,7 @@
 
 #include <iostream>
 #include <string>
-#include <drizzled/message/table.pb.h>
+#include <drizzled/message/statement_transform.h>
 #include <google/protobuf/io/zero_copy_stream.h>
 #include <google/protobuf/io/zero_copy_stream_impl.h>
 
@@ -42,246 +42,6 @@
   Written from Google proto example
 */
 
-static void print_field(const message::Table::Field &field)
-{
-  cout << "\t`" << field.name() << "`";
-
-  message::Table::Field::FieldType field_type= field.type();
-
-  switch (field_type)
-  {
-    case message::Table::Field::DOUBLE:
-    cout << " DOUBLE ";
-    break;
-  case message::Table::Field::VARCHAR:
-    cout << " VARCHAR(" << field.string_options().length() << ")";
-    break;
-  case message::Table::Field::BLOB:
-    cout << " BLOB "; /* FIXME: or text, depends on collation */
-    if(field.string_options().has_collation_id())
-      cout << "COLLATION=" << field.string_options().collation_id() << " ";
-    break;
-  case message::Table::Field::ENUM:
-    {
-      int x;
-
-      cout << " ENUM(";
-      for (x= 0; x < field.set_options().field_value_size() ; x++)
-      {
-        const string type= field.set_options().field_value(x);
-
-        if (x != 0)
-          cout << ",";
-        cout << "'" << type << "'";
-      }
-      cout << ") ";
-      break;
-    }
-  case message::Table::Field::INTEGER:
-    cout << " INT" ;
-    break;
-  case message::Table::Field::BIGINT:
-    cout << " BIGINT ";
-    break;
-  case message::Table::Field::DECIMAL:
-    cout << " DECIMAL(" << field.numeric_options().precision() << "," << field.numeric_options().scale() << ") ";
-    break;
-  case message::Table::Field::DATE:
-    cout << " DATE ";
-    break;
-  case message::Table::Field::TIMESTAMP:
-    cout << " TIMESTAMP ";
-    break;
-  case message::Table::Field::DATETIME:
-    cout << " DATETIME ";
-    break;
-  }
-
-  if (field.type() == message::Table::Field::INTEGER
-      || field.type() == message::Table::Field::BIGINT)
-  {
-    if (field.has_constraints()
-        && field.constraints().has_is_unsigned())
-      if (field.constraints().is_unsigned())
-        cout << " UNSIGNED";
-
-    if (field.has_numeric_options() &&
-      field.numeric_options().is_autoincrement())
-      cout << " AUTOINCREMENT ";
-  }
-
-  if (!( field.has_constraints()
-	 && field.constraints().is_nullable()))
-    cout << " NOT NULL ";
-
-  if (field.type() == message::Table::Field::BLOB
-      || field.type() == message::Table::Field::VARCHAR)
-  {
-    if (field.string_options().has_collation())
-      cout << " COLLATE " << field.string_options().collation();
-  }
-
-  if (field.options().has_default_value())
-    cout << " DEFAULT `" << field.options().default_value() << "` " ;
-
-  if (field.options().has_default_bin_value())
-  {
-    string v= field.options().default_bin_value();
-    cout << " DEFAULT 0x";
-    for(unsigned int i=0; i< v.length(); i++)
-    {
-      printf("%.2x", *(v.c_str()+i));
-    }
-  }
-
-  if (field.type() == message::Table::Field::TIMESTAMP)
-    if (field.timestamp_options().has_auto_updates()
-      && field.timestamp_options().auto_updates())
-      cout << " ON UPDATE CURRENT_TIMESTAMP";
-
-  if (field.has_comment())
-    cout << " COMMENT `" << field.comment() << "` ";
-}
-
-static void print_engine(const message::Table::StorageEngine &engine)
-{
-  int32_t x;
-
-  cout << " ENGINE = " << engine.name()  << endl;
-
-  for (x= 0; x < engine.option_size(); ++x) {
-    const message::Table::StorageEngine::EngineOption option= engine.option(x);
-    cout << "\t" << option.option_name() << " = "
-	 << option.option_value() << endl;
-  }
-}
-
-static void print_index(const message::Table::Index &index)
-{
-
-  if (index.is_primary())
-    cout << " PRIMARY";
-  else if (index.is_unique())
-    cout << " UNIQUE";
-  cout << " KEY `" << index.name() << "` (";
-  {
-    int32_t x;
-
-    for (x= 0; x < index.index_part_size() ; x++)
-    {
-      const message::Table::Index::IndexPart part= index.index_part(x);
-
-      if (x != 0)
-        cout << ",";
-      cout << "`" << part.fieldnr() << "`"; /* FIXME */
-      if (part.has_compare_length())
-        cout << "(" << part.compare_length() << ")";
-    }
-    cout << ")";
-  }
-  cout << "\t";
-}
-
-static void print_table_options(const message::Table::TableOptions &options)
-{
-  if (options.has_comment())
-    cout << " COMMENT = '" << options.comment() << "' " << endl;
-
-  if (options.has_collation())
-    cout << " COLLATE = '" << options.collation() << "' " << endl;
-
-  if (options.has_auto_increment())
-    cout << " AUTOINCREMENT_OFFSET = " << options.auto_increment() << endl;
-
-  if (options.has_collation_id())
-    cout << "-- collation_id = " << options.collation_id() << endl;
-  
-  if (options.has_row_type())
-    cout << " ROW_TYPE = " << options.row_type() << endl;
-
-  if (options.has_data_file_name())
-    cout << " DATA_FILE_NAME = '" << options.data_file_name() << "'" << endl;
-
-  if (options.has_index_file_name())
-    cout << " INDEX_FILE_NAME = '" << options.index_file_name() << "'" << endl;
-
-  if (options.has_max_rows())
-    cout << " MAX_ROWS = " << options.max_rows() << endl;
-
-  if (options.has_min_rows())
-    cout << " MIN_ROWS = " << options.min_rows() << endl;
-
-  if (options.has_auto_increment_value())
-    cout << " AUTO_INCREMENT = " << options.auto_increment_value() << endl;
-
-  if (options.has_avg_row_length())
-    cout << " AVG_ROW_LENGTH = " << options.avg_row_length() << endl;
-
-  if (options.has_key_block_size())
-    cout << " KEY_BLOCK_SIZE = "  << options.key_block_size() << endl;
-
-  if (options.has_block_size())
-    cout << " BLOCK_SIZE = " << options.block_size() << endl;
-
-  if (options.has_comment())
-    cout << " COMMENT = '" << options.comment() << "'" << endl;
-
-  if (options.has_pack_keys())
-    cout << " PACK_KEYS = " << options.pack_keys() << endl;
-  if (options.has_pack_record())
-    cout << " PACK_RECORD = " << options.pack_record() << endl;
-  if (options.has_checksum())
-    cout << " CHECKSUM = " << options.checksum() << endl;
-  if (options.has_page_checksum())
-    cout << " PAGE_CHECKSUM = " << options.page_checksum() << endl;
-}
-
-
-static void print_table(const message::Table &table)
-{
-  int32_t x;
-
-  cout << "CREATE ";
-
-  if (table.type() == message::Table::TEMPORARY)
-    cout << "TEMPORARY ";
-
-  cout << "TABLE `" << table.name() << "` (" << endl;
-
-  for (x= 0; x < table.field_size() ; x++)
-  {
-    const message::Table::Field field = table.field(x);
-
-    if (x != 0)
-      cout << "," << endl;
-
-    print_field(field);
-  }
-
-  for (x= 0; x < table.indexes_size() ; x++)
-  {
-    const message::Table::Index index= table.indexes(x);
-
-    if (x != 0)
-      cout << "," << endl;;
-
-    print_index(index);
-
-  }
-  cout << endl;
-
-  cout << ") " << endl;
-
-  print_engine(table.engine());
-
-  if (table.has_options())
-    print_table_options(table.options());
-  /*
-  if (table->has_stats())
-    print_table_stats(&table->stats());
-  */
-}
-
 int main(int argc, char* argv[])
 {
   GOOGLE_PROTOBUF_VERIFY_VERSION;
@@ -315,7 +75,10 @@
     close(fd);
   }
 
-  print_table(table);
+  string output;
+  (void) message::transformTableDefinitionToSql(table, output);
+
+  cout << output << endl;
 
   return 0;
 }

=== modified file 'drizzled/message/transaction.proto'
--- drizzled/message/transaction.proto	2009-11-03 18:49:13 +0000
+++ drizzled/message/transaction.proto	2010-02-26 00:05:00 +0000
@@ -499,6 +499,7 @@
 message DropTableStatement
 {
   required TableMetadata table_metadata = 1; /* Minimal metadata about the table to be dropped */
+  optional bool if_exists_clause = 2; /* Did the user specify an IF EXISTS clause? */
 }
 
 /*

=== modified file 'drizzled/plugin/logging.cc'
--- drizzled/plugin/logging.cc	2009-12-21 09:40:31 +0000
+++ drizzled/plugin/logging.cc	2010-03-02 16:22:42 +0000
@@ -96,6 +96,29 @@
   }
 };
 
+class PostEndIterate : public unary_function<plugin::Logging *, bool>
+{
+  Session *session;
+public:
+  PostEndIterate(Session *session_arg) :
+    unary_function<plugin::Logging *, bool>(),
+    session(session_arg) {}
+
+  /* This gets called once for each loaded logging plugin */
+  inline result_type operator()(argument_type handler)
+  {
+    if (handler->postEnd(session))
+    {
+      /* TRANSLATORS: The leading word "logging" is the name
+         of the plugin api, and so should not be translated. */
+      errmsg_printf(ERRMSG_LVL_ERROR,
+                    _("logging '%s' postEnd() failed"),
+                    handler->getName().c_str());
+      return true;
+    }
+    return false;
+  }
+};
 
 /* This is the Logging::preDo entry point.
    This gets called by the rest of the Drizzle server code */
@@ -127,4 +150,18 @@
   return iter != all_loggers.end();
 }
 
+/* This gets called in the session destructor */
+bool plugin::Logging::postEndDo(Session *session)
+{
+  /* Use find_if instead of foreach so that we can collect return codes */
+  vector<plugin::Logging *>::iterator iter=
+    find_if(all_loggers.begin(), all_loggers.end(),
+            PostEndIterate(session));
+  /* If iter is == end() here, that means that all of the plugins returned
+   * false, which in this case means they all succeeded. Since we want to
+   * return false on success, we return the value of the two being !=
+   */
+  return iter != all_loggers.end();
+}
+
 } /* namespace drizzled */

=== modified file 'drizzled/plugin/logging.h'
--- drizzled/plugin/logging.h	2010-02-04 08:14:46 +0000
+++ drizzled/plugin/logging.h	2010-03-02 16:22:42 +0000
@@ -50,11 +50,13 @@
    */
   virtual bool pre(Session *) {return false;}
   virtual bool post(Session *) {return false;}
+  virtual bool postEnd(Session*) {return false;}
 
   static bool addPlugin(Logging *handler);
   static void removePlugin(Logging *handler);
   static bool preDo(Session *session);
   static bool postDo(Session *session);
+  static bool postEndDo(Session *session);
 };
 
 } /* namespace plugin */

=== modified file 'drizzled/replication_services.cc'
--- drizzled/replication_services.cc	2010-02-11 03:49:10 +0000
+++ drizzled/replication_services.cc	2010-02-27 23:47:33 +0000
@@ -508,7 +508,7 @@
      * We add the "key field metadata" -- i.e. the fields which is
      * the primary key for the table.
      */
-    if (in_table->s->primary_key == current_field->field_index)
+    if (in_table->s->fieldInPrimaryKey(current_field))
     {
       field_metadata= header->add_key_field_metadata();
       field_metadata->set_name(current_field->field_name);
@@ -602,7 +602,7 @@
      * primary key field value.  Replication only supports tables
      * with a primary key.
      */
-    if (in_table->s->primary_key == current_field->field_index)
+    if (in_table->s->fieldInPrimaryKey(current_field))
     {
       /**
        * To say the below is ugly is an understatement. But it works.
@@ -682,7 +682,7 @@
      * primary key field value.  Replication only supports tables
      * with a primary key.
      */
-    if (in_table->s->primary_key == current_field->field_index)
+    if (in_table->s->fieldInPrimaryKey(current_field))
     {
       field_metadata= header->add_key_field_metadata();
       field_metadata->set_name(current_field->field_name);
@@ -715,7 +715,7 @@
      * primary key field value.  Replication only supports tables
      * with a primary key.
      */
-    if (in_table->s->primary_key == current_field->field_index)
+    if (in_table->s->fieldInPrimaryKey(current_field))
     {
       string_value= current_field->val_str(string_value);
       record->add_key_value(string_value->c_ptr(), string_value->length());
@@ -727,6 +727,126 @@
   }
 }
 
+void ReplicationServices::createTable(Session *in_session,
+                                      const message::Table &table)
+{
+  if (! is_active)
+    return;
+  
+  message::Transaction *transaction= getActiveTransaction(in_session);
+  message::Statement *statement= transaction->add_statement();
+
+  initStatement(*statement, message::Statement::CREATE_TABLE, in_session);
+
+  /* 
+   * Construct the specialized CreateTableStatement message and attach
+   * it to the generic Statement message
+   */
+  message::CreateTableStatement *create_table_statement= statement->mutable_create_table_statement();
+  message::Table *new_table_message= create_table_statement->mutable_table();
+  *new_table_message= table;
+
+  finalizeStatement(*statement, in_session);
+
+  finalizeTransaction(*transaction, in_session);
+  
+  push(*transaction);
+
+  cleanupTransaction(transaction, in_session);
+
+}
+
+void ReplicationServices::createSchema(Session *in_session,
+                                       const message::Schema &schema)
+{
+  if (! is_active)
+    return;
+  
+  message::Transaction *transaction= getActiveTransaction(in_session);
+  message::Statement *statement= transaction->add_statement();
+
+  initStatement(*statement, message::Statement::CREATE_SCHEMA, in_session);
+
+  /* 
+   * Construct the specialized CreateSchemaStatement message and attach
+   * it to the generic Statement message
+   */
+  message::CreateSchemaStatement *create_schema_statement= statement->mutable_create_schema_statement();
+  message::Schema *new_schema_message= create_schema_statement->mutable_schema();
+  *new_schema_message= schema;
+
+  finalizeStatement(*statement, in_session);
+
+  finalizeTransaction(*transaction, in_session);
+  
+  push(*transaction);
+
+  cleanupTransaction(transaction, in_session);
+
+}
+
+void ReplicationServices::dropSchema(Session *in_session, const string &schema_name)
+{
+  if (! is_active)
+    return;
+  
+  message::Transaction *transaction= getActiveTransaction(in_session);
+  message::Statement *statement= transaction->add_statement();
+
+  initStatement(*statement, message::Statement::DROP_SCHEMA, in_session);
+
+  /* 
+   * Construct the specialized DropSchemaStatement message and attach
+   * it to the generic Statement message
+   */
+  message::DropSchemaStatement *drop_schema_statement= statement->mutable_drop_schema_statement();
+
+  drop_schema_statement->set_schema_name(schema_name);
+
+  finalizeStatement(*statement, in_session);
+
+  finalizeTransaction(*transaction, in_session);
+  
+  push(*transaction);
+
+  cleanupTransaction(transaction, in_session);
+}
+
+void ReplicationServices::dropTable(Session *in_session,
+                                    const string &schema_name,
+                                    const string &table_name,
+                                    bool if_exists)
+{
+  if (! is_active)
+    return;
+  
+  message::Transaction *transaction= getActiveTransaction(in_session);
+  message::Statement *statement= transaction->add_statement();
+
+  initStatement(*statement, message::Statement::DROP_TABLE, in_session);
+
+  /* 
+   * Construct the specialized DropTableStatement message and attach
+   * it to the generic Statement message
+   */
+  message::DropTableStatement *drop_table_statement= statement->mutable_drop_table_statement();
+
+  drop_table_statement->set_if_exists_clause(if_exists);
+
+  message::TableMetadata *table_metadata= drop_table_statement->mutable_table_metadata();
+
+  table_metadata->set_schema_name(schema_name);
+  table_metadata->set_table_name(table_name);
+
+  finalizeStatement(*statement, in_session);
+
+  finalizeTransaction(*transaction, in_session);
+  
+  push(*transaction);
+
+  cleanupTransaction(transaction, in_session);
+}
+
 void ReplicationServices::truncateTable(Session *in_session, Table *in_table)
 {
   if (! is_active)

=== modified file 'drizzled/replication_services.h'
--- drizzled/replication_services.h	2010-02-11 03:29:52 +0000
+++ drizzled/replication_services.h	2010-02-27 23:47:33 +0000
@@ -2,10 +2,11 @@
  *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
  *
  *  Copyright (C) 2008-2009 Sun Microsystems
+ *  Copyright (c) 2009-2010 Jay Pipes <jaypipes@gmail.com>
  *
  *  Authors:
  *
- *    Jay Pipes <joinfu@sun.com>
+ *    Jay Pipes <jaypipes@gmail.com>
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -30,7 +31,6 @@
 
 #include <vector>
 
-
 namespace drizzled
 {
 
@@ -323,7 +323,48 @@
    */
   void deleteRecord(Session *in_session, Table *in_table);
   /**
-   * Creates a TruncateTable Statement GPB message and add it
+   * Creates a CreateSchema Statement GPB message and adds it
+   * to the Session's active Transaction GPB message for pushing
+   * out to the replicator streams.
+   *
+   * @param[in] Pointer to the Session which issued the statement
+   * @param[in] message::Schema message describing new schema
+   */
+  void createSchema(Session *in_session, const message::Schema &schema);
+  /**
+   * Creates a DropSchema Statement GPB message and adds it
+   * to the Session's active Transaction GPB message for pushing
+   * out to the replicator streams.
+   *
+   * @param[in] Pointer to the Session which issued the statement
+   * @param[in] message::Schema message describing new schema
+   */
+  void dropSchema(Session *in_session, const std::string &schema_name);
+  /**
+   * Creates a CreateTable Statement GPB message and adds it
+   * to the Session's active Transaction GPB message for pushing
+   * out to the replicator streams.
+   *
+   * @param[in] Pointer to the Session which issued the statement
+   * @param[in] message::Table message describing new schema
+   */
+  void createTable(Session *in_session, const message::Table &table);
+  /**
+   * Creates a DropTable Statement GPB message and adds it
+   * to the Session's active Transaction GPB message for pushing
+   * out to the replicator streams.
+   *
+   * @param[in] Pointer to the Session which issued the statement
+   * @param[in] The schema of the table being dropped
+   * @param[in] The table name of the table being dropped
+   * @param[in] Did the user specify an IF EXISTS clause?
+   */
+  void dropTable(Session *in_session,
+                     const std::string &schema_name,
+                     const std::string &table_name,
+                     bool if_exists);
+  /**
+   * Creates a TruncateTable Statement GPB message and adds it
    * to the Session's active Transaction GPB message for pushing
    * out to the replicator streams.
    *

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2010-03-03 20:21:57 +0000
+++ drizzled/session.cc	2010-03-04 14:42:39 +0000
@@ -39,6 +39,7 @@
 #include <drizzled/plugin/client.h>
 #include "drizzled/plugin/scheduler.h"
 #include "drizzled/plugin/authentication.h"
+#include "drizzled/plugin/logging.h"
 #include "drizzled/plugin/transactional_storage_engine.h"
 #include "drizzled/probes.h"
 #include "drizzled/table_proto.h"
@@ -412,6 +413,7 @@
   free_root(&main_mem_root, MYF(0));
   pthread_setspecific(THR_Session,  0);
 
+  plugin::Logging::postEndDo(this);
 
   /* Ensure that no one is using Session */
   pthread_mutex_unlock(&LOCK_delete);

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2010-03-01 21:13:13 +0000
+++ drizzled/sql_base.cc	2010-03-02 22:39:09 +0000
@@ -485,7 +485,7 @@
 {
   for (; table; table= table->*link )
   {
-    if ((table->table == 0 || table->table->s->tmp_table == NO_TMP_TABLE) &&
+    if ((table->table == 0 || table->table->s->tmp_table == STANDARD_TABLE) &&
         strcmp(table->db, db_name) == 0 &&
         strcmp(table->table_name, table_name) == 0)
       break;
@@ -549,7 +549,7 @@
   if (table->table)
   {
     /* temporary table is always unique */
-    if (table->table && table->table->s->tmp_table != NO_TMP_TABLE)
+    if (table->table && table->table->s->tmp_table != STANDARD_TABLE)
       return 0;
     table= table->find_underlying_table(table->table);
     /*
@@ -787,7 +787,7 @@
       that something has happened.
     */
     unlink_open_table(table);
-    TableIdentifier identifier(db_name, table_name, NO_TMP_TABLE);
+    TableIdentifier identifier(db_name, table_name, STANDARD_TABLE);
     quick_rm_table(*this, identifier);
     pthread_mutex_unlock(&LOCK_open);
   }
@@ -1283,7 +1283,7 @@
 
     if (table_list->create)
     {
-      TableIdentifier  lock_table_identifier(table_list->db, table_list->table_name, NO_TMP_TABLE);
+      TableIdentifier  lock_table_identifier(table_list->db, table_list->table_name, STANDARD_TABLE);
 
       if (not plugin::StorageEngine::doesTableExist(*this, lock_table_identifier))
       {
@@ -1337,7 +1337,7 @@
   table->reginfo.lock_type= TL_READ; /* Assume read */
 
 reset:
-  assert(table->s->ref_count > 0 || table->s->tmp_table != NO_TMP_TABLE);
+  assert(table->s->ref_count > 0 || table->s->tmp_table != STANDARD_TABLE);
 
   if (lex->need_correct_ident())
     table->alias_name_used= my_strcasecmp(table_alias_charset,
@@ -2068,7 +2068,7 @@
     {
       if (tables->lock_type == TL_WRITE_DEFAULT)
         tables->table->reginfo.lock_type= update_lock_default;
-      else if (tables->table->s->tmp_table == NO_TMP_TABLE)
+      else if (tables->table->s->tmp_table == STANDARD_TABLE)
         tables->table->reginfo.lock_type= tables->lock_type;
     }
   }

=== modified file 'drizzled/sql_base.h'
--- drizzled/sql_base.h	2010-02-26 22:52:58 +0000
+++ drizzled/sql_base.h	2010-03-02 23:59:33 +0000
@@ -29,7 +29,6 @@
 
 void table_cache_free(void);
 bool table_cache_init(void);
-void assign_new_table_id(TableShare *share);
 uint32_t cached_open_tables(void);
 uint32_t cached_table_definitions(void);
 

=== modified file 'drizzled/sql_insert.cc'
--- drizzled/sql_insert.cc	2010-02-14 20:26:43 +0000
+++ drizzled/sql_insert.cc	2010-03-02 22:39:09 +0000
@@ -1527,7 +1527,7 @@
   TableIdentifier identifier(create_table->db,
                              create_table->table_name,
                              lex_identified_temp_table ?  TEMP_TABLE :
-                             NO_TMP_TABLE);
+                             STANDARD_TABLE);
 
 
   /*
@@ -1615,32 +1615,17 @@
 
   DRIZZLE_LOCK *extra_lock= NULL;
   /*
-    For row-based replication, the CREATE-SELECT statement is written
-    in two pieces: the first one contain the CREATE TABLE statement
-    necessary to create the table and the second part contain the rows
-    that should go into the table.
-
-    For non-temporary tables, the start of the CREATE-SELECT
-    implicitly commits the previous transaction, and all events
-    forming the statement will be stored the transaction cache. At end
-    of the statement, the entire statement is committed as a
-    transaction, and all events are written to the binary log.
-
-    On the master, the table is locked for the duration of the
-    statement, but since the CREATE part is replicated as a simple
-    statement, there is no way to lock the table for accesses on the
-    slave.  Hence, we have to hold on to the CREATE part of the
-    statement until the statement has finished.
+    For replication, the CREATE-SELECT statement is written
+    in two pieces: the first transaction messsage contains 
+    the CREATE TABLE statement as a CreateTableStatement message
+    necessary to create the table.
+    
+    The second transaction message contains all the InsertStatement
+    and associated InsertRecords that should go into the table.
    */
 
   unit= u;
 
-  /*
-    Start a statement transaction before the create if we are using
-    row-based replication for the statement.  If we are creating a
-    temporary table, we need to start a statement transaction.
-  */
-
   if (!(table= create_table_from_items(session, create_info, create_table,
 				       table_proto,
                                        alter_info, &values,

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2010-03-02 02:17:49 +0000
+++ drizzled/sql_table.cc	2010-03-03 04:58:12 +0000
@@ -54,6 +54,7 @@
 namespace drizzled
 {
 
+extern plugin::StorageEngine *myisam_engine;
 extern pid_t current_pid;
 
 bool is_primary_key(KEY *key_info)
@@ -184,7 +185,7 @@
       table->db_type= share->db_type();
   }
 
-  if (!drop_temporary && lock_table_names_exclusively(session, tables))
+  if (not drop_temporary && lock_table_names_exclusively(session, tables))
   {
     pthread_mutex_unlock(&LOCK_open);
     return 1;
@@ -231,7 +232,7 @@
         goto err_with_placeholders;
       }
     }
-    TableIdentifier identifier(db, table->table_name, table->internal_tmp_table ? INTERNAL_TMP_TABLE : NO_TMP_TABLE);
+    TableIdentifier identifier(db, table->table_name, table->internal_tmp_table ? INTERNAL_TMP_TABLE : STANDARD_TABLE);
 
     if (drop_temporary || not plugin::StorageEngine::doesTableExist(*session, identifier))
     {
@@ -249,7 +250,7 @@
 
       if ((error == ENOENT || error == HA_ERR_NO_SUCH_TABLE) && if_exists)
       {
-	error= 0;
+        error= 0;
         session->clear_error();
       }
 
@@ -261,7 +262,10 @@
     }
 
     if (error == 0 || (if_exists && foreign_key_error == false))
-        write_bin_log_drop_table(session, if_exists, db, table->table_name);
+    {
+      ReplicationServices &replication_services= ReplicationServices::singleton();
+      replication_services.dropTable(session, string(db), string(table->table_name), if_exists);
+    }
 
     if (error)
     {
@@ -757,9 +761,11 @@
 	}
       }
     }
-    /* Don't pack rows in old tables if the user has requested this */
-    if ((sql_field->flags & BLOB_FLAG) ||
-	(sql_field->sql_type == DRIZZLE_TYPE_VARCHAR && create_info->row_type != ROW_TYPE_FIXED))
+
+    /** @todo Get rid of this MyISAM-specific crap. */
+    if (create_info->db_type == myisam_engine &&
+        ((sql_field->flags & BLOB_FLAG) ||
+         (sql_field->sql_type == DRIZZLE_TYPE_VARCHAR && create_info->row_type != ROW_TYPE_FIXED)))
       (*db_options)|= HA_OPTION_PACK_RECORD;
     it2.rewind();
   }
@@ -1451,15 +1457,11 @@
     }
   }
 
-  /*
-    Don't write statement if:
-    - It is an internal temporary table,
-    - Row-based logging is used and it we are creating a temporary table, or
-    - The binary log is not open.
-    Otherwise, the statement shall be binlogged.
-   */
   if (not internal_tmp_table && not lex_identified_temp_table)
-    write_bin_log(session, session->query.c_str());
+  {
+    ReplicationServices &replication_services= ReplicationServices::singleton();
+    replication_services.createTable(session, *table_proto);
+  }
   error= false;
 unlock_and_end:
   pthread_mutex_unlock(&LOCK_open);
@@ -1949,6 +1951,147 @@
 }
 
 /*
+  We have to write the query before we unlock the named table.
+
+  Since temporary tables are not replicated under row-based
+  replication, CREATE TABLE ... LIKE ... needs special
+  treatement.  We have four cases to consider, according to the
+  following decision table:
+
+  ==== ========= ========= ==============================
+  Case    Target    Source Write to binary log
+  ==== ========= ========= ==============================
+  1       normal    normal Original statement
+  2       normal temporary Generated statement
+  3    temporary    normal Nothing
+  4    temporary temporary Nothing
+  ==== ========= ========= ==============================
+*/
+static bool replicateCreateTableLike(Session *session, TableList *table, Table *name_lock,
+                                     bool is_src_table_tmp, bool is_if_not_exists)
+{
+  if (is_src_table_tmp)
+  {
+    char buf[2048];
+    String query(buf, sizeof(buf), system_charset_info);
+    query.length(0);  // Have to zero it since constructor doesn't
+
+
+    /*
+      Here we open the destination table, on which we already have
+      name-lock. This is needed for store_create_info() to work.
+      The table will be closed by unlink_open_table() at the end
+      of this function.
+    */
+    table->table= name_lock;
+    pthread_mutex_lock(&LOCK_open); /* Open new table we have just acquired */
+    if (session->reopen_name_locked_table(table, false))
+    {
+      pthread_mutex_unlock(&LOCK_open);
+      return false;
+    }
+    pthread_mutex_unlock(&LOCK_open);
+
+    int result= store_create_info(table, &query, is_if_not_exists);
+
+    assert(result == 0); // store_create_info() always return 0
+    write_bin_log(session, query.ptr());
+  }
+  else                                      // Case 1
+  {
+    write_bin_log(session, session->query.c_str());
+  }
+
+  return true;
+}
+
+  /*
+    Create a new table by copying from source table
+
+    Altough exclusive name-lock on target table protects us from concurrent
+    DML and DDL operations on it we still want to wrap .FRM creation and call
+    to plugin::StorageEngine::createTable() in critical section protected by
+    LOCK_open in order to provide minimal atomicity against operations which
+    disregard name-locks, like I_S implementation, for example. This is a
+    temporary and should not be copied. Instead we should fix our code to
+    always honor name-locks.
+
+    Also some engines (e.g. NDB cluster) require that LOCK_open should be held
+    during the call to plugin::StorageEngine::createTable().
+    See bug #28614 for more info.
+  */
+static bool create_table_wrapper(Session &session, message::Table& create_table_proto,
+                                 TableIdentifier &destination_identifier,
+                                 TableIdentifier &src_table,
+                                 bool lex_identified_temp_table, bool is_engine_set)
+{
+  int protoerr= EEXIST;
+  message::Table new_proto;
+  message::Table src_proto;
+
+  protoerr= plugin::StorageEngine::getTableDefinition(session,
+                                                      src_table,
+                                                      &src_proto);
+  new_proto.CopyFrom(src_proto);
+
+  if (lex_identified_temp_table)
+  {
+    new_proto.set_type(message::Table::TEMPORARY);
+  }
+  else
+  {
+    new_proto.set_type(message::Table::STANDARD);
+  }
+
+  if (is_engine_set)
+  {
+    message::Table::StorageEngine *protoengine;
+
+    protoengine= new_proto.mutable_engine();
+    protoengine->set_name(create_table_proto.engine().name());
+  }
+
+  if (protoerr == EEXIST)
+  {
+    plugin::StorageEngine* engine= plugin::StorageEngine::findByName(session,
+                                                                     new_proto.engine().name());
+
+    if (engine->check_flag(HTON_BIT_HAS_DATA_DICTIONARY) == false)
+    {
+      string dst_proto_path(destination_identifier.getPath());
+      dst_proto_path.append(".dfe");
+
+      protoerr= drizzle_write_proto_file(dst_proto_path.c_str(), &new_proto);
+    }
+    else
+    {
+      protoerr= 0;
+    }
+  }
+
+  if (protoerr)
+  {
+    if (errno == ENOENT)
+      my_error(ER_BAD_DB_ERROR,MYF(0), destination_identifier.getSchemaName());
+    else
+      my_error(ER_CANT_CREATE_FILE, MYF(0), destination_identifier.getPath(), errno);
+
+    return false;
+  }
+
+  /*
+    As mysql_truncate don't work on a new table at this stage of
+    creation, instead create the table directly (for both normal
+    and temporary tables).
+  */
+  int err= plugin::StorageEngine::createTable(session,
+                                              destination_identifier,
+                                              true, new_proto);
+
+  return err ? false : true;
+}
+
+/*
   Create a table identical to the specified table
 
   SYNOPSIS
@@ -1972,12 +2115,11 @@
   Table *name_lock= 0;
   char *db= table->db;
   char *table_name= table->table_name;
-  int  err;
   bool res= true;
   uint32_t not_used;
-  message::Table src_proto;
   bool lex_identified_temp_table=
     (create_table_proto.type() == message::Table::TEMPORARY);
+  bool was_created;
 
   /*
     By opening source table we guarantee that it exists and no concurrent
@@ -1991,203 +2133,111 @@
   if (session->open_tables_from_list(&src_table, &not_used))
     return true;
 
-  TableIdentifier destination_identifier(db, table_name, lex_identified_temp_table ? TEMP_TABLE : NO_TMP_TABLE);
+  TableIdentifier destination_identifier(db, table_name,
+                                         lex_identified_temp_table ? TEMP_TABLE : STANDARD_TABLE);
+
+  TableIdentifier src_identifier(src_table->table->s->db.str,
+                                 src_table->table->s->table_name.str, src_table->table->s->tmp_table);
+
+
 
   /*
     Check that destination tables does not exist. Note that its name
     was already checked when it was added to the table list.
   */
+  bool table_exists= false;
   if (lex_identified_temp_table)
   {
     if (session->find_temporary_table(db, table_name))
-      goto table_exists;
+    {
+      table_exists= true;
+    }
   }
   else
   {
     if (session->lock_table_name_if_not_cached(db, table_name, &name_lock))
-      goto err;
+    {
+      if (name_lock)
+      {
+        pthread_mutex_lock(&LOCK_open); /* unlink open tables for create table like*/
+        session->unlink_open_table(name_lock);
+        pthread_mutex_unlock(&LOCK_open);
+      }
+
+      return res;
+    }
+
     if (not name_lock)
-      goto table_exists;
-
-    if (plugin::StorageEngine::doesTableExist(*session, destination_identifier))
-      goto table_exists;
+    {
+      table_exists= true;
+    }
+    else if (plugin::StorageEngine::doesTableExist(*session, destination_identifier))
+    {
+      table_exists= true;
+    }
   }
 
-  /*
-    Create a new table by copying from source table
-
-    Altough exclusive name-lock on target table protects us from concurrent
-    DML and DDL operations on it we still want to wrap .FRM creation and call
-    to plugin::StorageEngine::createTable() in critical section protected by
-    LOCK_open in order to provide minimal atomicity against operations which
-    disregard name-locks, like I_S implementation, for example. This is a
-    temporary and should not be copied. Instead we should fix our code to
-    always honor name-locks.
-
-    Also some engines (e.g. NDB cluster) require that LOCK_open should be held
-    during the call to plugin::StorageEngine::createTable().
-    See bug #28614 for more info.
-  */
-  pthread_mutex_lock(&LOCK_open); /* We lock for CREATE TABLE LIKE to copy table definition */
+  if (table_exists)
   {
-    int protoerr= EEXIST;
-
-    TableIdentifier identifier(src_table->table->s->db.str,
-                               src_table->table->s->table_name.str, src_table->table->s->tmp_table);
-    protoerr= plugin::StorageEngine::getTableDefinition(*session,
-                                                        identifier,
-                                                        &src_proto);
-
-    message::Table new_proto(src_proto);
-
-    if (lex_identified_temp_table)
+    if (is_if_not_exists)
     {
-      new_proto.set_type(message::Table::TEMPORARY);
+      char warn_buff[DRIZZLE_ERRMSG_SIZE];
+      snprintf(warn_buff, sizeof(warn_buff),
+               ER(ER_TABLE_EXISTS_ERROR), table_name);
+      push_warning(session, DRIZZLE_ERROR::WARN_LEVEL_NOTE,
+                   ER_TABLE_EXISTS_ERROR,warn_buff);
+      res= false;
     }
     else
     {
-      new_proto.set_type(message::Table::STANDARD);
-    }
-
-    if (is_engine_set)
-    {
-      message::Table::StorageEngine *protoengine;
-
-      protoengine= new_proto.mutable_engine();
-      protoengine->set_name(create_table_proto.engine().name());
-    }
-
-    if (protoerr == EEXIST)
-    {
-      plugin::StorageEngine* engine= plugin::StorageEngine::findByName(*session,
-                                                                       new_proto.engine().name());
-
-      if (engine->check_flag(HTON_BIT_HAS_DATA_DICTIONARY) == false)
-      {
-        string dst_proto_path(destination_identifier.getPath());
-        dst_proto_path.append(".dfe");
-
-        protoerr= drizzle_write_proto_file(dst_proto_path.c_str(), &new_proto);
-      }
-      else
-      {
-        protoerr= 0;
-      }
-    }
-
-    if (protoerr)
-    {
-      if (errno == ENOENT)
-        my_error(ER_BAD_DB_ERROR,MYF(0),db);
-      else
-        my_error(ER_CANT_CREATE_FILE, MYF(0), destination_identifier.getPath(), errno);
-      pthread_mutex_unlock(&LOCK_open);
-      goto err;
-    }
-
-    /*
-      As mysql_truncate don't work on a new table at this stage of
-      creation, instead create the table directly (for both normal
-      and temporary tables).
-    */
-    err= plugin::StorageEngine::createTable(*session,
-                                            destination_identifier,
-                                            true, new_proto);
+      my_error(ER_TABLE_EXISTS_ERROR, MYF(0), table_name);
+    }
   }
-  pthread_mutex_unlock(&LOCK_open);
-
-  if (lex_identified_temp_table)
+  else // Otherwise we create the table
   {
-    if (err || !session->open_temporary_table(destination_identifier))
-    {
+    pthread_mutex_lock(&LOCK_open); /* We lock for CREATE TABLE LIKE to copy table definition */
+    was_created= create_table_wrapper(*session, create_table_proto, destination_identifier,
+                                      src_identifier, lex_identified_temp_table, is_engine_set);
+    pthread_mutex_unlock(&LOCK_open);
+
+    // So we blew the creation of the table, and we scramble to clean up
+    // anything that might have been created (read... it is a hack)
+    if (not was_created)
+    {
+      if (lex_identified_temp_table)
+      {
+        (void) session->rm_temporary_table(engine_arg, destination_identifier);
+      }
+      else
+      {
+        TableIdentifier identifier(db, table_name, STANDARD_TABLE);
+        quick_rm_table(*session, identifier);
+      }
+    } 
+    else if (lex_identified_temp_table && not session->open_temporary_table(destination_identifier))
+    {
+      // We created, but we can't open... also, a hack.
       (void) session->rm_temporary_table(engine_arg, destination_identifier);
-      goto err;
     }
-  }
-  else if (err)
-  {
-    TableIdentifier identifier(db, table_name, NO_TMP_TABLE);
-    quick_rm_table(*session, identifier);
-
-    goto err;
-  }
-
-  /*
-    We have to write the query before we unlock the tables.
-  */
-  {
-    /*
-       Since temporary tables are not replicated under row-based
-       replication, CREATE TABLE ... LIKE ... needs special
-       treatement.  We have four cases to consider, according to the
-       following decision table:
-
-           ==== ========= ========= ==============================
-           Case    Target    Source Write to binary log
-           ==== ========= ========= ==============================
-           1       normal    normal Original statement
-           2       normal temporary Generated statement
-           3    temporary    normal Nothing
-           4    temporary temporary Nothing
-           ==== ========= ========= ==============================
-    */
-    if (! lex_identified_temp_table)
+    else
     {
-      if (src_table->table->s->tmp_table)               // Case 2
+      if (not lex_identified_temp_table)
       {
-        char buf[2048];
-        String query(buf, sizeof(buf), system_charset_info);
-        query.length(0);  // Have to zero it since constructor doesn't
-
-
-        /*
-          Here we open the destination table, on which we already have
-          name-lock. This is needed for store_create_info() to work.
-          The table will be closed by unlink_open_table() at the end
-          of this function.
-        */
-        table->table= name_lock;
-        pthread_mutex_lock(&LOCK_open); /* Open new table we have just acquired */
-        if (session->reopen_name_locked_table(table, false))
-        {
-          pthread_mutex_unlock(&LOCK_open);
-          goto err;
-        }
-        pthread_mutex_unlock(&LOCK_open);
-
-        int result= store_create_info(table, &query, is_if_not_exists);
-
-        assert(result == 0); // store_create_info() always return 0
-        write_bin_log(session, query.ptr());
+        bool rc= replicateCreateTableLike(session, table, name_lock, (src_table->table->s->tmp_table), is_if_not_exists);
+        (void)rc;
       }
-      else                                      // Case 1
-        write_bin_log(session, session->query.c_str());
+
+      res= false;
     }
   }
 
-  res= false;
-  goto err;
-
-table_exists:
-  if (is_if_not_exists)
-  {
-    char warn_buff[DRIZZLE_ERRMSG_SIZE];
-    snprintf(warn_buff, sizeof(warn_buff),
-             ER(ER_TABLE_EXISTS_ERROR), table_name);
-    push_warning(session, DRIZZLE_ERROR::WARN_LEVEL_NOTE,
-		 ER_TABLE_EXISTS_ERROR,warn_buff);
-    res= false;
-  }
-  else
-    my_error(ER_TABLE_EXISTS_ERROR, MYF(0), table_name);
-
-err:
   if (name_lock)
   {
     pthread_mutex_lock(&LOCK_open); /* unlink open tables for create table like*/
     session->unlink_open_table(name_lock);
     pthread_mutex_unlock(&LOCK_open);
   }
+
   return(res);
 }
 

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2010-03-02 02:07:48 +0000
+++ drizzled/sql_yacc.yy	2010-03-02 19:29:14 +0000
@@ -4841,7 +4841,7 @@
 
              {
                drizzled::TableIdentifier identifier(select->getShowSchema().c_str(), $3->table.str);
-               if (plugin::StorageEngine::getTableDefinition(*session, identifier) != EEXIST)
+               if (not plugin::StorageEngine::doesTableExist(*session, identifier))
                {
                    my_error(ER_NO_SUCH_TABLE, MYF(0),
                             select->getShowSchema().c_str(), 
@@ -4883,7 +4883,7 @@
 
              {
                drizzled::TableIdentifier identifier(select->getShowSchema().c_str(), $3->table.str);
-               if (plugin::StorageEngine::getTableDefinition(*session, identifier) != EEXIST)
+               if (not plugin::StorageEngine::doesTableExist(*session, identifier))
                {
                    my_error(ER_NO_SUCH_TABLE, MYF(0),
                             select->getShowSchema().c_str(), 
@@ -5082,7 +5082,6 @@
 describe:
           describe_command table_ident
           {
-            Item_field *my_field;
             Session *session= YYSession;
             statement::Select *select;
             LEX *lex= Lex;
@@ -5103,7 +5102,7 @@
 
              {
                drizzled::TableIdentifier identifier(select->getShowSchema().c_str(), $2->table.str);
-               if (plugin::StorageEngine::getTableDefinition(*session, identifier) != EEXIST)
+               if (not plugin::StorageEngine::doesTableExist(*session, identifier))
                {
                    my_error(ER_NO_SUCH_TABLE, MYF(0),
                             select->getShowSchema().c_str(), 
@@ -5111,44 +5110,15 @@
                }
              }
 
-             if (prepare_new_schema_table(session, lex, "COLUMNS"))
-               DRIZZLE_YYABORT;
-
-             my_field= new Item_field(&session->lex->current_select->context, NULL, NULL, "COLUMN_NAME");
-             my_field->is_autogenerated_name= false;
-             my_field->set_name("Field");
-             if (session->add_item_to_list(my_field))
-               DRIZZLE_YYABORT;
-
-             my_field= new Item_field(&session->lex->current_select->context, NULL, NULL, "DATA_TYPE");
-             my_field->is_autogenerated_name= false;
-             my_field->set_name("Type");
-             if (session->add_item_to_list(my_field))
-               DRIZZLE_YYABORT;
-
-             my_field= new Item_field(&session->lex->current_select->context, NULL, NULL, "IS_NULLABLE");
-             my_field->is_autogenerated_name= false;
-             my_field->set_name("Null");
-             if (session->add_item_to_list(my_field))
-               DRIZZLE_YYABORT;
-
-             my_field= new Item_field(&session->lex->current_select->context, NULL, NULL, "COLUMN_DEFAULT");
-             my_field->is_autogenerated_name= false;
-             my_field->set_name("Default");
-             if (session->add_item_to_list(my_field))
-               DRIZZLE_YYABORT;
-
-             my_field= new Item_field(&session->lex->current_select->context, NULL, NULL, "COLUMN_DEFAULT_IS_NULL");
-             my_field->is_autogenerated_name= false;
-             my_field->set_name("Default is NULL");
-             if (session->add_item_to_list(my_field))
-               DRIZZLE_YYABORT;
-
-             my_field= new Item_field(&session->lex->current_select->context, NULL, NULL, "COLUMN_DEFAULT_UPDATE");
-             my_field->is_autogenerated_name= false;
-             my_field->set_name("On Update");
-             if (session->add_item_to_list(my_field))
-               DRIZZLE_YYABORT;
+             if (prepare_new_schema_table(session, lex, "SHOW_COLUMNS"))
+               DRIZZLE_YYABORT;
+
+             if (session->add_item_to_list( new Item_field(&session->lex->current_select->
+                                                           context,
+                                                           NULL, NULL, "*")))
+               DRIZZLE_YYABORT;
+             (session->lex->current_select->with_wild)++;
+
           }
           opt_describe_column {}
         | describe_command opt_extended_describe
@@ -5205,14 +5175,26 @@
 
 flush_option:
           table_or_tables
-          { Lex->type|= REFRESH_TABLES; }
+          {
+            statement::Flush *statement= (statement::Flush*)Lex->statement;
+            statement->setFlushTables(true);
+          }
           opt_table_list {}
         | TABLES WITH READ_SYM LOCK_SYM
-          { Lex->type|= REFRESH_TABLES | REFRESH_READ_LOCK; }
+          {
+            statement::Flush *statement= (statement::Flush*)Lex->statement;
+            statement->setFlushTablesWithReadLock(true);
+          }
         | LOGS_SYM
-          { Lex->type|= REFRESH_LOG; }
+          {
+            statement::Flush *statement= (statement::Flush*)Lex->statement;
+            statement->setFlushLog(true);
+          }
         | STATUS_SYM
-          { Lex->type|= REFRESH_STATUS; }
+          {
+            statement::Flush *statement= (statement::Flush*)Lex->statement;
+            statement->setFlushStatus(true);
+          }
         ;
 
 opt_table_list:

=== modified file 'drizzled/statement/alter_table.cc'
--- drizzled/statement/alter_table.cc	2010-03-02 01:51:00 +0000
+++ drizzled/statement/alter_table.cc	2010-03-03 04:58:12 +0000
@@ -692,8 +692,6 @@
   int error= 0;
   char tmp_name[80];
   char old_name[32];
-  char new_name_buff[FN_REFLEN];
-  char new_alias_buff[FN_REFLEN];
   char *table_name;
   char *db;
   const char *new_alias;
@@ -704,8 +702,6 @@
   plugin::StorageEngine *save_old_db_type;
   bitset<32> tmp;
 
-  new_name_buff[0]= '\0';
-
   session->set_proc_info("init");
 
   /*
@@ -724,11 +720,6 @@
     return mysql_discard_or_import_tablespace(session, table_list, alter_info->tablespace_op);
   }
 
-  ostringstream oss;
-  oss << drizzle_data_home << "/" << db << "/" << table_name;
-
-  (void) internal::unpack_filename(new_name_buff, oss.str().c_str());
-
   /*
     If this is just a rename of a view, short cut to the
     following scenario: 1) lock LOCK_open 2) do a RENAME
@@ -743,7 +734,7 @@
     This code is wrong and will be removed, please do not copy.
   */
 
-  if (!(table= session->openTableLock(table_list, TL_WRITE_ALLOW_READ)))
+  if (not (table= session->openTableLock(table_list, TL_WRITE_ALLOW_READ)))
     return true;
   
   table->use_all_columns();
@@ -751,16 +742,19 @@
   /* Check that we are not trying to rename to an existing table */
   if (new_name)
   {
-    strcpy(new_name_buff, new_name);
+    char new_alias_buff[FN_REFLEN];
+    char lower_case_table_name[FN_REFLEN];
+
+    strcpy(lower_case_table_name, new_name);
     strcpy(new_alias_buff, new_name);
     new_alias= new_alias_buff;
 
-    my_casedn_str(files_charset_info, new_name_buff);
+    my_casedn_str(files_charset_info, lower_case_table_name);
     new_alias= new_name; // Create lower case table name
     my_casedn_str(files_charset_info, new_name);
 
     if (new_db == db &&
-        ! my_strcasecmp(table_alias_charset, new_name_buff, table_name))
+        not my_strcasecmp(table_alias_charset, lower_case_table_name, table_name))
     {
       /*
         Source and destination table names are equal: make later check
@@ -770,11 +764,11 @@
     }
     else
     {
-      if (table->s->tmp_table != NO_TMP_TABLE)
+      if (table->s->tmp_table != STANDARD_TABLE)
       {
-        if (session->find_temporary_table(new_db, new_name_buff))
+        if (session->find_temporary_table(new_db, lower_case_table_name))
         {
-          my_error(ER_TABLE_EXISTS_ERROR, MYF(0), new_name_buff);
+          my_error(ER_TABLE_EXISTS_ERROR, MYF(0), lower_case_table_name);
           return true;
         }
       }
@@ -789,9 +783,9 @@
           return true;
         }
 
-        TableIdentifier identifier(new_db, new_name_buff);
+        TableIdentifier identifier(new_db, lower_case_table_name);
 
-        if (plugin::StorageEngine::getTableDefinition(*session, identifier) == EEXIST)
+        if (plugin::StorageEngine::doesTableExist(*session, identifier))
         {
           /* Table will be closed by Session::executeCommand() */
           my_error(ER_TABLE_EXISTS_ERROR, MYF(0), new_alias);
@@ -807,12 +801,12 @@
   }
 
   old_db_type= table->s->db_type();
-  if (! create_info->db_type)
+  if (not create_info->db_type)
   {
     create_info->db_type= old_db_type;
   }
 
-  if (table->s->tmp_table != NO_TMP_TABLE)
+  if (table->s->tmp_table != STANDARD_TABLE)
   {
     create_proto->set_type(message::Table::TEMPORARY);
   }
@@ -823,8 +817,12 @@
 
   new_db_type= create_info->db_type;
 
+  /**
+    @todo Have a check on the table definition for FK in the future 
+    to remove the need for the cursor. (aka can_switch_engines())
+  */
   if (new_db_type != old_db_type &&
-      !table->cursor->can_switch_engines())
+      not table->cursor->can_switch_engines())
   {
     assert(0);
     my_error(ER_ROW_IS_REFERENCED, MYF(0));
@@ -1032,7 +1030,7 @@
   /* We must not ignore bad input! */
   session->count_cuted_fields= CHECK_FIELD_ERROR_FOR_NULL;
 
-  if (table->s->tmp_table != NO_TMP_TABLE)
+  if (table->s->tmp_table != STANDARD_TABLE)
   {
     /* We changed a temporary table */
     if (error)
@@ -1125,7 +1123,7 @@
       /* Try to get everything back. */
       error= 1;
 
-      TableIdentifier alias_identifier(new_db, new_alias, NO_TMP_TABLE);
+      TableIdentifier alias_identifier(new_db, new_alias, STANDARD_TABLE);
       quick_rm_table(*session, alias_identifier);
 
       TableIdentifier tmp_identifier(new_db, tmp_name, INTERNAL_TMP_TABLE);

=== modified file 'drizzled/statement/create_table.cc'
--- drizzled/statement/create_table.cc	2010-02-04 08:14:46 +0000
+++ drizzled/statement/create_table.cc	2010-03-02 22:39:09 +0000
@@ -91,7 +91,7 @@
   */
   TableIdentifier new_table_identifier(create_table->db,
                                        create_table->table_name,
-                                       create_table_proto.type() != message::Table::TEMPORARY ? NO_TMP_TABLE : TEMP_TABLE);
+                                       create_table_proto.type() != message::Table::TEMPORARY ? STANDARD_TABLE : TEMP_TABLE);
 
   if (create_table_precheck(new_table_identifier))
   {

=== modified file 'drizzled/statement/flush.cc'
--- drizzled/statement/flush.cc	2010-02-11 03:29:52 +0000
+++ drizzled/statement/flush.cc	2010-03-02 07:34:04 +0000
@@ -52,10 +52,9 @@
 bool statement::Flush::reloadCache()
 {
   bool result= false;
-  ulong options= session->lex->type;
   TableList *tables= (TableList *) session->lex->select_lex.table_list.first;
 
-  if (options & REFRESH_LOG)
+  if (flush_log)
   {
     if (plugin::StorageEngine::flushLogs(NULL))
     {
@@ -66,17 +65,16 @@
     Note that if REFRESH_READ_LOCK bit is set then REFRESH_TABLES is set too
     (see sql_yacc.yy)
   */
-  if (options & (REFRESH_TABLES | REFRESH_READ_LOCK))
+  if (flush_tables || flush_tables_with_read_lock)
   {
-    if ((options & REFRESH_READ_LOCK) && session)
+    if (session && flush_tables_with_read_lock)
     {
       if (lock_global_read_lock(session))
       {
         return true; /* Killed */
       }
-      result= session->close_cached_tables(tables, 
-                                           (options & REFRESH_FAST) ?  false : true, 
-                                           true);
+      result= session->close_cached_tables(tables, true, true);
+
       if (make_global_read_lock_block_commit(session)) /* Killed */
       {
         /* Don't leave things in a half-locked state */
@@ -86,13 +84,11 @@
     }
     else
     {
-      result= session->close_cached_tables(tables, 
-                                           (options & REFRESH_FAST) ?  false : true, 
-                                           false);
+      result= session->close_cached_tables(tables, true, false);
     }
   }
 
-  if (session && (options & REFRESH_STATUS))
+  if (session && flush_status)
   {
     session->refresh_status();
   }

=== modified file 'drizzled/statement/flush.h'
--- drizzled/statement/flush.h	2010-02-04 08:14:46 +0000
+++ drizzled/statement/flush.h	2010-03-02 07:09:16 +0000
@@ -35,12 +35,30 @@
 public:
   Flush(Session *in_session)
     :
-      Statement(in_session)
+    Statement(in_session),
+    flush_log(false),
+    flush_tables(false),
+    flush_tables_with_read_lock(false),
+    flush_status(false)
   {}
 
   bool execute();
 
 private:
+  bool flush_log;
+  bool flush_tables;
+  bool flush_tables_with_read_lock;
+  bool flush_status;
+
+public:
+  void setFlushLog(bool f) { flush_log= f; }
+  void setFlushTables(bool f) { flush_tables= f; }
+  void setFlushTablesWithReadLock(bool f) {
+    flush_tables= flush_tables_with_read_lock= f;
+  }
+  void setFlushStatus(bool f) { flush_status= f; }
+
+private:
 
   /**
    * Reload/resets privileges and the different caches.

=== modified file 'drizzled/statement/rename_table.cc'
--- drizzled/statement/rename_table.cc	2010-03-01 21:13:13 +0000
+++ drizzled/statement/rename_table.cc	2010-03-02 22:39:09 +0000
@@ -154,7 +154,7 @@
   plugin::StorageEngine *engine= NULL;
   message::Table table_proto;
 
-  TableIdentifier old_identifier(ren_table->db, old_alias, NO_TMP_TABLE);
+  TableIdentifier old_identifier(ren_table->db, old_alias, STANDARD_TABLE);
 
   if (plugin::StorageEngine::getTableDefinition(*session, old_identifier, &table_proto) != EEXIST)
   {
@@ -164,7 +164,7 @@
 
   engine= plugin::StorageEngine::findByName(*session, table_proto.engine().name());
 
-  TableIdentifier new_identifier(new_db, new_alias, NO_TMP_TABLE);
+  TableIdentifier new_identifier(new_db, new_alias, STANDARD_TABLE);
   if (plugin::StorageEngine::doesTableExist(*session, new_identifier))
   {
     my_error(ER_TABLE_EXISTS_ERROR, MYF(0), new_alias);

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2010-03-01 21:23:22 +0000
+++ drizzled/table.cc	2010-03-02 22:39:09 +0000
@@ -1562,7 +1562,7 @@
   cursor= 0;				/* For easier errorchecking */
   if (free_share)
   {
-    if (s->tmp_table == NO_TMP_TABLE)
+    if (s->tmp_table == STANDARD_TABLE)
       TableShare::release(s);
     else
       s->free_table_share();

=== modified file 'drizzled/table_identifier.cc'
--- drizzled/table_identifier.cc	2010-03-01 20:27:04 +0000
+++ drizzled/table_identifier.cc	2010-03-02 22:39:09 +0000
@@ -285,7 +285,7 @@
     size_t path_length= 0;
 
     switch (type) {
-    case NO_TMP_TABLE:
+    case STANDARD_TABLE:
       path_length= build_table_filename(path, sizeof(path),
                                         db, table_name,
                                         false);

=== modified file 'drizzled/table_identifier.h'
--- drizzled/table_identifier.h	2010-03-01 20:27:04 +0000
+++ drizzled/table_identifier.h	2010-03-02 22:39:09 +0000
@@ -60,7 +60,7 @@
 public:
   TableIdentifier( const char *db_arg,
                    const char *table_name_arg,
-                   tmp_table_type tmp_arg= NO_TMP_TABLE) :
+                   tmp_table_type tmp_arg= STANDARD_TABLE) :
     path_inited(false),
     type(tmp_arg),
     db(db_arg),
@@ -69,7 +69,7 @@
 
   bool isTmp() const
   {
-    return type == NO_TMP_TABLE ? false  : true;
+    return type == STANDARD_TABLE ? false  : true;
   }
 
   const char *getPath();
@@ -100,7 +100,7 @@
     output << ", ";
 
     switch (identifier.type) {
-    case NO_TMP_TABLE:
+    case STANDARD_TABLE:
       type_str= "standard";
       break;
     case INTERNAL_TMP_TABLE:

=== modified file 'drizzled/table_proto.h'
--- drizzled/table_proto.h	2010-02-08 01:10:03 +0000
+++ drizzled/table_proto.h	2010-03-02 06:49:12 +0000
@@ -22,6 +22,14 @@
 #define DRIZZLED_TABLE_PROTO_H
 
 namespace drizzled {
+/*
+  Maximum length of comments.
+
+  These are historical limits that no longer need to apply.
+*/
+#define TABLE_COMMENT_MAXLEN 2048
+#define COLUMN_COMMENT_MAXLEN 1024
+#define INDEX_COMMENT_MAXLEN 1024
 
 int drizzle_write_proto_file(const std::string file_name,
                              message::Table *table_proto);

=== modified file 'drizzled/table_proto_write.cc'
--- drizzled/table_proto_write.cc	2010-02-24 00:18:38 +0000
+++ drizzled/table_proto_write.cc	2010-02-27 23:47:33 +0000
@@ -309,7 +309,7 @@
   switch(create_info->row_type)
   {
   case ROW_TYPE_DEFAULT:
-    table_options->set_row_type(message::Table::TableOptions::ROW_TYPE_DEFAULT);
+    /* No use setting a default row type... just adds redundant info to message */
     break;
   case ROW_TYPE_FIXED:
     table_options->set_row_type(message::Table::TableOptions::ROW_TYPE_FIXED);
@@ -333,8 +333,8 @@
     abort();
   }
 
-  table_options->set_pack_record(create_info->table_options
-				 & HA_OPTION_PACK_RECORD);
+  if (create_info->table_options & HA_OPTION_PACK_RECORD)
+    table_options->set_pack_record(true);
 
   if (table_options->has_comment())
   {
@@ -447,7 +447,10 @@
 
       idx->set_comment(key_info[i].comment.str);
     }
-    if(key_info[i].flags & ~(HA_NOSAME | HA_PACK_KEY | HA_USES_BLOCK_SIZE | HA_BINARY_PACK_KEY | HA_VAR_LENGTH_PART | HA_NULL_PART_KEY | HA_KEY_HAS_PART_KEY_SEG | HA_GENERATED_KEY | HA_USES_COMMENT))
+    if (key_info[i].flags & 
+        ~(HA_NOSAME | HA_PACK_KEY | HA_USES_BLOCK_SIZE | 
+          HA_BINARY_PACK_KEY | HA_VAR_LENGTH_PART | HA_NULL_PART_KEY | 
+          HA_KEY_HAS_PART_KEY_SEG | HA_GENERATED_KEY | HA_USES_COMMENT))
       abort(); // Invalid (unknown) index flag.
 
     for(unsigned int j=0; j< key_info[i].key_parts; j++)

=== modified file 'drizzled/table_share.cc'
--- drizzled/table_share.cc	2010-02-04 08:14:46 +0000
+++ drizzled/table_share.cc	2010-02-25 20:20:08 +0000
@@ -273,4 +273,31 @@
   }
 }
 
+/**
+ * @todo
+ *
+ * Precache this stuff....
+ */
+bool TableShare::fieldInPrimaryKey(Field *in_field) const
+{
+  assert(table_proto != NULL);
+  
+  size_t num_indexes= table_proto->indexes_size();
+
+  for (size_t x= 0; x < num_indexes; ++x)
+  {
+    const message::Table::Index &index= table_proto->indexes(x);
+    if (index.is_primary())
+    {
+      size_t num_parts= index.index_part_size();
+      for (size_t y= 0; y < num_parts; ++y)
+      {
+        if (index.index_part(y).fieldnr() == in_field->field_index)
+          return true;
+      }
+    }
+  }
+  return false;
+}
+
 } /* namespace drizzled */

=== modified file 'drizzled/table_share.h'
--- drizzled/table_share.h	2010-02-23 01:14:53 +0000
+++ drizzled/table_share.h	2010-03-02 22:39:09 +0000
@@ -58,7 +58,7 @@
     max_rows(0),
     table_proto(NULL),
     storage_engine(NULL),
-    tmp_table(NO_TMP_TABLE),
+    tmp_table(STANDARD_TABLE),
     ref_count(0),
     null_bytes(0),
     last_null_bit_pos(0),
@@ -119,7 +119,7 @@
     max_rows(0),
     table_proto(NULL),
     storage_engine(NULL),
-    tmp_table(NO_TMP_TABLE),
+    tmp_table(STANDARD_TABLE),
     ref_count(0),
     null_bytes(0),
     last_null_bit_pos(0),
@@ -260,6 +260,12 @@
     max_rows= arg;
   }
 
+  /**
+   * Returns true if the supplied Field object
+   * is part of the table's primary key.
+   */
+  bool fieldInPrimaryKey(Field *field) const;
+
   plugin::StorageEngine *storage_engine;			/* storage engine plugin */
   inline plugin::StorageEngine *db_type() const	/* table_type for handler */
   {
@@ -449,7 +455,7 @@
       If someone is waiting for this to be deleted, inform it about this.
       Don't do a delete until we know that no one is refering to this anymore.
     */
-    if (tmp_table == NO_TMP_TABLE)
+    if (tmp_table == STANDARD_TABLE)
     {
       /* share->mutex is locked in release_table_share() */
       while (waiting_on_cond)

=== modified file 'drizzled/visibility.h' (properties changed: +x to -x)
=== modified file 'plugin/errmsg_notify/errmsg_notify.cc'
--- plugin/errmsg_notify/errmsg_notify.cc	2010-01-20 08:47:40 +0000
+++ plugin/errmsg_notify/errmsg_notify.cc	2010-03-02 18:28:00 +0000
@@ -115,4 +115,4 @@
   return 0;
 }
 
-DRIZZLE_PLUGIN(plugin_init, plugin_deinit, NULL, NULL);
+DRIZZLE_PLUGIN(plugin_init, plugin_deinit, NULL);

=== modified file 'plugin/heap/ha_heap.cc'
--- plugin/heap/ha_heap.cc	2010-03-01 22:09:13 +0000
+++ plugin/heap/ha_heap.cc	2010-03-02 22:39:09 +0000
@@ -377,7 +377,7 @@
   int res;
   ha_statistic_increment(&system_status_var::ha_delete_count);
   res= heap_delete(file,buf);
-  if (!res && table->s->tmp_table == NO_TMP_TABLE &&
+  if (!res && table->s->tmp_table == STANDARD_TABLE &&
       ++records_changed*MEMORY_STATS_UPDATE_THRESHOLD > file->s->records)
   {
     /*
@@ -535,7 +535,7 @@
 int ha_heap::delete_all_rows()
 {
   heap_clear(file);
-  if (table->s->tmp_table == NO_TMP_TABLE)
+  if (table->s->tmp_table == STANDARD_TABLE)
   {
     /*
        We can perform this safely since only one writer at the time is
@@ -837,7 +837,7 @@
         key_part_size= next_field_pos;
       }
 
-      if (field->flags & (ENUM_FLAG | SET_FLAG))
+      if (field->flags & ENUM_FLAG)
         seg->charset= &my_charset_bin;
       else
         seg->charset= field->charset();

=== modified file 'plugin/myisam/ha_myisam.cc'
--- plugin/myisam/ha_myisam.cc	2010-03-01 22:09:13 +0000
+++ plugin/myisam/ha_myisam.cc	2010-03-02 22:39:09 +0000
@@ -1223,7 +1223,7 @@
     stats.block_size= myisam_key_cache_block_size;        /* record block size */
 
     /* Update share */
-    if (share->tmp_table == NO_TMP_TABLE)
+    if (share->tmp_table == STANDARD_TABLE)
       pthread_mutex_lock(&share->mutex);
     set_prefix(share->keys_in_use, share->keys);
     /*
@@ -1277,7 +1277,7 @@
       memcpy(table->key_info[0].rec_per_key,
 	     misam_info.rec_per_key,
 	     sizeof(table->key_info[0].rec_per_key)*share->key_parts);
-    if (share->tmp_table == NO_TMP_TABLE)
+    if (share->tmp_table == STANDARD_TABLE)
       pthread_mutex_unlock(&share->mutex);
 
    /*

=== modified file 'plugin/schema_dictionary/columns.cc'
--- plugin/schema_dictionary/columns.cc	2010-03-01 22:24:10 +0000
+++ plugin/schema_dictionary/columns.cc	2010-03-02 17:58:59 +0000
@@ -38,6 +38,12 @@
   add_field("COLUMN_DEFAULT_IS_NULL", plugin::TableFunction::BOOLEAN);
   add_field("COLUMN_DEFAULT_UPDATE");
   add_field("IS_NULLABLE", plugin::TableFunction::BOOLEAN);
+  add_field("IS_INDEXED", plugin::TableFunction::BOOLEAN);
+  add_field("IS_USED_IN_PRIMARY", plugin::TableFunction::BOOLEAN);
+  add_field("IS_UNIQUE", plugin::TableFunction::BOOLEAN);
+  add_field("IS_MULTI", plugin::TableFunction::BOOLEAN);
+  add_field("IS_FIRST_IN_MULTI", plugin::TableFunction::BOOLEAN);
+  add_field("INDEXES_FOUND_IN", plugin::TableFunction::NUMBER);
   add_field("DATA_TYPE");
 
   add_field("CHARACTER_MAXIMUM_LENGTH", plugin::TableFunction::NUMBER);
@@ -140,6 +146,52 @@
   /* IS_NULLABLE */
   push(column.constraints().is_nullable());
 
+  /* IS_INDEXED, IS_USED_IN_PRIMARY, IS_UNIQUE, IS_MULTI, IS_FIRST_IN_MULTI, INDEXES_FOUND_IN */
+  bool is_indexed= false;
+  bool is_primary= false;
+  bool is_unique= false;
+  bool is_multi= false;
+  bool is_multi_first= false;
+  int64_t indexes_found_in= 0;
+  for (int32_t x= 0; x < getTableProto().indexes_size() ; x++)
+  {
+    drizzled::message::Table::Index index=
+      getTableProto().indexes(x);
+
+    for (int32_t y= 0; y < index.index_part_size() ; y++)
+    {
+      drizzled::message::Table::Index::IndexPart index_part=
+        index.index_part(y);
+
+      if (static_cast<int32_t>(index_part.fieldnr()) == column_iterator)
+      {
+        indexes_found_in++;
+        is_indexed= true;
+
+        if (index.is_primary())
+          is_primary= true;
+
+        if (index.is_unique())
+          is_unique= true;
+
+        if (index.index_part_size() > 1)
+        {
+          is_multi= true;
+
+          if (y == 0)
+            is_multi_first= true;
+        }
+      }
+    }
+  }
+  /* ...IS_INDEXED, IS_USED_IN_PRIMARY, IS_UNIQUE, IS_MULTI, IS_FIRST_IN_MULTI, INDEXES_FOUND_IN */
+  push(is_indexed);
+  push(is_primary);
+  push(is_unique);
+  push(is_multi);
+  push(is_multi_first);
+  push(indexes_found_in);
+
   /* DATATYPE */
   pushType(column.type());
 

=== modified file 'plugin/schema_dictionary/index_parts.cc'
--- plugin/schema_dictionary/index_parts.cc	2010-02-19 01:53:48 +0000
+++ plugin/schema_dictionary/index_parts.cc	2010-03-02 17:58:59 +0000
@@ -36,6 +36,9 @@
   add_field("SEQUENCE_IN_INDEX", plugin::TableFunction::NUMBER);
   add_field("COMPARE_LENGTH", plugin::TableFunction::NUMBER);
   add_field("IS_ORDER_REVERSE", plugin::TableFunction::BOOLEAN);
+  add_field("IS_USED_IN_PRIMARY", plugin::TableFunction::BOOLEAN);
+  add_field("IS_UNIQUE", plugin::TableFunction::BOOLEAN);
+  add_field("IS_NULLABLE", plugin::TableFunction::BOOLEAN);
 }
 
 IndexPartsTool::Generator::Generator(Field **arg) :
@@ -121,4 +124,13 @@
 
   /* IS_ORDER_REVERSE */
   push(index_part.in_reverse_order());
+
+  /* IS_USED_IN_PRIMARY */
+  push(getIndex().is_primary());
+
+  /* IS_UNIQUE */
+  push(getIndex().is_unique());
+
+  /* IS_NULLABLE */
+  push(getIndex().options().null_part_key());
 }

=== modified file 'plugin/schema_dictionary/indexes.cc'
--- plugin/schema_dictionary/indexes.cc	2010-02-18 17:24:08 +0000
+++ plugin/schema_dictionary/indexes.cc	2010-03-02 17:58:59 +0000
@@ -30,7 +30,7 @@
   add_field("TABLE_SCHEMA");
   add_field("TABLE_NAME");
   add_field("INDEX_NAME");
-  add_field("IS_PRIMARY", plugin::TableFunction::BOOLEAN);
+  add_field("IS_USED_IN_PRIMARY", plugin::TableFunction::BOOLEAN);
   add_field("IS_UNIQUE", plugin::TableFunction::BOOLEAN);
   add_field("IS_NULLABLE", plugin::TableFunction::BOOLEAN);
   add_field("KEY_LENGTH", plugin::TableFunction::NUMBER);
@@ -101,7 +101,7 @@
   /* INDEX_NAME */
   push(index.name());
 
-  /* IS_PRIMARY */
+  /* IS_USED_IN_PRIMARY */
   push(index.is_primary());
 
   /* IS_UNIQUE */

=== modified file 'plugin/schema_dictionary/tests/r/data_dictionary.result'
--- plugin/schema_dictionary/tests/r/data_dictionary.result	2010-03-02 03:06:15 +0000
+++ plugin/schema_dictionary/tests/r/data_dictionary.result	2010-03-02 17:58:59 +0000
@@ -191,6 +191,15 @@
 #
 #
 #
+#
+#
+#
+#
+#
+#
+#
+#
+#
 SELECT count(*) FROM REFERENTIAL_CONSTRAINTS;
 count(*)
 #
@@ -209,6 +218,12 @@
   `COLUMN_DEFAULT_IS_NULL` varchar(5) NOT NULL DEFAULT '',
   `COLUMN_DEFAULT_UPDATE` varchar(64) NOT NULL DEFAULT '',
   `IS_NULLABLE` varchar(5) NOT NULL DEFAULT '',
+  `IS_INDEXED` varchar(5) NOT NULL DEFAULT '',
+  `IS_USED_IN_PRIMARY` varchar(5) NOT NULL DEFAULT '',
+  `IS_UNIQUE` varchar(5) NOT NULL DEFAULT '',
+  `IS_MULTI` varchar(5) NOT NULL DEFAULT '',
+  `IS_FIRST_IN_MULTI` varchar(5) NOT NULL DEFAULT '',
+  `INDEXES_FOUND_IN` bigint NOT NULL DEFAULT '0',
   `DATA_TYPE` varchar(64) NOT NULL DEFAULT '',
   `CHARACTER_MAXIMUM_LENGTH` bigint NOT NULL DEFAULT '0',
   `CHARACTER_OCTET_LENGTH` bigint NOT NULL DEFAULT '0',
@@ -223,7 +238,7 @@
   `TABLE_SCHEMA` varchar(64) NOT NULL DEFAULT '',
   `TABLE_NAME` varchar(64) NOT NULL DEFAULT '',
   `INDEX_NAME` varchar(64) NOT NULL DEFAULT '',
-  `IS_PRIMARY` varchar(5) NOT NULL DEFAULT '',
+  `IS_USED_IN_PRIMARY` varchar(5) NOT NULL DEFAULT '',
   `IS_UNIQUE` varchar(5) NOT NULL DEFAULT '',
   `IS_NULLABLE` varchar(5) NOT NULL DEFAULT '',
   `KEY_LENGTH` bigint NOT NULL DEFAULT '0',
@@ -240,7 +255,10 @@
   `COLUMN_NUMBER` bigint NOT NULL DEFAULT '0',
   `SEQUENCE_IN_INDEX` bigint NOT NULL DEFAULT '0',
   `COMPARE_LENGTH` bigint NOT NULL DEFAULT '0',
-  `IS_ORDER_REVERSE` varchar(5) NOT NULL DEFAULT ''
+  `IS_ORDER_REVERSE` varchar(5) NOT NULL DEFAULT '',
+  `IS_USED_IN_PRIMARY` varchar(5) NOT NULL DEFAULT '',
+  `IS_UNIQUE` varchar(5) NOT NULL DEFAULT '',
+  `IS_NULLABLE` varchar(5) NOT NULL DEFAULT ''
 ) ENGINE=FunctionEngine
 show create table REFERENTIAL_CONSTRAINTS ;
 Table	Create Table

=== modified file 'plugin/transaction_log/tests/r/alter.result'
--- plugin/transaction_log/tests/r/alter.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/alter.result	2010-02-27 23:47:33 +0000
@@ -10,10 +10,10 @@
 ALTER TABLE t1 ADD INDEX ix_padding (padding(20));
 DROP TABLE t1;
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
+DROP TABLE IF EXISTS `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL , padding VARCHAR(200) NOT NULL , PRIMARY KEY (id) );
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
@@ -28,6 +28,6 @@
 ALTER TABLE t1 ADD INDEX ix_padding (padding(20));
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE `test`.`t1`;
 COMMIT;
 SET GLOBAL transaction_log_truncate_debug= true;

=== modified file 'plugin/transaction_log/tests/r/auto_commit.result'
--- plugin/transaction_log/tests/r/auto_commit.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/auto_commit.result	2010-02-27 23:47:33 +0000
@@ -16,28 +16,28 @@
 INSERT INTO t1 VALUES (2, "I hate testing.");
 DROP TABLE t1;
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
-COMMIT;
-START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL PRIMARY KEY , padding VARCHAR(200) NOT NULL );
-COMMIT;
-START TRANSACTION;
-INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
-INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (2,'I hate testing.');
-COMMIT;
-START TRANSACTION;
-DROP TABLE `t1`;
-COMMIT;
-START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL PRIMARY KEY , padding VARCHAR(200) NOT NULL );
-COMMIT;
-START TRANSACTION;
-INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
-COMMIT;
-START TRANSACTION;
-INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (2,'I hate testing.');
-COMMIT;
-START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE IF EXISTS `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
+COMMIT;
+START TRANSACTION;
+INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
+INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (2,'I hate testing.');
+COMMIT;
+START TRANSACTION;
+DROP TABLE `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
+COMMIT;
+START TRANSACTION;
+INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
+COMMIT;
+START TRANSACTION;
+INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (2,'I hate testing.');
+COMMIT;
+START TRANSACTION;
+DROP TABLE `test`.`t1`;
 COMMIT;
 SET GLOBAL transaction_log_truncate_debug= true;

=== modified file 'plugin/transaction_log/tests/r/blob.result'
--- plugin/transaction_log/tests/r/blob.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/blob.result	2010-02-27 23:47:33 +0000
@@ -10,10 +10,10 @@
 DELETE FROM t1 WHERE padding = 'test\0you';
 DROP TABLE t1;
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
+DROP TABLE IF EXISTS `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL , padding BLOB NOT NULL , PRIMARY KEY (id) );
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` BLOB NOT NULL COLLATE binary, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'test\0me');
@@ -29,6 +29,6 @@
 DELETE FROM `test`.`t1` WHERE `id`=2;
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE `test`.`t1`;
 COMMIT;
 SET GLOBAL transaction_log_truncate_debug= true;

=== added file 'plugin/transaction_log/tests/r/create_schema.result'
--- plugin/transaction_log/tests/r/create_schema.result	1970-01-01 00:00:00 +0000
+++ plugin/transaction_log/tests/r/create_schema.result	2010-02-25 20:20:08 +0000
@@ -0,0 +1,13 @@
+DROP SCHEMA IF EXISTS my_new_schema;
+CREATE SCHEMA my_new_warnings;
+DROP SCHEMA my_new_warnings;
+START TRANSACTION;
+DROP SCHEMA IF EXISTS my_new_schema;
+COMMIT;
+START TRANSACTION;
+CREATE SCHEMA `my_new_warnings` COLLATE utf8_general_ci;
+COMMIT;
+START TRANSACTION;
+DROP SCHEMA my_new_warnings;
+COMMIT;
+SET GLOBAL transaction_log_truncate_debug= true;

=== modified file 'plugin/transaction_log/tests/r/create_select.result'
--- plugin/transaction_log/tests/r/create_select.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/create_select.result	2010-02-27 23:47:33 +0000
@@ -12,13 +12,13 @@
 ) SELECT * FROM t1;
 DROP TABLE t1, t2;
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
-COMMIT;
-START TRANSACTION;
-DROP TABLE IF EXISTS `t2`;
-COMMIT;
-START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL PRIMARY KEY , padding VARCHAR(200) NOT NULL );
+DROP TABLE IF EXISTS `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+DROP TABLE IF EXISTS `test`.`t2`;
+COMMIT;
+START TRANSACTION;
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
@@ -27,12 +27,16 @@
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (2,'I hate testing.');
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t2 ( id INT NOT NULL PRIMARY KEY , padding VARCHAR(200) NOT NULL ) SELECT * FROM t1;
-COMMIT;
-START TRANSACTION;
-DROP TABLE `t1`;
-COMMIT;
-START TRANSACTION;
-DROP TABLE `t2`;
+CREATE TABLE `t2` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
+COMMIT;
+START TRANSACTION;
+INSERT INTO `test`.`t2` (`id`,`padding`) VALUES (1,'I love testing.');
+INSERT INTO `test`.`t2` (`id`,`padding`) VALUES (2,'I hate testing.');
+COMMIT;
+START TRANSACTION;
+DROP TABLE `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+DROP TABLE `test`.`t2`;
 COMMIT;
 SET GLOBAL transaction_log_truncate_debug= true;

=== added file 'plugin/transaction_log/tests/r/create_table.result'
--- plugin/transaction_log/tests/r/create_table.result	1970-01-01 00:00:00 +0000
+++ plugin/transaction_log/tests/r/create_table.result	2010-02-27 23:47:33 +0000
@@ -0,0 +1,54 @@
+DROP TABLE IF EXISTS t1;
+CREATE TABLE t1 (
+autoinc_int_field INT NOT NULL AUTO_INCREMENT
+, null_int_field INT NULL
+, not_null_bigint_field BIGINT NOT NULL
+, null_bigint_field BIGINT NULL
+, not_null_int_field INT NOT NULL
+, null_varchar_field VARCHAR(100) NULL
+, not_null_varchar_field VARCHAR(100) NOT NULL
+, null_enum_field ENUM ('val1', 'val2') NULL
+, not_null_enum_field ENUM ('val1', 'val2') NOT NULL
+, null_date_field DATE NULL
+, not_null_date_field DATE NOT NULL
+, null_datetime_field DATETIME NULL
+, not_null_datetime_field DATETIME NOT NULL
+, null_blob_field BLOB NULL
+, not_null_blob_field BLOB NOT NULL
+, null_text_field TEXT NULL
+, not_null_text_field TEXT NOT NULL
+, null_timestamp_field TIMESTAMP NULL
+, not_null_timestamp_field TIMESTAMP NOT NULL
+, null_double_field DOUBLE NULL
+, not_null_double_field DOUBLE NOT NULL
+, null_decimal_field DECIMAL(10,2) NULL
+, not_null_decimal_field DECIMAL(10,2) NOT NULL
+, PRIMARY KEY (autoinc_int_field)
+);
+DROP TABLE t1;
+CREATE TABLE t1 (
+id INT NOT NULL AUTO_INCREMENT PRIMARY KEY
+, key1 VARCHAR(10) NOT NULL
+, key2 DOUBLE NOT NULL
+, key3 BLOB NOT NULL
+, UNIQUE KEY (key1)
+, KEY named_key (key2)
+, KEY partial_key (key3(30))
+);
+DROP TABLE t1;
+START TRANSACTION;
+DROP TABLE IF EXISTS `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+CREATE TABLE `t1` ( `autoinc_int_field` INT NOT NULL AUTO_INCREMENT, `null_int_field` INT NULL, `not_null_bigint_field` BIGINT NOT NULL, `null_bigint_field` BIGINT NULL, `not_null_int_field` INT NOT NULL, `null_varchar_field` VARCHAR(100) NULL COLLATE utf8_general_ci, `not_null_varchar_field` VARCHAR(100) NOT NULL COLLATE utf8_general_ci, `null_enum_field` ENUM('val1','val2') NULL, `not_null_enum_field` ENUM('val1','val2') NOT NULL, `null_date_field` DATE NULL, `not_null_date_field` DATE NOT NULL, `null_datetime_field` DATETIME NULL, `not_null_datetime_field` DATETIME NOT NULL, `null_blob_field` BLOB NULL COLLATE binary, `not_null_blob_field` BLOB NOT NULL COLLATE binary, `null_text_field` BLOB NULL COLLATE utf8_general_ci, `not_null_text_field` BLOB NOT NULL COLLATE utf8_general_ci, `null_timestamp_field` TIMESTAMP NULL, `not_null_timestamp_field` TIMESTAMP NOT NULL, `null_double_field` DOUBLE NULL, `not_null_double_field` DOUBLE NOT NULL, `null_decimal_field` DECIMAL(10,2) NULL, `not_null_decimal_field` DECIMAL(10,2) NOT NULL, PRIMARY KEY `PRIMARY` (`autoinc_int_field`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
+COMMIT;
+START TRANSACTION;
+DROP TABLE `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+CREATE TABLE `t1` ( `id` INT NOT NULL AUTO_INCREMENT, `key1` VARCHAR(10) NOT NULL COLLATE utf8_general_ci, `key2` DOUBLE NOT NULL, `key3` BLOB NOT NULL COLLATE binary, PRIMARY KEY `PRIMARY` (`id`), UNIQUE KEY `key1` (`key1`), KEY `named_key` (`key2`), KEY `partial_key` (`key3`(30)) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
+COMMIT;
+START TRANSACTION;
+DROP TABLE `test`.`t1`;
+COMMIT;
+SET GLOBAL transaction_log_truncate_debug= true;

=== modified file 'plugin/transaction_log/tests/r/database.result'
--- plugin/transaction_log/tests/r/database.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/database.result	2010-02-25 20:20:08 +0000
@@ -1,7 +1,7 @@
 CREATE DATABASE test1;
 DROP DATABASE test1;
 START TRANSACTION;
-CREATE DATABASE test1;
+CREATE SCHEMA `test1` COLLATE utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 DROP DATABASE test1;

=== modified file 'plugin/transaction_log/tests/r/delete.result'
--- plugin/transaction_log/tests/r/delete.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/delete.result	2010-02-27 23:47:33 +0000
@@ -37,10 +37,10 @@
 DROP TABLE t1;
 End Test of LP Bug #496101
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
+DROP TABLE IF EXISTS `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL , padding VARCHAR(200) NOT NULL , PRIMARY KEY (id) );
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
@@ -52,10 +52,10 @@
 DELETE FROM `test`.`t1` WHERE `id`=1;
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL , other INT NOT NULL , PRIMARY KEY (id) );
+CREATE TABLE `t1` ( `id` INT NOT NULL, `other` INT NOT NULL, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`other`) VALUES (1,1);
@@ -92,10 +92,10 @@
 DELETE FROM `test`.`t1` WHERE `id`=8;
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL , padding VARCHAR(200) NOT NULL , PRIMARY KEY (id) );
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
@@ -103,6 +103,6 @@
 DELETE FROM `test`.`t1` WHERE `id`=1;
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE `test`.`t1`;
 COMMIT;
 SET GLOBAL transaction_log_truncate_debug= true;

=== modified file 'plugin/transaction_log/tests/r/filtered_replicator.result'
--- plugin/transaction_log/tests/r/filtered_replicator.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/filtered_replicator.result	2010-02-27 23:47:33 +0000
@@ -36,8 +36,9 @@
 ALTER TABLE t1 ADD dummy INT;
 ALTER TABLE t1 ADD INDEX ix_padding (padding(20));
 DROP TABLE t1;
-CREATE DATABASE test1;
-DROP DATABASE test1;
+DROP SCHEMA IF EXISTS my_new_schema;
+CREATE SCHEMA my_new_warnings;
+DROP SCHEMA my_new_warnings;
 DROP TABLE IF EXISTS t1, t2;
 CREATE TABLE t1 (
 id INT NOT NULL
@@ -121,47 +122,44 @@
 UPDATE t1 SET id = 4 WHERE id = 2;
 DROP TABLE t1;
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
-COMMIT;
-START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL PRIMARY KEY , padding VARCHAR(200) NOT NULL );
-COMMIT;
-START TRANSACTION;
-INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
-COMMIT;
-START TRANSACTION;
-INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (2,'I hate testing.');
-COMMIT;
-START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
-COMMIT;
-START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL PRIMARY KEY , padding VARCHAR(200) NOT NULL );
-COMMIT;
-START TRANSACTION;
-INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
-INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (2,'I hate testing.');
-COMMIT;
-START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
-COMMIT;
-START TRANSACTION;
-DROP TABLE IF EXISTS `t2`;
-COMMIT;
-START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL PRIMARY KEY , padding VARCHAR(200) NOT NULL );
-COMMIT;
-START TRANSACTION;
-INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
-COMMIT;
-START TRANSACTION;
-INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (2,'I hate testing.');
-COMMIT;
-START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
-COMMIT;
-START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL , padding VARCHAR(200) NOT NULL , PRIMARY KEY (id) );
+DROP TABLE IF EXISTS `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
+COMMIT;
+START TRANSACTION;
+INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
+COMMIT;
+START TRANSACTION;
+INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (2,'I hate testing.');
+COMMIT;
+START TRANSACTION;
+DROP TABLE IF EXISTS `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
+COMMIT;
+START TRANSACTION;
+INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
+INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (2,'I hate testing.');
+COMMIT;
+START TRANSACTION;
+DROP TABLE IF EXISTS `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
+COMMIT;
+START TRANSACTION;
+INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
+COMMIT;
+START TRANSACTION;
+INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (2,'I hate testing.');
+COMMIT;
+START TRANSACTION;
+DROP TABLE IF EXISTS `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
@@ -176,31 +174,31 @@
 ALTER TABLE t1 ADD INDEX ix_padding (padding(20));
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
-COMMIT;
-START TRANSACTION;
-CREATE DATABASE test1;
-COMMIT;
-START TRANSACTION;
-DROP DATABASE test1;
-COMMIT;
-START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
-COMMIT;
-START TRANSACTION;
-DROP TABLE IF EXISTS `t2`;
-COMMIT;
-START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL , padding VARCHAR(200) NOT NULL , PRIMARY KEY (id) );
+DROP TABLE `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+DROP SCHEMA `my_new_schema`;
+COMMIT;
+START TRANSACTION;
+CREATE SCHEMA `my_new_warnings` COLLATE utf8_general_ci;
+COMMIT;
+START TRANSACTION;
+DROP SCHEMA `my_new_warnings`;
+COMMIT;
+START TRANSACTION;
+DROP TABLE IF EXISTS `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 RENAME TABLE t1 TO t2;
 COMMIT;
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
+DROP TABLE IF EXISTS `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL , padding VARCHAR(200) NOT NULL , PRIMARY KEY (id) );
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
@@ -212,10 +210,10 @@
 DELETE FROM `test`.`t1` WHERE `id`=1;
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL , other INT NOT NULL , PRIMARY KEY (id) );
+CREATE TABLE `t1` ( `id` INT NOT NULL, `other` INT NOT NULL, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`other`) VALUES (1,1);
@@ -252,10 +250,10 @@
 DELETE FROM `test`.`t1` WHERE `id`=8;
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL , padding VARCHAR(200) NOT NULL , PRIMARY KEY (id) );
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
@@ -263,13 +261,13 @@
 DELETE FROM `test`.`t1` WHERE `id`=1;
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
-COMMIT;
-START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
-COMMIT;
-START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL , padding VARCHAR(200) NOT NULL , PRIMARY KEY (id) );
+DROP TABLE `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+DROP TABLE IF EXISTS `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
@@ -285,10 +283,10 @@
 UPDATE `test`.`t1` SET `padding`='AAA' WHERE `id`=2;
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id int AUTO_INCREMENT NOT NULL PRIMARY KEY , name varchar(1024) , alias varchar(1024) );
+CREATE TABLE `t1` ( `id` INT NOT NULL AUTO_INCREMENT, `name` VARCHAR(1024) NOT NULL COLLATE utf8_general_ci, `alias` VARCHAR(1024) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`name`,`alias`) VALUES (1,'jeff lebowski','dude');
@@ -297,10 +295,10 @@
 UPDATE `test`.`t1` SET `alias`='the dude' WHERE `id`=1;
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL , counter INT NOT NULL , PRIMARY KEY (id) );
+CREATE TABLE `t1` ( `id` INT NOT NULL, `counter` INT NOT NULL, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`counter`) VALUES (1,1);
@@ -315,10 +313,10 @@
 UPDATE `test`.`t1` SET `counter`=4 WHERE `id`=3;
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL , padding VARCHAR(200) NOT NULL , PRIMARY KEY (id) );
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
@@ -330,6 +328,6 @@
 UPDATE `test`.`t1` SET `id`=4 WHERE `id`=2;
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE `test`.`t1`;
 COMMIT;
 SET GLOBAL transaction_log_truncate_debug= true;

=== modified file 'plugin/transaction_log/tests/r/insert.result'
--- plugin/transaction_log/tests/r/insert.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/insert.result	2010-02-27 23:47:33 +0000
@@ -6,10 +6,10 @@
 INSERT INTO t1 VALUES (1, "I love testing.");
 INSERT INTO t1 VALUES (2, "I hate testing.");
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
+DROP TABLE IF EXISTS `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL PRIMARY KEY , padding VARCHAR(200) NOT NULL );
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');

=== modified file 'plugin/transaction_log/tests/r/insert_multi.result'
--- plugin/transaction_log/tests/r/insert_multi.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/insert_multi.result	2010-02-27 23:47:33 +0000
@@ -5,10 +5,10 @@
 );
 INSERT INTO t1 VALUES (1, "I love testing."), (2, "I hate testing.");
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
+DROP TABLE IF EXISTS `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL PRIMARY KEY , padding VARCHAR(200) NOT NULL );
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');

=== modified file 'plugin/transaction_log/tests/r/insert_on_duplicate_update.result'
--- plugin/transaction_log/tests/r/insert_on_duplicate_update.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/insert_on_duplicate_update.result	2010-02-27 23:47:33 +0000
@@ -9,10 +9,10 @@
 ON DUPLICATE KEY UPDATE padding="I love testing";
 DROP TABLE t1;
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
+DROP TABLE IF EXISTS `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL AUTO_INCREMENT PRIMARY KEY , padding VARCHAR(200) NOT NULL );
+CREATE TABLE `t1` ( `id` INT NOT NULL AUTO_INCREMENT, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
@@ -24,6 +24,6 @@
 UPDATE `test`.`t1` SET `padding`='I love testing' WHERE `id`=2;
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE `test`.`t1`;
 COMMIT;
 SET GLOBAL transaction_log_truncate_debug= true;

=== modified file 'plugin/transaction_log/tests/r/insert_select.result'
--- plugin/transaction_log/tests/r/insert_select.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/insert_select.result	2010-02-27 23:47:33 +0000
@@ -12,13 +12,13 @@
 );
 INSERT INTO t2 SELECT * FROM t1;
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
-COMMIT;
-START TRANSACTION;
-DROP TABLE IF EXISTS `t2`;
-COMMIT;
-START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL PRIMARY KEY , padding VARCHAR(200) NOT NULL );
+DROP TABLE IF EXISTS `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+DROP TABLE IF EXISTS `test`.`t2`;
+COMMIT;
+START TRANSACTION;
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
@@ -27,7 +27,7 @@
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (2,'I hate testing.');
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t2 ( id INT NOT NULL PRIMARY KEY , padding VARCHAR(200) NOT NULL );
+CREATE TABLE `t2` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t2` (`id`,`padding`) VALUES (1,'I love testing.');

=== added file 'plugin/transaction_log/tests/r/multi_column_primary_key.result'
--- plugin/transaction_log/tests/r/multi_column_primary_key.result	1970-01-01 00:00:00 +0000
+++ plugin/transaction_log/tests/r/multi_column_primary_key.result	2010-02-27 23:47:33 +0000
@@ -0,0 +1,55 @@
+DROP TABLE IF EXISTS t1;
+CREATE TABLE t1 (
+k1 INT NOT NULL
+, k2 INT NOT NULL
+, padding VARCHAR(200) NOT NULL
+, PRIMARY KEY (k1, k2)
+);
+INSERT INTO t1 VALUES (1, 1, "I love testing.");
+INSERT INTO t1 VALUES (2, 2, "I hate testing.");
+INSERT INTO t1 VALUES (2, 3, "I hate and love testing.");
+INSERT INTO t1 VALUES (3, 3, "I adore testing.");
+UPDATE t1 SET padding= "XXX" WHERE k1= 1 AND k2= 1;
+UPDATE t1 SET padding= "YYY" WHERE k1= 2;
+UPDATE t1 SET padding= "ZZZ" WHERE k2= 3;
+UPDATE t1 SET padding= "AAA";
+DROP TABLE t1;
+START TRANSACTION;
+DROP TABLE IF EXISTS `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+CREATE TABLE `t1` ( `k1` INT NOT NULL, `k2` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`k1`,`k2`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
+COMMIT;
+START TRANSACTION;
+INSERT INTO `test`.`t1` (`k1`,`k2`,`padding`) VALUES (1,1,'I love testing.');
+COMMIT;
+START TRANSACTION;
+INSERT INTO `test`.`t1` (`k1`,`k2`,`padding`) VALUES (2,2,'I hate testing.');
+COMMIT;
+START TRANSACTION;
+INSERT INTO `test`.`t1` (`k1`,`k2`,`padding`) VALUES (2,3,'I hate and love testing.');
+COMMIT;
+START TRANSACTION;
+INSERT INTO `test`.`t1` (`k1`,`k2`,`padding`) VALUES (3,3,'I adore testing.');
+COMMIT;
+START TRANSACTION;
+UPDATE `test`.`t1` SET `padding`='XXX' WHERE `k1`=1 AND `k2`=1;
+COMMIT;
+START TRANSACTION;
+UPDATE `test`.`t1` SET `padding`='YYY' WHERE `k1`=2 AND `k2`=2;
+UPDATE `test`.`t1` SET `padding`='YYY' WHERE `k1`=2 AND `k2`=3;
+COMMIT;
+START TRANSACTION;
+UPDATE `test`.`t1` SET `padding`='ZZZ' WHERE `k1`=2 AND `k2`=3;
+UPDATE `test`.`t1` SET `padding`='ZZZ' WHERE `k1`=3 AND `k2`=3;
+COMMIT;
+START TRANSACTION;
+UPDATE `test`.`t1` SET `padding`='AAA' WHERE `k1`=1 AND `k2`=1;
+UPDATE `test`.`t1` SET `padding`='AAA' WHERE `k1`=2 AND `k2`=2;
+UPDATE `test`.`t1` SET `padding`='AAA' WHERE `k1`=2 AND `k2`=3;
+UPDATE `test`.`t1` SET `padding`='AAA' WHERE `k1`=3 AND `k2`=3;
+COMMIT;
+START TRANSACTION;
+DROP TABLE `test`.`t1`;
+COMMIT;
+SET GLOBAL transaction_log_truncate_debug= true;

=== modified file 'plugin/transaction_log/tests/r/no_modification.result'
--- plugin/transaction_log/tests/r/no_modification.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/no_modification.result	2010-02-27 23:47:33 +0000
@@ -15,10 +15,10 @@
 2	I hate testing.
 COMMIT;
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
+DROP TABLE IF EXISTS `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL PRIMARY KEY , padding VARCHAR(200) NOT NULL );
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');

=== modified file 'plugin/transaction_log/tests/r/no_primary_key.result'
--- plugin/transaction_log/tests/r/no_primary_key.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/no_primary_key.result	2010-02-27 23:47:33 +0000
@@ -7,12 +7,12 @@
 ERROR HY000: Tables which are replicated require a primary key.
 DROP TABLE t1;
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
-COMMIT;
-START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL , padding VARCHAR(200) NOT NULL );
-COMMIT;
-START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE IF EXISTS `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci ) ENGINE = InnoDB COLLATE = utf8_general_ci;
+COMMIT;
+START TRANSACTION;
+DROP TABLE `test`.`t1`;
 COMMIT;
 SET GLOBAL transaction_log_truncate_debug= true;

=== modified file 'plugin/transaction_log/tests/r/rand.result'
--- plugin/transaction_log/tests/r/rand.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/rand.result	2010-02-27 23:47:33 +0000
@@ -7,10 +7,10 @@
 INSERT INTO t1 SELECT RAND(100)*100 FROM t1;
 DROP TABLE t1;
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
+DROP TABLE IF EXISTS `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL , PRIMARY KEY (id) );
+CREATE TABLE `t1` ( `id` INT NOT NULL, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`) VALUES (1);
@@ -19,6 +19,6 @@
 INSERT INTO `test`.`t1` (`id`) VALUES (17);
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE `test`.`t1`;
 COMMIT;
 SET GLOBAL transaction_log_truncate_debug= true;

=== modified file 'plugin/transaction_log/tests/r/rename.result'
--- plugin/transaction_log/tests/r/rename.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/rename.result	2010-02-27 23:47:33 +0000
@@ -6,13 +6,13 @@
 );
 RENAME TABLE t1 TO t2;
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
-COMMIT;
-START TRANSACTION;
-DROP TABLE IF EXISTS `t2`;
-COMMIT;
-START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL , padding VARCHAR(200) NOT NULL , PRIMARY KEY (id) );
+DROP TABLE IF EXISTS `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+DROP TABLE IF EXISTS `test`.`t2`;
+COMMIT;
+START TRANSACTION;
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 RENAME TABLE t1 TO t2;

=== modified file 'plugin/transaction_log/tests/r/replace.result'
--- plugin/transaction_log/tests/r/replace.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/replace.result	2010-02-27 23:47:33 +0000
@@ -21,13 +21,13 @@
 REPLACE INTO t1 VALUE (2, "I love testing.");
 DROP TABLE t2, t1;
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
-COMMIT;
-START TRANSACTION;
-DROP TABLE IF EXISTS `t2`;
-COMMIT;
-START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL AUTO_INCREMENT PRIMARY KEY , padding VARCHAR(200) NOT NULL ) ENGINE=InnoDB;
+DROP TABLE IF EXISTS `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+DROP TABLE IF EXISTS `test`.`t2`;
+COMMIT;
+START TRANSACTION;
+CREATE TABLE `t1` ( `id` INT NOT NULL AUTO_INCREMENT, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
@@ -39,13 +39,13 @@
 UPDATE `test`.`t1` SET `padding`='I love testing.' WHERE `id`=2;
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
-COMMIT;
-START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL AUTO_INCREMENT PRIMARY KEY , padding VARCHAR(200) NOT NULL ) ENGINE=InnoDB;
-COMMIT;
-START TRANSACTION;
-CREATE TABLE t2 ( id INT NOT NULL AUTO_INCREMENT PRIMARY KEY , fk_id INT NOT NULL , CONSTRAINT fk_t1 FOREIGN KEY (fk_id) REFERENCES t1 (id) ON DELETE CASCADE ) ENGINE=InnoDB;
+DROP TABLE `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+CREATE TABLE `t1` ( `id` INT NOT NULL AUTO_INCREMENT, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
+COMMIT;
+START TRANSACTION;
+CREATE TABLE `t2` ( `id` INT NOT NULL AUTO_INCREMENT, `fk_id` INT NOT NULL, PRIMARY KEY `PRIMARY` (`id`), KEY `fk_t1` (`fk_id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
@@ -58,9 +58,9 @@
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (2,'I love testing.');
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t2`;
+DROP TABLE `test`.`t2`;
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE `test`.`t1`;
 COMMIT;
 SET GLOBAL transaction_log_truncate_debug= true;

=== modified file 'plugin/transaction_log/tests/r/rollback.result'
--- plugin/transaction_log/tests/r/rollback.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/rollback.result	2010-02-27 23:47:33 +0000
@@ -13,12 +13,12 @@
 ROLLBACK;
 DROP TABLE t1;
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
-COMMIT;
-START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL PRIMARY KEY , padding VARCHAR(200) NOT NULL );
-COMMIT;
-START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE IF EXISTS `test`.`t1`;
+COMMIT;
+START TRANSACTION;
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
+COMMIT;
+START TRANSACTION;
+DROP TABLE `test`.`t1`;
 COMMIT;
 SET GLOBAL transaction_log_truncate_debug= true;

=== added file 'plugin/transaction_log/tests/r/schema.result'
--- plugin/transaction_log/tests/r/schema.result	1970-01-01 00:00:00 +0000
+++ plugin/transaction_log/tests/r/schema.result	2010-02-26 19:22:47 +0000
@@ -0,0 +1,13 @@
+DROP SCHEMA IF EXISTS my_new_schema;
+CREATE SCHEMA my_new_warnings;
+DROP SCHEMA my_new_warnings;
+START TRANSACTION;
+DROP SCHEMA `my_new_schema`;
+COMMIT;
+START TRANSACTION;
+CREATE SCHEMA `my_new_warnings` COLLATE utf8_general_ci;
+COMMIT;
+START TRANSACTION;
+DROP SCHEMA `my_new_warnings`;
+COMMIT;
+SET GLOBAL transaction_log_truncate_debug= true;

=== modified file 'plugin/transaction_log/tests/r/select_for_update.result'
--- plugin/transaction_log/tests/r/select_for_update.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/select_for_update.result	2010-02-27 23:47:33 +0000
@@ -19,10 +19,10 @@
 COMMIT;
 DROP TABLE t1;
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
+DROP TABLE IF EXISTS `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL , padding VARCHAR(200) NOT NULL , PRIMARY KEY (id) );
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
@@ -39,6 +39,6 @@
 UPDATE `test`.`t1` SET `id`=6 WHERE `id`=5;
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE `test`.`t1`;
 COMMIT;
 SET GLOBAL transaction_log_truncate_debug= true;

=== modified file 'plugin/transaction_log/tests/r/temp_tables.result'
--- plugin/transaction_log/tests/r/temp_tables.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/temp_tables.result	2010-02-26 00:05:00 +0000
@@ -10,10 +10,10 @@
 DROP TABLE t1;
 DROP TABLE t2;
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
+DROP TABLE IF EXISTS `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-DROP TABLE IF EXISTS `t2`;
+DROP TABLE IF EXISTS `test`.`t2`;
 COMMIT;
 START TRANSACTION;
 CREATE TABLE `t2` (   `id` int NOT NULL,   `padding` varchar(200) NOT NULL,   PRIMARY KEY (`id`) ) ENGINE=InnoDB;
@@ -23,6 +23,6 @@
 INSERT INTO `test`.`t2` (`id`,`padding`) VALUES (2,'I hate testing.');
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t2`;
+DROP TABLE `test`.`t2`;
 COMMIT;
 SET GLOBAL transaction_log_truncate_debug= true;

=== modified file 'plugin/transaction_log/tests/r/truncate.result'
--- plugin/transaction_log/tests/r/truncate.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/truncate.result	2010-02-27 23:47:33 +0000
@@ -7,10 +7,10 @@
 INSERT INTO t1 VALUES (2, "I hate testing.");
 TRUNCATE TABLE t1;
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
+DROP TABLE IF EXISTS `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL PRIMARY KEY , padding VARCHAR(200) NOT NULL );
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');

=== modified file 'plugin/transaction_log/tests/r/truncate_log.result'
--- plugin/transaction_log/tests/r/truncate_log.result	2009-12-11 19:08:29 +0000
+++ plugin/transaction_log/tests/r/truncate_log.result	2010-02-27 23:47:33 +0000
@@ -5,6 +5,6 @@
 );
 INSERT INTO t1 VALUES (1, "I love testing.");
 INSERT INTO t1 VALUES (2, "I hate testing.");
-17var/master-data/transaction.log
+24var/master-data/transaction.log
 SET GLOBAL transaction_log_truncate_debug= true;
 0var/master-data/transaction.log

=== modified file 'plugin/transaction_log/tests/r/update.result'
--- plugin/transaction_log/tests/r/update.result	2009-12-23 14:24:22 +0000
+++ plugin/transaction_log/tests/r/update.result	2010-02-27 23:47:33 +0000
@@ -36,10 +36,10 @@
 UPDATE t1 SET id = 4 WHERE id = 2;
 DROP TABLE t1;
 START TRANSACTION;
-DROP TABLE IF EXISTS `t1`;
+DROP TABLE IF EXISTS `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL , padding VARCHAR(200) NOT NULL , PRIMARY KEY (id) );
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
@@ -55,10 +55,10 @@
 UPDATE `test`.`t1` SET `padding`='AAA' WHERE `id`=2;
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id int AUTO_INCREMENT NOT NULL PRIMARY KEY , name varchar(1024) , alias varchar(1024) );
+CREATE TABLE `t1` ( `id` INT NOT NULL AUTO_INCREMENT, `name` VARCHAR(1024) NOT NULL COLLATE utf8_general_ci, `alias` VARCHAR(1024) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`name`,`alias`) VALUES (1,'jeff lebowski','dude');
@@ -67,10 +67,10 @@
 UPDATE `test`.`t1` SET `alias`='the dude' WHERE `id`=1;
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL , counter INT NOT NULL , PRIMARY KEY (id) );
+CREATE TABLE `t1` ( `id` INT NOT NULL, `counter` INT NOT NULL, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`counter`) VALUES (1,1);
@@ -85,10 +85,10 @@
 UPDATE `test`.`t1` SET `counter`=4 WHERE `id`=3;
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE `test`.`t1`;
 COMMIT;
 START TRANSACTION;
-CREATE TABLE t1 ( id INT NOT NULL , padding VARCHAR(200) NOT NULL , PRIMARY KEY (id) );
+CREATE TABLE `t1` ( `id` INT NOT NULL, `padding` VARCHAR(200) NOT NULL COLLATE utf8_general_ci, PRIMARY KEY `PRIMARY` (`id`) ) ENGINE = InnoDB COLLATE = utf8_general_ci;
 COMMIT;
 START TRANSACTION;
 INSERT INTO `test`.`t1` (`id`,`padding`) VALUES (1,'I love testing.');
@@ -100,6 +100,6 @@
 UPDATE `test`.`t1` SET `id`=4 WHERE `id`=2;
 COMMIT;
 START TRANSACTION;
-DROP TABLE `t1`;
+DROP TABLE `test`.`t1`;
 COMMIT;
 SET GLOBAL transaction_log_truncate_debug= true;

=== added file 'plugin/transaction_log/tests/t/create_table-master.opt'
--- plugin/transaction_log/tests/t/create_table-master.opt	1970-01-01 00:00:00 +0000
+++ plugin/transaction_log/tests/t/create_table-master.opt	2010-02-27 23:47:33 +0000
@@ -0,0 +1,1 @@
+--default-replicator-enable --transaction-log-enable --scheduler=multi_thread

=== added file 'plugin/transaction_log/tests/t/create_table.inc'
--- plugin/transaction_log/tests/t/create_table.inc	1970-01-01 00:00:00 +0000
+++ plugin/transaction_log/tests/t/create_table.inc	2010-02-27 23:47:33 +0000
@@ -0,0 +1,53 @@
+#
+# Tests tons of different CREATE TABLE
+# variations and the replication stream
+#
+
+--disable_warnings
+DROP TABLE IF EXISTS t1;
+--enable_warnings
+
+# Test the field generation
+
+CREATE TABLE t1 (
+  autoinc_int_field INT NOT NULL AUTO_INCREMENT
+, null_int_field INT NULL
+, not_null_bigint_field BIGINT NOT NULL
+, null_bigint_field BIGINT NULL
+, not_null_int_field INT NOT NULL
+, null_varchar_field VARCHAR(100) NULL
+, not_null_varchar_field VARCHAR(100) NOT NULL
+, null_enum_field ENUM ('val1', 'val2') NULL
+, not_null_enum_field ENUM ('val1', 'val2') NOT NULL
+, null_date_field DATE NULL
+, not_null_date_field DATE NOT NULL
+, null_datetime_field DATETIME NULL
+, not_null_datetime_field DATETIME NOT NULL
+, null_blob_field BLOB NULL
+, not_null_blob_field BLOB NOT NULL
+, null_text_field TEXT NULL
+, not_null_text_field TEXT NOT NULL
+, null_timestamp_field TIMESTAMP NULL
+, not_null_timestamp_field TIMESTAMP NOT NULL
+, null_double_field DOUBLE NULL
+, not_null_double_field DOUBLE NOT NULL
+, null_decimal_field DECIMAL(10,2) NULL
+, not_null_decimal_field DECIMAL(10,2) NOT NULL
+, PRIMARY KEY (autoinc_int_field)
+);
+
+DROP TABLE t1;
+
+# Test the index generation
+
+CREATE TABLE t1 (
+  id INT NOT NULL AUTO_INCREMENT PRIMARY KEY
+, key1 VARCHAR(10) NOT NULL
+, key2 DOUBLE NOT NULL
+, key3 BLOB NOT NULL
+, UNIQUE KEY (key1)
+, KEY named_key (key2)
+, KEY partial_key (key3(30))
+);
+
+DROP TABLE t1;

=== added file 'plugin/transaction_log/tests/t/create_table.test'
--- plugin/transaction_log/tests/t/create_table.test	1970-01-01 00:00:00 +0000
+++ plugin/transaction_log/tests/t/create_table.test	2010-02-27 23:47:33 +0000
@@ -0,0 +1,9 @@
+# Populate log with some records...
+--source ../plugin/transaction_log/tests/t/create_table.inc
+
+# Read in the transaction.log.
+
+--exec ../drizzled/message/transaction_reader var/master-data/transaction.log
+
+# Truncate the log file to reset for the next test
+--source ../plugin/transaction_log/tests/t/truncate_log.inc

=== removed file 'plugin/transaction_log/tests/t/database.inc'
--- plugin/transaction_log/tests/t/database.inc	2009-07-02 05:08:33 +0000
+++ plugin/transaction_log/tests/t/database.inc	1970-01-01 00:00:00 +0000
@@ -1,12 +0,0 @@
-# 
-# Simple test of the serial event log for CREATE DATABASE and
-# DROP DATABASE  
-# 
-# Create a database then drop a database 
-# 
-# We then use the transaction_reader in drizzled/message/ to read the events.
-#
-
-# CREATE DATABASE 
-CREATE DATABASE test1;
-DROP DATABASE test1;

=== removed file 'plugin/transaction_log/tests/t/database.test'
--- plugin/transaction_log/tests/t/database.test	2009-12-04 18:50:04 +0000
+++ plugin/transaction_log/tests/t/database.test	1970-01-01 00:00:00 +0000
@@ -1,13 +0,0 @@
-#
-# Tests simple CREATE DATABASE and DROP DATABASE statements and the transaction log
-#
-
-# Populate log with some records...
---source ../plugin/transaction_log/tests/t/database.inc
-
-# Read in the transaction.log.
-
---exec ../drizzled/message/transaction_reader var/master-data/transaction.log
-
-# Truncate the log file to reset for the next test
---source ../plugin/transaction_log/tests/t/truncate_log.inc

=== modified file 'plugin/transaction_log/tests/t/filtered_replicator.test'
--- plugin/transaction_log/tests/t/filtered_replicator.test	2009-12-04 18:50:04 +0000
+++ plugin/transaction_log/tests/t/filtered_replicator.test	2010-02-25 22:59:56 +0000
@@ -16,7 +16,7 @@
 --source ../plugin/transaction_log/tests/t/insert_multi.inc
 --source ../plugin/transaction_log/tests/t/insert_select.inc
 --source ../plugin/transaction_log/tests/t/alter.inc
---source ../plugin/transaction_log/tests/t/database.inc
+--source ../plugin/transaction_log/tests/t/schema.inc
 --source ../plugin/transaction_log/tests/t/rename.inc
 --source ../plugin/transaction_log/tests/t/delete.inc
 --source ../plugin/transaction_log/tests/t/update.inc

=== added file 'plugin/transaction_log/tests/t/multi_column_primary_key-master.opt'
--- plugin/transaction_log/tests/t/multi_column_primary_key-master.opt	1970-01-01 00:00:00 +0000
+++ plugin/transaction_log/tests/t/multi_column_primary_key-master.opt	2010-02-25 20:20:08 +0000
@@ -0,0 +1,1 @@
+--default-replicator-enable --transaction-log-enable --scheduler=multi_thread

=== added file 'plugin/transaction_log/tests/t/multi_column_primary_key.inc'
--- plugin/transaction_log/tests/t/multi_column_primary_key.inc	1970-01-01 00:00:00 +0000
+++ plugin/transaction_log/tests/t/multi_column_primary_key.inc	2010-02-25 20:20:08 +0000
@@ -0,0 +1,36 @@
+# 
+# Test that tables with multi-column primary keys
+# are handled properly in replication
+#
+
+--disable_warnings
+DROP TABLE IF EXISTS t1;
+--enable_warnings
+
+CREATE TABLE t1 (
+  k1 INT NOT NULL
+, k2 INT NOT NULL
+, padding VARCHAR(200) NOT NULL
+, PRIMARY KEY (k1, k2)
+);
+
+INSERT INTO t1 VALUES (1, 1, "I love testing.");
+INSERT INTO t1 VALUES (2, 2, "I hate testing.");
+INSERT INTO t1 VALUES (2, 3, "I hate and love testing.");
+INSERT INTO t1 VALUES (3, 3, "I adore testing.");
+
+# Simple PK update on both columns
+UPDATE t1 SET padding= "XXX" WHERE k1= 1 AND k2= 1;
+
+# UPDATE all records in table matching first column
+# in primary key
+UPDATE t1 SET padding= "YYY" WHERE k1= 2;
+
+# UPDATE all records in table matching second column
+# in primary key
+UPDATE t1 SET padding= "ZZZ" WHERE k2= 3;
+
+# UPDATE all records in table
+UPDATE t1 SET padding= "AAA";
+
+DROP TABLE t1;

=== added file 'plugin/transaction_log/tests/t/multi_column_primary_key.test'
--- plugin/transaction_log/tests/t/multi_column_primary_key.test	1970-01-01 00:00:00 +0000
+++ plugin/transaction_log/tests/t/multi_column_primary_key.test	2010-02-25 20:20:08 +0000
@@ -0,0 +1,9 @@
+# Populate log with some records...
+--source ../plugin/transaction_log/tests/t/multi_column_primary_key.inc
+
+# Read in the transaction.log.
+
+--exec ../drizzled/message/transaction_reader var/master-data/transaction.log
+
+# Truncate the log file to reset for the next test
+--source ../plugin/transaction_log/tests/t/truncate_log.inc

=== added file 'plugin/transaction_log/tests/t/schema-master.opt'
--- plugin/transaction_log/tests/t/schema-master.opt	1970-01-01 00:00:00 +0000
+++ plugin/transaction_log/tests/t/schema-master.opt	2010-02-25 22:59:56 +0000
@@ -0,0 +1,1 @@
+--default-replicator-enable --transaction-log-enable --scheduler=multi_thread

=== added file 'plugin/transaction_log/tests/t/schema.inc'
--- plugin/transaction_log/tests/t/schema.inc	1970-01-01 00:00:00 +0000
+++ plugin/transaction_log/tests/t/schema.inc	2010-02-25 22:59:56 +0000
@@ -0,0 +1,12 @@
+# 
+# Test CREATE SCHEMA, DROP SCHEMA, ALTER SCHEMA
+# and the replication stream
+#
+
+--disable_warnings
+DROP SCHEMA IF EXISTS my_new_schema;
+--enable_warnings
+
+CREATE SCHEMA my_new_warnings;
+
+DROP SCHEMA my_new_warnings;

=== added file 'plugin/transaction_log/tests/t/schema.test'
--- plugin/transaction_log/tests/t/schema.test	1970-01-01 00:00:00 +0000
+++ plugin/transaction_log/tests/t/schema.test	2010-02-25 22:59:56 +0000
@@ -0,0 +1,9 @@
+# Populate log with some records...
+--source ../plugin/transaction_log/tests/t/schema.inc
+
+# Read in the transaction.log.
+
+--exec ../drizzled/message/transaction_reader var/master-data/transaction.log
+
+# Truncate the log file to reset for the next test
+--source ../plugin/transaction_log/tests/t/truncate_log.inc

=== modified file 'tests/r/alter_table.result'
--- tests/r/alter_table.result	2010-03-02 01:04:20 +0000
+++ tests/r/alter_table.result	2010-03-02 16:42:01 +0000
@@ -417,7 +417,7 @@
 Table	Unique	Key_name	Seq_in_index	Column_name
 t1	FALSE	a	1	a
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	BIGINT	TRUE		TRUE	
 b	VARCHAR	TRUE		TRUE	
 c	DECIMAL	TRUE		TRUE	
@@ -665,7 +665,7 @@
 create table t1 (mycol int not null);
 alter table t1 alter column mycol set default 0;
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 mycol	INTEGER	FALSE	0	FALSE	
 drop table t1;
 create TEMPORARY table t1(id int primary key auto_increment) engine=MEMORY;
@@ -843,7 +843,7 @@
 INDEX(`int_field`)
 );
 DESCRIBE t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 int_field	INTEGER	FALSE		FALSE	
 char_field	VARCHAR	TRUE		TRUE	
 SHOW INDEXES FROM t1;
@@ -862,16 +862,16 @@
 3	tri
 5	pet
 DESCRIBE t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 unsigned_int_field	INTEGER	FALSE		FALSE	
 char_field	VARCHAR	TRUE		TRUE	
 DESCRIBE t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 unsigned_int_field	INTEGER	FALSE		FALSE	
 char_field	VARCHAR	TRUE		TRUE	
 ALTER TABLE t2 MODIFY unsigned_int_field BIGINT NOT NULL;
 DESCRIBE t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 unsigned_int_field	BIGINT	FALSE		FALSE	
 char_field	VARCHAR	TRUE		TRUE	
 DROP TABLE t2;

=== modified file 'tests/r/bigint.result'
--- tests/r/bigint.result	2010-02-19 19:04:24 +0000
+++ tests/r/bigint.result	2010-03-02 16:42:01 +0000
@@ -368,11 +368,11 @@
 9223372036854775808	-9223372036854775808
 create table t1 select -9223372036854775808 bi;
 describe t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 bi	BIGINT	FALSE		FALSE	
 drop table t1;
 create table t1 select -9223372036854775809 bi;
 describe t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 bi	DECIMAL	FALSE		FALSE	
 drop table t1;

=== modified file 'tests/r/create.result'
--- tests/r/create.result	2010-02-25 23:52:42 +0000
+++ tests/r/create.result	2010-03-02 16:42:01 +0000
@@ -107,15 +107,15 @@
 create table t1(x varchar(50) );
 create table t2 select x from t1 where 1=2;
 describe t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 x	VARCHAR	TRUE		TRUE	
 describe t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 x	VARCHAR	TRUE		TRUE	
 drop table t2;
 create table t2 select now() as a , curdate() as c , 1+1 as d , 1.0 + 1 as e , 33333333333333333 + 3 as f;
 describe t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	DATETIME	TRUE		TRUE	
 c	DATE	FALSE		FALSE	
 d	INTEGER	FALSE		FALSE	
@@ -124,17 +124,17 @@
 drop table t2;
 create table t2 select CAST("2001-12-29" AS DATE) as d, CAST("2001-12-29  20:45:11" AS DATETIME) as dt;
 describe t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 d	DATE	TRUE		TRUE	
 dt	DATETIME	TRUE		TRUE	
 drop table t1,t2;
 create table t1 (a int);
 create table t2 (a int) select * from t1;
 describe t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	TRUE		TRUE	
 describe t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	TRUE		TRUE	
 drop table if exists t2;
 create table t2 (a int, a float) select * from t1;
@@ -418,7 +418,7 @@
 ifnull(h,cast('yet another binary data' as binary))   as h
 from t1;
 explain t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	TRUE		TRUE	
 b	BIGINT	FALSE		FALSE	
 c	BIGINT	FALSE		FALSE	
@@ -453,14 +453,14 @@
 create table t1(str varchar(10) default 'def',strnull varchar(10),intg int default '10',rel double default '3.14');
 insert into t1 values ('','',0,0.0);
 describe t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 str	VARCHAR	TRUE	def	FALSE	
 strnull	VARCHAR	TRUE	def	TRUE	
 intg	INTEGER	TRUE	10	FALSE	
 rel	DOUBLE	TRUE	3.14	FALSE	
 create table t2 select default(str) as str, default(strnull) as strnull, default(intg) as intg, default(rel) as rel from t1;
 describe t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 str	VARCHAR	TRUE		TRUE	
 strnull	VARCHAR	TRUE		TRUE	
 intg	INTEGER	TRUE		TRUE	
@@ -468,12 +468,12 @@
 drop table t1, t2;
 create table t1(name varchar(10), age int default -1);
 describe t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 name	VARCHAR	TRUE		TRUE	
 age	INTEGER	TRUE	-1	FALSE	
 create table t2(name varchar(10), age int default - 1);
 describe t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 name	VARCHAR	TRUE		TRUE	
 age	INTEGER	TRUE	-1	FALSE	
 drop table t1, t2;
@@ -522,7 +522,7 @@
 CREATE TABLE t1 (f1 VARCHAR(255));
 CREATE TABLE t2 AS SELECT LEFT(f1,171) AS f2 FROM t1 UNION SELECT LEFT(f1,171) AS f2 FROM t1;
 DESC t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f2	VARCHAR	TRUE		TRUE	
 DROP TABLE t1,t2;
 CREATE TABLE t12913 (f1 ENUM ('a','b')) AS SELECT 'a' AS f1;

=== modified file 'tests/r/data_dictionary_like_info.result'
--- tests/r/data_dictionary_like_info.result	2010-03-02 03:06:15 +0000
+++ tests/r/data_dictionary_like_info.result	2010-03-02 17:58:59 +0000
@@ -42,8 +42,8 @@
 a	INTEGER	TRUE		TRUE	
 select * from data_dictionary.COLUMNS where table_name="t1"
 and column_name= "a";
-TABLE_SCHEMA	TABLE_NAME	COLUMN_NAME	COLUMN_TYPE	ORDINAL_POSITION	COLUMN_DEFAULT	COLUMN_DEFAULT_IS_NULL	COLUMN_DEFAULT_UPDATE	IS_NULLABLE	DATA_TYPE	CHARACTER_MAXIMUM_LENGTH	CHARACTER_OCTET_LENGTH	NUMERIC_PRECISION	NUMERIC_SCALE	COLLATION_NAME	COLUMN_COMMENT
-mysqltest	t1	a	INTEGER	0		TRUE		TRUE	INTEGER	0	0	0	0		
+TABLE_SCHEMA	TABLE_NAME	COLUMN_NAME	COLUMN_TYPE	ORDINAL_POSITION	COLUMN_DEFAULT	COLUMN_DEFAULT_IS_NULL	COLUMN_DEFAULT_UPDATE	IS_NULLABLE	IS_INDEXED	IS_USED_IN_PRIMARY	IS_UNIQUE	IS_MULTI	IS_FIRST_IN_MULTI	INDEXES_FOUND_IN	DATA_TYPE	CHARACTER_MAXIMUM_LENGTH	CHARACTER_OCTET_LENGTH	NUMERIC_PRECISION	NUMERIC_SCALE	COLLATION_NAME	COLUMN_COMMENT
+mysqltest	t1	a	INTEGER	0		TRUE		TRUE	FALSE	FALSE	FALSE	FALSE	FALSE	0	INTEGER	0	0	0	0		
 select table_name, column_name from data_dictionary.columns 
 where table_schema = 'mysqltest' and table_name = 't1';
 table_name	column_name
@@ -174,7 +174,7 @@
 Field	Type	Null	Default	Default_is_NULL	On_Update
 f1	INTEGER	TRUE		TRUE	
 describe t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f1	INTEGER	TRUE		TRUE	
 show indexes from t1;
 Table	Unique	Key_name	Seq_in_index	Column_name
@@ -194,7 +194,7 @@
  or DATA_TYPE = 'varchar')
 group by DATA_TYPE order by DATA_TYPE, num;
 DATA_TYPE	group_concat(table_schema, '.', table_name)	num
-VARCHAR	data_dictionary.CHARACTER_SETS,data_dictionary.CHARACTER_SETS,data_dictionary.CHARACTER_SETS,data_dictionary.COLLATIONS,data_dictionary.COLLATIONS,data_dictionary.COLLATIONS,data_dictionary.COLLATIONS,data_dictionary.COLLATIONS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.GLOBAL_STATEMENTS,data_dictionary.GLOBAL_STATEMENTS,data_dictionary.GLOBAL_STATUS,data_dictionary.GLOBAL_STATUS,data_dictionary.GLOBAL_VARIABLES,data_dictionary.GLOBAL_VARIABLES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEX_PARTS,data_dictionary.INDEX_PARTS,data_dictionary.INDEX_PARTS,data_dictionary.INDEX_PARTS,data_dictionary.INDEX_PARTS,data_d	131
+VARCHAR	data_dictionary.CHARACTER_SETS,data_dictionary.CHARACTER_SETS,data_dictionary.CHARACTER_SETS,data_dictionary.COLLATIONS,data_dictionary.COLLATIONS,data_dictionary.COLLATIONS,data_dictionary.COLLATIONS,data_dictionary.COLLATIONS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.COLUMNS,data_dictionary.GLOBAL_STATEMENTS,data_dictionary.GLOBAL_STATEMENTS,data_dictionary.GLOBAL_STATUS,data_dictionary.GLOBAL_STATUS,data_dictionary.GLOBAL_VARIABLES,data_dictionary.GLOBAL_VARIABLES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEXES,data_dictionary.INDEX_PART	139
 Warnings:
 Warning	1260	1 line(s) were cut by GROUP_CONCAT()
 create table t1(f1 char(1) not null, f2 char(9) not null);
@@ -334,13 +334,13 @@
 WHERE TABLE_SCHEMA='mysql' and TABLE_NAME= 'db';
 TABLE_COLLATION
 select * from data_dictionary.columns where table_schema = NULL;
-TABLE_SCHEMA	TABLE_NAME	COLUMN_NAME	COLUMN_TYPE	ORDINAL_POSITION	COLUMN_DEFAULT	COLUMN_DEFAULT_IS_NULL	COLUMN_DEFAULT_UPDATE	IS_NULLABLE	DATA_TYPE	CHARACTER_MAXIMUM_LENGTH	CHARACTER_OCTET_LENGTH	NUMERIC_PRECISION	NUMERIC_SCALE	COLLATION_NAME	COLUMN_COMMENT
+TABLE_SCHEMA	TABLE_NAME	COLUMN_NAME	COLUMN_TYPE	ORDINAL_POSITION	COLUMN_DEFAULT	COLUMN_DEFAULT_IS_NULL	COLUMN_DEFAULT_UPDATE	IS_NULLABLE	IS_INDEXED	IS_USED_IN_PRIMARY	IS_UNIQUE	IS_MULTI	IS_FIRST_IN_MULTI	INDEXES_FOUND_IN	DATA_TYPE	CHARACTER_MAXIMUM_LENGTH	CHARACTER_OCTET_LENGTH	NUMERIC_PRECISION	NUMERIC_SCALE	COLLATION_NAME	COLUMN_COMMENT
 select * from `data_dictionary`.`COLUMNS` where `TABLE_NAME` = NULL;
-TABLE_SCHEMA	TABLE_NAME	COLUMN_NAME	COLUMN_TYPE	ORDINAL_POSITION	COLUMN_DEFAULT	COLUMN_DEFAULT_IS_NULL	COLUMN_DEFAULT_UPDATE	IS_NULLABLE	DATA_TYPE	CHARACTER_MAXIMUM_LENGTH	CHARACTER_OCTET_LENGTH	NUMERIC_PRECISION	NUMERIC_SCALE	COLLATION_NAME	COLUMN_COMMENT
+TABLE_SCHEMA	TABLE_NAME	COLUMN_NAME	COLUMN_TYPE	ORDINAL_POSITION	COLUMN_DEFAULT	COLUMN_DEFAULT_IS_NULL	COLUMN_DEFAULT_UPDATE	IS_NULLABLE	IS_INDEXED	IS_USED_IN_PRIMARY	IS_UNIQUE	IS_MULTI	IS_FIRST_IN_MULTI	INDEXES_FOUND_IN	DATA_TYPE	CHARACTER_MAXIMUM_LENGTH	CHARACTER_OCTET_LENGTH	NUMERIC_PRECISION	NUMERIC_SCALE	COLLATION_NAME	COLUMN_COMMENT
 select * from `data_dictionary`.`INDEXES` where `TABLE_SCHEMA` = NULL;
-TABLE_SCHEMA	TABLE_NAME	INDEX_NAME	IS_PRIMARY	IS_UNIQUE	IS_NULLABLE	KEY_LENGTH	INDEX_TYPE	INDEX_COMMENT
+TABLE_SCHEMA	TABLE_NAME	INDEX_NAME	IS_USED_IN_PRIMARY	IS_UNIQUE	IS_NULLABLE	KEY_LENGTH	INDEX_TYPE	INDEX_COMMENT
 select * from `data_dictionary`.`INDEXES` where `TABLE_NAME` = NULL;
-TABLE_SCHEMA	TABLE_NAME	INDEX_NAME	IS_PRIMARY	IS_UNIQUE	IS_NULLABLE	KEY_LENGTH	INDEX_TYPE	INDEX_COMMENT
+TABLE_SCHEMA	TABLE_NAME	INDEX_NAME	IS_USED_IN_PRIMARY	IS_UNIQUE	IS_NULLABLE	KEY_LENGTH	INDEX_TYPE	INDEX_COMMENT
 select * from data_dictionary.schemas where schema_name = NULL;
 SCHEMA_NAME	DEFAULT_COLLATION_NAME
 select * from data_dictionary.tables where table_schema = NULL;

=== modified file 'tests/r/drop.result'
--- tests/r/drop.result	2010-02-26 19:08:27 +0000
+++ tests/r/drop.result	2010-03-03 04:58:12 +0000
@@ -81,8 +81,6 @@
 create table mysql_test.`#sql-347f_8` (f1 int);
 drop table mysql_test.`#sql-347f_8`;
 drop database mysql_test;
-Warnings:
-Note	1051	Unknown table '#sql-347f_7'
 create database mysqltestbug26703;
 use mysqltestbug26703;
 create table `#mysql50#abc``def` ( id int );

=== modified file 'tests/r/func_sapdb.result'
--- tests/r/func_sapdb.result	2010-02-19 19:04:24 +0000
+++ tests/r/func_sapdb.result	2010-03-02 16:42:01 +0000
@@ -109,7 +109,7 @@
 select makedate(1997,1) as f1,
 date("1997-12-31 23:59:59.000001") as f8;
 describe t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f1	DATE	TRUE		TRUE	
 f8	DATE	TRUE		TRUE	
 select * from t1;

=== modified file 'tests/r/func_time.result'
--- tests/r/func_time.result	2010-02-19 19:04:24 +0000
+++ tests/r/func_time.result	2010-03-02 16:42:01 +0000
@@ -634,7 +634,7 @@
 create table t1 select last_day('2000-02-05') as a,
 from_days(to_days("960101")) as b;
 describe t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	DATE	FALSE		FALSE	
 b	DATE	TRUE		TRUE	
 select * from t1;

=== modified file 'tests/r/information_schema.result'
Binary files tests/r/information_schema.result and tests/r/information_schema.result differ
=== modified file 'tests/r/information_schema_inno.result'
Binary files tests/r/information_schema_inno.result and tests/r/information_schema_inno.result differ
=== modified file 'tests/r/innodb.result'
--- tests/r/innodb.result	2010-03-01 22:24:10 +0000
+++ tests/r/innodb.result	2010-03-02 21:16:40 +0000
@@ -883,7 +883,7 @@
 drop table t1;
 create table t1 (t int not null default 1, key (t)) engine=innodb;
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 t	INTEGER	FALSE	1	FALSE	
 drop table t1;
 create table t1 (id int not null auto_increment, code int not null, name char(20) not null, primary key (id), key (code), unique (name)) engine=innodb;
@@ -1130,24 +1130,24 @@
 checksum table t1, t2, t3, t4;
 Table	Checksum
 test.t1	2948697075
-test.t2	2948697075
-test.t3	2948697075
-test.t4	NULL
-Warnings:
-Error	1146	Table 'test.t4' doesn't exist
-checksum table t1, t2, t3, t4;
-Table	Checksum
-test.t1	2948697075
-test.t2	2948697075
-test.t3	2948697075
-test.t4	NULL
-Warnings:
-Error	1146	Table 'test.t4' doesn't exist
-checksum table t1, t2, t3, t4;
-Table	Checksum
-test.t1	2948697075
-test.t2	2948697075
-test.t3	2948697075
+test.t2	3505595080
+test.t3	3505595080
+test.t4	NULL
+Warnings:
+Error	1146	Table 'test.t4' doesn't exist
+checksum table t1, t2, t3, t4;
+Table	Checksum
+test.t1	2948697075
+test.t2	3505595080
+test.t3	3505595080
+test.t4	NULL
+Warnings:
+Error	1146	Table 'test.t4' doesn't exist
+checksum table t1, t2, t3, t4;
+Table	Checksum
+test.t1	2948697075
+test.t2	3505595080
+test.t3	3505595080
 test.t4	NULL
 Warnings:
 Error	1146	Table 'test.t4' doesn't exist

=== modified file 'tests/r/innodb_mysql.result'
--- tests/r/innodb_mysql.result	2010-02-19 19:04:24 +0000
+++ tests/r/innodb_mysql.result	2010-03-02 16:42:01 +0000
@@ -1153,7 +1153,7 @@
 create table t1(a char(10) not null, unique key aa(a(1)),
 b char(4) not null, unique key bb(b(4))) engine=innodb;
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	VARCHAR	FALSE		FALSE	
 b	VARCHAR	FALSE		FALSE	
 show create table t1;

=== modified file 'tests/r/key.result'
--- tests/r/key.result	2010-03-01 22:24:10 +0000
+++ tests/r/key.result	2010-03-02 16:42:01 +0000
@@ -301,7 +301,7 @@
 UNIQUE i1idx (i1),
 UNIQUE i2idx (i2));
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 i1	INTEGER	FALSE		FALSE	
 i2	INTEGER	FALSE		FALSE	
 show create table t1;
@@ -357,25 +357,25 @@
 drop table t1;
 create table t1 (a int not null primary key, b varchar(20) not null unique);
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	FALSE		FALSE	
 b	VARCHAR	FALSE		FALSE	
 drop table t1;
 create table t1 (a int not null primary key, b int not null unique);
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	FALSE		FALSE	
 b	INTEGER	FALSE		FALSE	
 drop table t1;
 create table t1 (a int not null primary key, b varchar(20) not null, unique (b(10)));
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	FALSE		FALSE	
 b	VARCHAR	FALSE		FALSE	
 drop table t1;
 create table t1 (a int not null primary key, b varchar(20) not null, c varchar(20) not null, unique(b(10),c(10)));
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	FALSE		FALSE	
 b	VARCHAR	FALSE		FALSE	
 c	VARCHAR	FALSE		FALSE	
@@ -493,7 +493,7 @@
 b char(10) not null, unique key bb(b(1)), 
 c char(4) not null, unique key cc(c));
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	FALSE		FALSE	
 b	VARCHAR	FALSE		FALSE	
 c	VARCHAR	FALSE		FALSE	
@@ -512,13 +512,13 @@
 b char(10) not null, unique key bb(b(1)),
 c char(4) not null);
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	FALSE		FALSE	
 b	VARCHAR	FALSE		FALSE	
 c	VARCHAR	FALSE		FALSE	
 alter table t1 add unique key cc(c);
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	FALSE		FALSE	
 b	VARCHAR	FALSE		FALSE	
 c	VARCHAR	FALSE		FALSE	

=== modified file 'tests/r/mix2_myisam.result'
--- tests/r/mix2_myisam.result	2010-02-19 19:04:24 +0000
+++ tests/r/mix2_myisam.result	2010-02-27 23:47:33 +0000
@@ -898,30 +898,30 @@
 Table	Checksum
 test.t1	2948697075
 test.t2	2948697075
-test.t3	2948697075
-test.t4	2948697075
-test.t5	2948697075
-test.t6	2948697075
-test.t7	NULL
-Warnings:
-Error	1146	Table 'test.t7' doesn't exist
-checksum table t1, t2, t3, t4, t5, t6, t7;
-Table	Checksum
-test.t1	2948697075
-test.t2	2948697075
-test.t3	2948697075
-test.t4	2948697075
-test.t5	2948697075
-test.t6	2948697075
-test.t7	NULL
-Warnings:
-Error	1146	Table 'test.t7' doesn't exist
-checksum table t1, t2, t3, t4, t5, t6, t7;
-Table	Checksum
-test.t1	2948697075
-test.t2	2948697075
-test.t3	2948697075
-test.t4	2948697075
+test.t3	3505595080
+test.t4	3505595080
+test.t5	2948697075
+test.t6	2948697075
+test.t7	NULL
+Warnings:
+Error	1146	Table 'test.t7' doesn't exist
+checksum table t1, t2, t3, t4, t5, t6, t7;
+Table	Checksum
+test.t1	2948697075
+test.t2	2948697075
+test.t3	3505595080
+test.t4	3505595080
+test.t5	2948697075
+test.t6	2948697075
+test.t7	NULL
+Warnings:
+Error	1146	Table 'test.t7' doesn't exist
+checksum table t1, t2, t3, t4, t5, t6, t7;
+Table	Checksum
+test.t1	2948697075
+test.t2	2948697075
+test.t3	3505595080
+test.t4	3505595080
 test.t5	2948697075
 test.t6	2948697075
 test.t7	NULL

=== modified file 'tests/r/myisam.result'
--- tests/r/myisam.result	2010-03-01 22:24:10 +0000
+++ tests/r/myisam.result	2010-03-02 21:16:40 +0000
@@ -490,22 +490,22 @@
 insert t2 select * from t1;
 checksum table t1, t2, t3;
 Table	Checksum
-test.t1	2948697075
-test.t2	2948697075
-test.t3	NULL
-Warnings:
-Error	1146	Table 'test.t3' doesn't exist
-checksum table t1, t2, t3;
-Table	Checksum
-test.t1	2948697075
-test.t2	2948697075
-test.t3	NULL
-Warnings:
-Error	1146	Table 'test.t3' doesn't exist
-checksum table t1, t2, t3;
-Table	Checksum
-test.t1	2948697075
-test.t2	2948697075
+test.t1	3505595080
+test.t2	3505595080
+test.t3	NULL
+Warnings:
+Error	1146	Table 'test.t3' doesn't exist
+checksum table t1, t2, t3;
+Table	Checksum
+test.t1	3505595080
+test.t2	3505595080
+test.t3	NULL
+Warnings:
+Error	1146	Table 'test.t3' doesn't exist
+checksum table t1, t2, t3;
+Table	Checksum
+test.t1	3505595080
+test.t2	3505595080
 test.t3	NULL
 Warnings:
 Error	1146	Table 'test.t3' doesn't exist

=== modified file 'tests/r/mysql.result'
--- tests/r/mysql.result	2010-02-19 19:04:24 +0000
+++ tests/r/mysql.result	2010-03-02 16:42:01 +0000
@@ -39,7 +39,7 @@
 +------+------+---------------------------+
 i	j	k
 NULL	1	NULL
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 i	INTEGER	TRUE		TRUE	
 j	INTEGER	FALSE		FALSE	
 k	INTEGER	TRUE		TRUE	
@@ -49,7 +49,7 @@
 | NULL | 1 | NULL | 
 +------+---+------+
 +-------+---------+-------+---------+-----------------+-----------+
-| Field | Type    | Null  | Default | Default is NULL | On Update |
+| Field | Type    | Null  | Default | Default_is_NULL | On_Update |
 +-------+---------+-------+---------+-----------------+-----------+
 | i     | INTEGER | TRUE  |         | TRUE            |           | 
 | j     | INTEGER | FALSE |         | FALSE           |           | 
@@ -74,11 +74,11 @@
 | NULL        | 
 +-------------+
 create table t1(a int, b varchar(255), c int);
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	TRUE		TRUE	
 b	VARCHAR	TRUE		TRUE	
 c	INTEGER	TRUE		TRUE	
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	TRUE		TRUE	
 b	VARCHAR	TRUE		TRUE	
 c	INTEGER	TRUE		TRUE	

=== modified file 'tests/r/null.result'
--- tests/r/null.result	2010-02-19 19:04:24 +0000
+++ tests/r/null.result	2010-03-02 16:42:01 +0000
@@ -240,17 +240,17 @@
 INSERT INTO t1 (a, b) VALUES (0, 0);
 CREATE TABLE t2 SELECT IFNULL(a, b) FROM t1;
 DESCRIBE t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 IFNULL(a, b)	DECIMAL	TRUE		TRUE	
 DROP TABLE t2;
 CREATE TABLE t2 SELECT IFNULL(a, NULL) FROM t1;
 DESCRIBE t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 IFNULL(a, NULL)	DECIMAL	TRUE		TRUE	
 DROP TABLE t2;
 CREATE TABLE t2 SELECT IFNULL(NULL, b) FROM t1;
 DESCRIBE t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 IFNULL(NULL, b)	DECIMAL	TRUE		TRUE	
 DROP TABLE t1, t2;
 # End of 5.0 tests

=== modified file 'tests/r/parser.result'
--- tests/r/parser.result	2010-02-19 19:04:24 +0000
+++ tests/r/parser.result	2010-03-02 16:42:01 +0000
@@ -241,7 +241,7 @@
 CREATE TABLE table_25930_a ( blah INT );
 CREATE TABLE table_25930_b SELECT "blah" - 1 FROM table_25930_a;
 desc table_25930_b;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 "blah" - 1	DOUBLE	FALSE		FALSE	
 DROP TABLE table_25930_a;
 DROP TABLE table_25930_b;

=== added file 'tests/r/randgen_queries.result'
--- tests/r/randgen_queries.result	1970-01-01 00:00:00 +0000
+++ tests/r/randgen_queries.result	2010-03-02 17:58:59 +0000
@@ -0,0 +1,110 @@
+drop table if exists t1;
+show variables like 'version';
+Variable_name	Value
+version	####.##.####
+select version();
+version()
+####.##.####
+select database();
+database()
+test
+CREATE TABLE `t1` (
+`col_bigint` bigint,
+`col_text` text,
+`col_char` char (1),
+`col_enum` enum ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'),
+`col_int` int,
+`col_char_not_null` char (1) not null,
+`col_int_not_null_key` int not null,
+`col_text_not_null` text not null,
+`col_enum_not_null_key` enum ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z') not null,
+`col_int_key` int,
+`col_char_key` char (1),
+`col_enum_not_null` enum ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z') not null,
+`col_text_not_null_key` text not null,
+pk integer auto_increment,
+`col_bigint_key` bigint,
+`col_int_not_null` int not null,
+`col_bigint_not_null` bigint not null,
+`col_bigint_not_null_key` bigint not null,
+`col_char_not_null_key` char (1) not null,
+`col_text_key` text,
+`col_enum_key` enum ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'),
+/*Indices*/
+key (`col_int_not_null_key` ),
+key (`col_enum_not_null_key` ),
+key (`col_int_key` ),
+key (`col_char_key` ),
+key (`col_text_not_null_key`  (255)),
+primary key (pk),
+key (`col_bigint_key` ),
+key (`col_bigint_not_null_key` ),
+key (`col_char_not_null_key` ),
+key (`col_text_key`  (255)),
+key (`col_enum_key` )) ENGINE=innodb;
+Warnings:
+Warning	1071	Specified key was too long; max key length is 767 bytes
+Warning	1071	Specified key was too long; max key length is 767 bytes
+set AUTOCOMMIT=OFF;
+select table_schema, 
+table_name, 
+'STANDARD',
+#       CASE WHEN table_type = 'STANDARD' THEN 'table' 
+#            WHEN table_type = 'VIEW' THEN 'view' 
+#            WHEN table_type = 'FUNCTION' then 'view' 
+#       ELSE 'misc' END, 
+column_name,
+CASE WHEN IS_USED_IN_PRIMARY = 'TRUE' THEN 'primary' 
+#      WHEN column_key = 'MUL' THEN 'indexed' 
+#      WHEN column_key = 'UNI' THEN 'indexed' 
+ELSE 'indexed' END 
+FROM data_dictionary.index_parts;
+table_schema	table_name	STANDARD	column_name	CASE WHEN IS_USED_IN_PRIMARY = 'TRUE' THEN 'primary' 
+#      WHEN column_key = 'MUL' THEN 'indexed' 
+#      WHEN column_key = 'UNI' THEN 'indexed' 
+ELSE 'indexed' END 
+
+test	t1	STANDARD	pk	primary
+test	t1	STANDARD	col_int_not_null_key	indexed
+test	t1	STANDARD	col_enum_not_null_key	indexed
+test	t1	STANDARD	col_int_key	indexed
+test	t1	STANDARD	col_char_key	indexed
+test	t1	STANDARD	col_text_not_null_key	indexed
+test	t1	STANDARD	col_bigint_key	indexed
+test	t1	STANDARD	col_bigint_not_null_key	indexed
+test	t1	STANDARD	col_char_not_null_key	indexed
+test	t1	STANDARD	col_text_key	indexed
+test	t1	STANDARD	col_enum_key	indexed
+select AVG(`col_int_key`) + AVG(`col_int`) AS average1,
+(SUM(`col_int_key`) + SUM(`col_int`)) / COUNT(*) AS average2,
+COUNT(*) AS count FROM t1;
+average1	average2	count
+NULL	NULL	0
+select collation_name,character_set_name FROM data_dictionary.collations;
+collation_name	character_set_name
+utf8_general_ci	utf8_general_ci
+utf8_bin	utf8_general_ci
+utf8_unicode_ci	utf8_general_ci
+utf8_icelandic_ci	utf8_general_ci
+utf8_latvian_ci	utf8_general_ci
+utf8_romanian_ci	utf8_general_ci
+utf8_slovenian_ci	utf8_general_ci
+utf8_polish_ci	utf8_general_ci
+utf8_estonian_ci	utf8_general_ci
+utf8_spanish_ci	utf8_general_ci
+utf8_swedish_ci	utf8_general_ci
+utf8_turkish_ci	utf8_general_ci
+utf8_czech_ci	utf8_general_ci
+utf8_danish_ci	utf8_general_ci
+utf8_lithuanian_ci	utf8_general_ci
+utf8_slovak_ci	utf8_general_ci
+utf8_spanish2_ci	utf8_general_ci
+utf8_roman_ci	utf8_general_ci
+utf8_persian_ci	utf8_general_ci
+utf8_esperanto_ci	utf8_general_ci
+utf8_hungarian_ci	utf8_general_ci
+utf8_sinhala_ci	utf8_general_ci
+binary	binary
+select COUNT(*) from data_dictionary.tables;
+COUNT(*)
+32

=== modified file 'tests/r/type_datetime.result'
--- tests/r/type_datetime.result	2010-02-19 19:04:24 +0000
+++ tests/r/type_datetime.result	2010-03-02 16:42:01 +0000
@@ -341,57 +341,57 @@
 create table t1 (f1 date, f2 datetime, f3 varchar(20));
 create table t2 as select coalesce(f1,f1) as f4 from t1;
 desc t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	DATE	TRUE		TRUE	
 create table t3 as select coalesce(f1,f2) as f4 from t1;
 desc t3;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	DATETIME	TRUE		TRUE	
 create table t4 as select coalesce(f2,f2) as f4 from t1;
 desc t4;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	DATETIME	TRUE		TRUE	
 create table t5 as select coalesce(f1,f3) as f4 from t1;
 desc t5;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	VARCHAR	TRUE		TRUE	
 create table t6 as select coalesce(f2,f3) as f4 from t1;
 desc t6;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	VARCHAR	TRUE		TRUE	
 create table t7 as select coalesce(makedate(1997,1),f2) as f4 from t1;
 desc t7;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	DATETIME	TRUE		TRUE	
 create table t8 as select coalesce(cast('01-01-01' as datetime),f2) as f4
 from t1;
 desc t8;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	DATETIME	TRUE		TRUE	
 create table t9 as select case when 1 then cast('01-01-01' as date)
 when 0 then cast('01-01-01' as date) end as f4 from t1;
 desc t9;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	DATE	TRUE		TRUE	
 create table t10 as select case when 1 then cast('01-01-01' as datetime)
 when 0 then cast('01-01-01' as datetime) end as f4 from t1;
 desc t10;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	DATETIME	TRUE		TRUE	
 create table t11 as select if(1, cast('01-01-01' as datetime),
 cast('01-01-01' as date)) as f4 from t1;
 desc t11;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	DATE	TRUE		TRUE	
 create table t12 as select least(cast('01-01-01' as datetime),
 cast('01-01-01' as date)) as f4 from t1;
 desc t12;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	DATE	TRUE		TRUE	
 create table t13 as select ifnull(cast('01-01-01' as datetime),
 cast('01-01-01' as date)) as f4 from t1;
 desc t13;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 f4	DATE	TRUE		TRUE	
 drop tables t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13;
 ###################################################################

=== modified file 'tests/r/type_float.result'
--- tests/r/type_float.result	2010-03-02 01:04:20 +0000
+++ tests/r/type_float.result	2010-03-02 16:42:01 +0000
@@ -208,22 +208,22 @@
 show warnings;
 Level	Code	Message
 desc  t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 x	DECIMAL	FALSE		FALSE	
 drop table t1;
 create table t1 select 0.0 x;
 desc t1;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 x	DECIMAL	FALSE		FALSE	
 create table t2 select 105213674794682365.00 y;
 desc t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 y	DECIMAL	FALSE		FALSE	
 create table t3 select x+y a from t1,t2;
 show warnings;
 Level	Code	Message
 desc t3;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	DECIMAL	FALSE		FALSE	
 drop table t1,t2,t3;
 select 1e-308, 1.00000001e-300, 100000000e-300;

=== modified file 'tests/r/union.result'
--- tests/r/union.result	2010-03-02 01:04:20 +0000
+++ tests/r/union.result	2010-03-02 16:42:01 +0000
@@ -1438,24 +1438,24 @@
 INSERT INTO t1 VALUES (1), (2), (3);
 CREATE TABLE t2 SELECT * FROM (SELECT NULL) a UNION SELECT a FROM t1;
 DESC t2;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 NULL	INTEGER	TRUE		TRUE	
 CREATE TABLE t3 SELECT a FROM t1 UNION SELECT * FROM (SELECT NULL) a;
 DESC t3;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 a	INTEGER	TRUE		TRUE	
 CREATE TABLE t4 SELECT NULL;
 DESC t4;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 NULL	VARCHAR	TRUE		TRUE	
 CREATE TABLE t5 SELECT NULL UNION SELECT NULL;
 DESC t5;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 NULL	VARCHAR	TRUE		TRUE	
 CREATE TABLE t6 
 SELECT * FROM (SELECT * FROM (SELECT NULL)a) b UNION SELECT a FROM t1;
 DESC t6;
-Field	Type	Null	Default	Default is NULL	On Update
+Field	Type	Null	Default	Default_is_NULL	On_Update
 NULL	INTEGER	TRUE		TRUE	
 DROP TABLE t1, t2, t3, t4, t5, t6;
 End of 5.0 tests

=== modified file 'tests/t/drop.test'
--- tests/t/drop.test	2010-02-04 08:14:46 +0000
+++ tests/t/drop.test	2010-03-03 04:58:12 +0000
@@ -92,10 +92,6 @@
 create table mysql_test.`#sql-347f_7` (f1 int);
 create table mysql_test.`#sql-347f_8` (f1 int);
 drop table mysql_test.`#sql-347f_8`;
-## TODO: Uncommenting this causes drop database to fail, but I don't know that
-#  I care to fix it, since it's testing .frm implementation which is being 
-#  replaced.
-#copy_file $MYSQLTEST_VARDIR/master-data/mysql_test/t1.frm $MYSQLTEST_VARDIR/master-data/mysql_test/#sql-347f_6.frm;
 drop database mysql_test;
 
 #

=== added file 'tests/t/randgen_queries.test'
--- tests/t/randgen_queries.test	1970-01-01 00:00:00 +0000
+++ tests/t/randgen_queries.test	2010-03-02 17:58:59 +0000
@@ -0,0 +1,69 @@
+--disable_warnings
+drop table if exists t1;
+--enable_warnings
+
+# execute all the queries that randgen uses to setup and run its tests
+--replace_column 2 ####.##.####
+show variables like 'version';
+--replace_column 1 ####.##.####
+select version();
+select database();
+
+CREATE TABLE `t1` (
+`col_bigint` bigint,
+`col_text` text,
+`col_char` char (1),
+`col_enum` enum ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'),
+`col_int` int,
+`col_char_not_null` char (1) not null,
+`col_int_not_null_key` int not null,
+`col_text_not_null` text not null,
+`col_enum_not_null_key` enum ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z') not null,
+`col_int_key` int,
+`col_char_key` char (1),
+`col_enum_not_null` enum ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z') not null,
+`col_text_not_null_key` text not null,
+pk integer auto_increment,
+`col_bigint_key` bigint,
+`col_int_not_null` int not null,
+`col_bigint_not_null` bigint not null,
+`col_bigint_not_null_key` bigint not null,
+`col_char_not_null_key` char (1) not null,
+`col_text_key` text,
+`col_enum_key` enum ('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'),
+/*Indices*/
+key (`col_int_not_null_key` ),
+key (`col_enum_not_null_key` ),
+key (`col_int_key` ),
+key (`col_char_key` ),
+key (`col_text_not_null_key`  (255)),
+primary key (pk),
+key (`col_bigint_key` ),
+key (`col_bigint_not_null_key` ),
+key (`col_char_not_null_key` ),
+key (`col_text_key`  (255)),
+key (`col_enum_key` )) ENGINE=innodb;
+set AUTOCOMMIT=OFF;
+
+# Obviously, FUNCTION does not always means VIEW.
+#
+select table_schema, 
+       table_name, 
+       'STANDARD',
+#       CASE WHEN table_type = 'STANDARD' THEN 'table' 
+#            WHEN table_type = 'VIEW' THEN 'view' 
+#            WHEN table_type = 'FUNCTION' then 'view' 
+#       ELSE 'misc' END, 
+       column_name,
+       CASE WHEN IS_USED_IN_PRIMARY = 'TRUE' THEN 'primary' 
+      #      WHEN column_key = 'MUL' THEN 'indexed' 
+      #      WHEN column_key = 'UNI' THEN 'indexed' 
+       ELSE 'indexed' END 
+FROM data_dictionary.index_parts;
+
+select AVG(`col_int_key`) + AVG(`col_int`) AS average1,
+                        (SUM(`col_int_key`) + SUM(`col_int`)) / COUNT(*) AS average2,
+                        COUNT(*) AS count FROM t1;
+
+select collation_name,character_set_name FROM data_dictionary.collations;
+select COUNT(*) from data_dictionary.tables;

